 2024- 5- 1 Jelle van der Waa <jvanderwaa@redhat.com>
    
    examples: replace logging.warn with logging.warning
    logging.warn is an alias to logging.warning since Python 3.3 and will be
    removed in Python 3.13.
    
    
    
 2024- 4- 30 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: stop using a venv when creating source/binary dist
    The change to use 'python -m build' in
    
    commit 333c8bef2bcca5ca7dbcdb5861a385d626e0feb9
    Author: Erik Skultety <eskultet@redhat.com>
    Date:   Tue Jun 20 12:19:40 2023 +0200
    
    ci: Drop direct 'setup.py' usage
    
    resulted in the CI jobs all downloading latest setuptools and
    deps from pypi and running builds with them in a venv. IOW we
    ceased testing against the setuptools/wheel packages provided
    by the distro, which is the whole point of the CI.
    
    Passing the '-n -x' flags to 'python -m build' tells it to stop
    using a venv and not to check dependancies, thus letting it
    use what we pre-installed in the container.
    
    This doesn't work on CentOS Stream 8, however, so we revert to
    using the old setup.py approach. This is a short term issue,
    since Stream 8 is EOL at the end of May, so we'll be deleting
    all the Stream 8 jobs across libvirt CI very soon.
    
    
    
 2024- 4- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh with lcitool manifest
    This pulls in the new wheel packages.
    
    
    
 2024- 4- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: add 'python3-wheel' as a dep
    The 'python -m build' command creates a source dist and a binary
    wheel. To be able run this command without creating a new venv
    and downloading from pypi, we need to pre-install the 'wheel'
    package.
    
    
    
 2024- 4- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh with latest lcitool manifest
    Fixes logic that caused some jobs to mistakenly not be run
    when expected.
    
    
    
 2024- 4- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 10.3.0
    
    
 2024- 3- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 10.2.0
    
    
 2024- 2- 27 Michal Privoznik <mprivozn@redhat.com>
    
    ci: Switch native_git_build_job to c9s and resume api_coverage_job
    Currently, there's just one native_git_build_job -
    x86_64-centos-stream-8-git and this is a problem because that's
    the job that api_coverage_job then uses. But CentOS Stream 8 has
    too old lxml which then makes tests/test_api_coverage.py skip its
    run. By switching to CentOS Stream 9 the test can run happily
    again.
    
    
    
 2024- 2- 27 Michal Privoznik <mprivozn@redhat.com>
    
    test_api_coverage: Reflect different naming in python for virDomainFDAssociate() and virDomainRestoreParams()
    While virDomainRestoreParams() has 'virDomain' prefix (and thus
    is put into Domain class), it is really in the same family as
    virDomainRestore() or virDomainRestoreFlags() -> it acts upon
    virConnect object and thus belongs into Connect class.
    
    Then, virDomainFDAssociate is exposed as Domain.FDAssociate() but
    because of the way we would generate the method's name
    (fDAssociate) the test thinks it's not implemented.
    
    
    
 2024- 2- 20 Vincent Vanlaer <libvirt-e6954efa@volkihar.be>
    
    Fix memory leak in virStreamRecvFlags
    virStreamRecvFlags allocates a temporary buffer to store the received
    stream data in. This buffer was not freed on returns other than the
    normal return with data.
    
    
    
 2024- 1- 19 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh with latest 'lcitool manifest'
    This refresh gets rid of the split jobs for prebuilt and local
    container environments.
    
    
    
 2024- 1- 15 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 10.1.0
    
    
 2024- 1- 8 Peter Krempa <pkrempa@redhat.com>
    
    ci: Install built module for testing insde an venv
    Distros recently started to object to using 'pip' to install system-wide
    packages to prevent breakage. We were hacking-around that by using
    'pip install --break-system-packages', but it's straightforward to
    simply create a venv with '--system-site-packages' and install it there.
    
    
    
 2024- 1- 8 Peter Krempa <pkrempa@redhat.com>
    
    ci: Update Fedora and Debian versions and regenerate
    Update:
    Debian-10 -> Debian-12
    Fedora-37 -> Fedora-38
    Fedora-38 -> Fedora-39
    
    Also the artifacts from the Fedora 39 job are needed for the integration
    test suite in the main libvirt project.
    
    For Debian 12 we need to start using
    'pip install --break-system-packages' as a hack to work around
    installation of the built package for testing.
    
    
    
 2023- 12- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 10.0.0
    
    
 2023- 11- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.10.0
    
    
 2023- 10- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.9.0
    
    
 2023- 9- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    Request the Python stable API when building
    We have Python 3.6 as a minimum version. If we set Py_LIMITED_API
    to 0x03060000, we'll get the stable python API associated with
    versions >= 3.6. This lets users compile once and have the libvirt
    binary module be loadable by any Python version >= 3.6, as described
    in:
    
    https://docs.python.org/3/c-api/stable.html
    
    
    
 2023- 9- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    Use PySequence_GetItem preferentially
    Although marginally faster, PySequence_ITEM is not part
    of the stable API and also omits some safety checks. It
    is better for us to be using PySequence_GetItem instead.
    
    
    
 2023- 9- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    add missing includes for C library functions
    We use various C library functions like printf, strcmp, free
    but don't have the corresponding #includes, getting them
    indirectly via Python.h. This is a bad idea as Python.h is
    not guaranteed to provided these, and indeed will omit them
    when Py_LIMITED_API is greater then 0x030a0000.
    
    
    
 2023- 9- 25 Pino Toscano <ptoscano@redhat.com>
    
    setup: simplify authors list generation
    Use a set to collect the authors from the git output with no duplicates,
    then sort the resulting set, and apply the wanted indentation.
    
    This method is more Pythonic, using a set to avoid duplicates; applying
    the indentation after the sorting makes the sorting slightly faster.
    
    
    
 2023- 9- 25 Pino Toscano <ptoscano@redhat.com>
    
    setup: switch away fron subprocess.Popen()
    Adopt subprocess.check_output() as more modern and higher-level way to
    invoke processes, checking that they succeed, and getting their output.
    
    
    
 2023- 9- 25 Pino Toscano <ptoscano@redhat.com>
    
    setup: remove unnecessary f-string
    The whole content of this f-string is a variable, so use that variable
    directly.
    
    
    
 2023- 9- 25 Pino Toscano <ptoscano@redhat.com>
    
    setup: invoke git commands properly
    Storing the git commands as single string, to split it by space later
    on, works only in case there are no spaces in the arguments, which is
    exactly what is in those commands.
    
    Instead, specify them directly as lists, with the options & arguments
    split in the right way. This fixes the generation of the AUTHORS and
    ChangeLog files.
    
    
    
 2023- 9- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: unset CFLAGS for rpm build
    Setting CFLAGS before invoking rpm-build causes replacement of the
    CFLAGS that RPM wants to set for python. This causes the loss of
    certain flags needed to turn on debug output and optimization.
    Previously this wasn't a problem as something in setuptools appears
    to have been adding -g anyway, but with the update to python 3.12
    this now fully breaks. We should never have been setting CFLAGS
    during the RPM build so we drop it unconditionally for all distros.
    
    
    
 2023- 9- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    Add binding for network metadata events
    
    
 2023- 9- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.8.0
    
    
 2023- 8- 21 Erik Skultety <eskultet@redhat.com>
    
    ci: lcitool: Maintain project package deps lists here
    Each respective project that lcitool knows about and currently
    maintains its list of package dependencies knows best what packages
    they actually depend on. If a new dependency is currently needed,
    first a change in lcitool is necessary before GitLab jobs and
    containers can be updated. Provided a mapping already exists in
    lcitool (which can quickly be added as an override via mappings.yml
    temporarily) we speed up the whole CI update process by
    one step.
    
    Note that starting this commit lcitool must be invoked as
    '$ lcitool -d/--data-dir ci/lcitool ...'
    to pick up the project dependency list correctly.
    
    
    
 2023- 8- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.7.0
    
    
 2023- 7- 3 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.6.0
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    README: Drop direct 'setup.py' usage
    With all the bits in place we can now replace the direct 'setup.py'
    invocation examples with alternatives.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    ci: Drop direct 'setup.py' usage
    With all the bits in place we can now drop the 'setup.py' invocations
    with preferred alternatives.
    This patch does a few things:
    - we don't run plain install because that always spins up a new build
    process regardless of whether there are build artifacts literally from
    the previous command, so instead we install the built wheel directly
    
    - when building, we build both the .whl binary and an sdist because
    we'll need the sdist for rpmbuild later in the CI job
    
    - we don't capture the 'build' path as a job artifact anymore, because
    that now only contains egg metadata, all the build artifacts are
    created by Python's build module under 'dist' so we capture that one
    instead
    
    - we always limit pytest to the 'tests' directory which was something
    'setup.py test' used to do as a precaution measure, but setup.py no
    longer has the logic (which is fine)
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    spec: Invoke pytest properly
    With all the bits in place we can now drop the 'setup.py' invocations
    with preferred alternatives. The way to do this in a SPEC file is to
    use either of the following macros: %tox or %pytest - both of which
    automatically set paths for the test suite correctly which is
    something we used to do ourselves in our implementation of the
    setup.py's test command originally.
    That is wrong and with the migration to PEP-517 compliant builds it
    also won't work anymore properly, because there'd be no libs to import
    by mangling PYTHONPATH, we'd only get an sdist or a wheel, or in case
    of rpmbuild a preset buildroot environment.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    setup: Drop the my_test command
    Direct setup.py invocations are being discouraged in favour of
    using Python's 'build' module. Therefore, we can't really make use of this command
    anymore since only wheels and tarballs are built with the 'build' module
    compared to the previous state of the art of dumping the freshly built
    modules and libraries directly inside the build directory.
    
    We'll have to encourage usage of tox which will install the package
    inside a virtualenvironment for the tests. Future patch will update the
    Makefile targets to make this easier for the end users.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    setup: Drop the clean command
    Direct setup.py invocations are discouraged anyway, use git clean
    or 'make clean' instead.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    Add pyproject.toml
    Given the missing setuptools keywords issue and hence having moved all
    the declarative stuff to setup.cfg this one is only a very basic one
    just to comply PEP-517 and foolproof this project for the future
    PyPa/pip changes.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    Makefile: Add a 'test' rule to run the full tox execution
    This one should be used for the "full" test experience including any
    additional environments, test suites and linters we may introduce
    further down the road.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    Makefile: Update targets according to the new way of building
    - drop direct setup.py invocations
    - clean the artifacts directly with 'rm'
    - use tox instead of invoking pytest otherwise we don't have a
    mechanism to test against the freshly built libvirt modules other
    than unpacking the built wheel and mangling the PYTHONPATH again
    - use direct rpmbuild invocation to build RPM (the rpm target in its
    current form didn't really work anyway)
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    setup: Query library version out of a file
    This makes it possible to programatically query the version in any
    stage of the build process, including Makefile etc.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    Move declarative stuff out of setup.py to setup.cfg
    So, why using setup.cfg if pyproject.toml is the new best thing
    recommended everywhere? Well, quite a few of the fields we use with
    setuptools are setuptools-specific and haven't been introduced as
    keywords to pyproject.toml yet. There is a chance that these fields
    could be added via a dedicated 'tool.setuptools' TOML section, but none
    of it is officially documented and so it would be BETA at best anyway.
    Let's not try our luck and use a declarative config file tailored
    specifically to setuptools - setup.cfg. It's also unlikely we'd switch
    from setuptools to something else in the near future given the nature
    of building this project (i.e. building with C modules) and if so, it
    would likely not be a PyPa recommended PEP-517 compliant build
    system anyway, e.g. meson, so we're totally fine doing this.
    
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    README: Move the long_description from setup.py in here
    
    
 2023- 6- 22 Erik Skultety <eskultet@redhat.com>
    
    MANIFEST.in: Cleanup
    When migrated to the PEP-517 compliant builds, some errors occurred due
    to missing or non-existent files mentioned in the MANIFEST. Notable
    changes:
    
    - README and MANIFEST files are automatically added to sdist per
    MANIFEST documentation
    - we want all tests/examples to be included, so use the 'graft' keyword
    instead of enumerating individual files
    - we want all *.[ch] files as those are needed for the build, so use
    'include *.[ch]' instead of enumerating individual files
    - we want all *.xml files, so use 'include *.xml'
    - we want all *.py files - in case this is no longer the case in the
    future, we'll need to tweak that 'include'
    - we don't want any __pycache__ nor *.pyc build artifacts, so exclude
    them globally
    
    
    
 2023- 6- 21 Erik Skultety <eskultet@redhat.com>
    
    ci: Refresh with latest lcitool changes
    - bump OpenSUSE Leap 15.4 -> 15.5
    - add python3-build dependency (PEP-517)
    - add python3-venv dependency (PEP-517)
    
    
    
 2023- 6- 9 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Fix last occurrence of os.path in favour of pathlib
    Commit e749b4cf forgot to update a couple more occurrences.
    
    Fixes: e749b4cf111bcfc9ceeb88be57dc1d810fc631d9
    
    
 2023- 6- 9 Erik Skultety <eskultet@redhat.com>
    
    setup: Drop explicit creation of the build dir in sdist
    No need to do that since we'll create it in the top-level code as a
    first thing anyway.
    
    
    
 2023- 6- 9 Erik Skultety <eskultet@redhat.com>
    
    setup: Use a simple helper to generate dist files from .in templates
    The code is almost identical in the impacted cases, so factor it out.
    
    
    
 2023- 6- 9 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Use context managers more
    Some of the operations, namely file operations and spawning processes
    can utilize the power of context managers. Use them more, use them
    together.
    
    
    
 2023- 6- 9 Erik Skultety <eskultet@redhat.com>
    
    setup: Move over from os.popen to subprocess.Popen
    subprocess is the high-level Pythonic interface providing more
    flexibility over the low-level os.popen stuff. It is recommended to
    always use subprocess over the direct 'os' interface.
    
    
    
 2023- 6- 9 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: More f-string conversions
    Fix a few more occurrences.
    
    Fixes: 745e5a8ca46feb1acf3382c38eb45c74c1c42489
    
    
 2023- 6- 8 Erik Skultety <eskultet@redhat.com>
    
    MANIFEST.in: Add Makefile
    
    
 2023- 6- 8 Erik Skultety <eskultet@redhat.com>
    
    tox.ini: Drop sanitytest execution
    Commit 60044515 renamed sanitytest to test_coverage_api but forgot to
    update the tox.ini file.
    
    Fixes: 60044515a256c36afad0fc5efcb7ea946eb93783
    
    
 2023- 6- 8 Erik Skultety <eskultet@redhat.com>
    
    COPYING: Only ship a single license file COPYING
    The correct license we've used for a while is LGPLv2+, so drop the
    original.
    
    
    
 2023- 6- 8 Erik Skultety <eskultet@redhat.com>
    
    setup: Simplify get_pkgconfig_data
    We don't need to do both None/non-None checks on the returned string.
    
    
    
 2023- 6- 8 Erik Skultety <eskultet@redhat.com>
    
    setup: Move away from os.path to pathlib.Path
    Drops usage of the glob module along the way as pathlib integrates glob
    as well.
    
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Don't mix top-level code with function/class definition
    It hinders readability so much when the top-level code that gets
    executed right away when setup.py is loaded is mixed in between type
    definitions.
    
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Format multi-line arguments properly
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Adopt f-strings in favour of old-style string formatting
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Drop unexpected spaces when providing kwargs arguments
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Replace apostrophes with quotes
    Let's standardize on usage of one and be consistent with it.
    
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: styling: Fix method/function/class spacing
    2 newlines in between classes/functions, 1 newline in between methods.
    
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: Re-order the imports
    First go general, whole module imports, then specific symbol imports.
    
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: Bump the minimum version of Python to 3.6
    3.6 is already EOL, but many platforms still default to Python 3.6 when
    it comes to the default platform Python package. Since we don't rely
    on any 3.7+ features in the bindings at the moment, let's keep
    everyone's life simpler and stay with 3.6 for now, we can bump it again
    in the future.
    
    
    
 2023- 6- 7 Erik Skultety <eskultet@redhat.com>
    
    setup: Reduce the Python classifiers to "Python :: 3" only
    We're not good at tracking all the released Python 3 versions (+ we
    don't support Python 2 anymore).
    Additionally, future patches will take care of reporting the minimum
    required version of Python anyway through the 'python_requires' field
    which shows up correctly in PyPI.
    
    
    
 2023- 6- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.5.0
    
    
 2023- 5- 31 Han Han <hhan@redhat.com>
    
    virDomainMigrate3Params: Add missing params
    Add these missing migrate params:
    - VIR_MIGRATE_PARAM_DISKS_URI, since libvirt v6.8.0(49186372db)
    - VIR_MIGRATE_PARAM_TLS_DESTINATION, since libvirt v6.0.0(1b8af37213e)
    - VIR_MIGRATE_PARAM_COMPRESSION_ZLIB_LEVEL and VIR_MIGRATE_PARAM_COMPRESSION_ZSTD_LEVEL,
    since libvirt v9.4.0(150ae3e62b9)
    
    
    
 2023- 5- 3 Erik Skultety <eskultet@redhat.com>
    
    ci: Drop Fedora 36 target
    
    
 2023- 5- 3 Erik Skultety <eskultet@redhat.com>
    
    ci: Add Fedora 38 target
    
    
 2023- 5- 3 Erik Skultety <eskultet@redhat.com>
    
    ci: Replace OpenSUSE Leap 15.4 target with Leap 15 name
    We now refer to the latest Leap 15.X simply as Leap 15 in lcitool.
    
    
    
 2023- 5- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.4.0
    
    
 2023- 4- 26 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: convert license to SPDX format
    
    
 2023- 4- 19 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.3.0
    
    
 2023- 4- 19 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: limit pytest to 'tests' subdir
    The libvirt git repo contains test data that represents the
    layout of files in sysfs, which has two subdirs that mutually
    reference each other with symlinks.
    
    When pytest does test discovery it will traverse every
    directory it finds underneath the libvirt-python checkout.
    
    Since we checkout libvirt as a sub-dir, pytest traverses
    everything in libvirt git and gets stuck in an infinite
    loop following symlinks in the libvirt test data.
    
    Telling pytest to only look at the 'tests' subdir avoids
    this extra traversal.
    
    
    
 2023- 4- 19 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: pass --break-system-packages on Debian Sid
    Debian Sid python packages block users from installing packages using
    pip unless using a venv. A venv has no benefit when we are running in
    a throwaway container which has no need for software upgrades.
    
    
    
 2023- 4- 19 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: mark bleeding edge distros as non-gating
    Fedora Rawhide, Debian Sid and OpenSUSE Tumbleweed are all liable to
    have sporadic failures due to being bleeding edge distros. Thus they
    should not gate contributor changes that are otherwise correct.
    
    
    
 2023- 4- 19 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: regenerated with lcitool manifest
    This replaces OpenSUSE Leap 15.3 with 15.4
    
    
    
 2023- 3- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.2.0
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    Fix sign compare offenders
    In a few places we compare signed and unsigned integers. In
    majority of cases it's because the iteration variable is declared
    as ssize_t but then in the for() loop it's compared against an
    unsigned int. But there is one case where the opposite happens
    (libvirt_virDomainSendKey()), or where an UINT_MAX (which is
    inherently unsigned) is compared against signed long.
    
    Also, use this opportunity to decrease scope of 'j' variable
    inside of libvirt_virDomainInterfaceAddresses().
    
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    Stop typecasting libvirt_intWrap() arguments
    There's no need to explicitly typecast arguments passed to
    libvirt_intWrap() as they are int or long already.
    
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    libvirt-override: Don't typecast strlen() in debug printings
    After some data was read from an incoming stream, we debug print
    their length using strlen() (assuming its text stream, not binary
    stream). Anyway, the debug format uses %d which then requires
    strlen() to be typecasted. Well, we can use %zu and drop the
    typecast.
    
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    libvirt_virConnectOpenAuth: Avoid plain PyLong_AsLong() call
    When constructing the list of credentials to pass to
    virConnectOpenAuth(), the virConnectAuth.credtype member is set
    via plain PyLong_AsLong() without any error checking. Well, the
    code relies on virConnectOpenAuth() to do sanity check of passed
    arguments.
    
    Switch to libvirt_intUnwrap() which does check for errors and
    avoid needless trip to libvirt's public API upon error.
    
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    libvirt_virNodeGetInfo fix
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    typewrappers: Drop typecast in libvirt_intWrap()
    The libvirt_intWrap() accepts an integer and passes it to
    PyLong_FromLong() which accepts a long. It's perfectly okay to
    let compiler do that implicitly.
    
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    typewrappers: Rework libvirt_uintWrap()
    Python C API offers PyLong_FromUnsignedLong() which allows us to
    drop typecast.
    
    
    
 2023- 2- 13 Michal Privoznik <mprivozn@redhat.com>
    
    typewrappers: Rework libvirt_uintUnwrap()
    Python C API offers PyLong_AsUnsignedLong() which already raises
    an exception on negative values. Rewrite our libvirt_uintUnwrap()
    to use that and drop check for negative values.
    
    
    
 2023- 1- 16 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.1.0
    
    
 2023- 1- 12 Peter Krempa <pkrempa@redhat.com>
    
    override: domain: Implement override for virDomainFDAssociate
    The bindings generator can't generate proper bindings for FD passing so
    the bindings need to be implemented manually both the python wrapper and
    the C backend.
    
    
    
 2023- 1- 6 Erik Skultety <eskultet@redhat.com>
    
    ci: manifest: Define RPM artifacts for regular CentOS Stream 8 build
    Commit 7360326 missed the fact that artifacts were only defined for the
    libvirt Git type of libvirt-python build (git is cloned, libvirt is
    built and then libvirt-python) based on the
    'native_git_build_job_prebuilt_env' job template whereas libvirt CI
    expects the RPM artifacts to come from a job based on the
    'native_build_job' template instead.
    
    Note that this patch is a hotfix to something which requires a proper
    cleanup to stay consistent with the way we're handling the same thing
    in libvirt-perl.
    
    
    
 2023- 1- 6 Erik Skultety <eskultet@redhat.com>
    
    .gitignore: Ignore more common Python build artifacts
    
    
 2023- 1- 5 Erik Skultety <eskultet@redhat.com>
    
    ci: manifest: Define artifacts cache
    After commit 6e0d4d53 we lost RPM artifacts cache breaking the whole
    integration CI. The reason for that is that we manually defined the
    artifacts cache in gitlab.yml instead of manifest.yml. Naturally with
    the next lcitool update, gitlab.yml got overwritten according to
    manifest.yml which didn't define any artifacts cache.
    
    Fixes: 6e0d4d53d51e8aa9d537e404a886eab131e311cc
    
    
    
 2023- 1- 5 Erik Skultety <eskultet@redhat.com>
    
    ci: manifest: Replace 'expiry' with 'expire_in'
    'expiry' isn't a keyword in lcitool anymore, the only reason why
    everything has kept working despite lcitool updates is that lcitool
    sets 'expire_in' to 2 days by default.
    
    
    
 2023- 1- 4 Erik Skultety <eskultety@ridgehead.home.lan>
    
    ci: Refresh and add Fedora 37 target
    
    
 2022- 12- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 9.0.0
    
    
 2022- 11- 23 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: add explicit build dep on python3-setuptools
    We previously got this implicitly via a dep from python3-pytest
    so never noticed that it was missing. The implicit dep is going
    away in rawhide real soon.
    
    
    
 2022- 11- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.10.0
    
    
 2022- 10- 13 Peter Krempa <pkrempa@redhat.com>
    
    ci: Expose built RPMs as artifacts
    Expose the artifacts from the centos-stream-8/9 and fedora 35/36 jobs so
    that the main libvirt integration testing project can consume them.
    
    The new libvirt sub-rpm containing a python helper to access QMP
    directly requires python environment which we didn't yet install in the
    integration job.
    
    
    
 2022- 10- 10 Chris Gunn <chrisgun@microsoft.com>
    
    Fix memory leak in libvirt_virStreamRecv.
    The libvirt_virStreamRecv function uses a temporary allocated buffer to
    receive data before copying the data into a Python byte array. But
    there are some error paths where this buffer is not freed. This change
    fixes that memory leak.
    
    
    
 2022- 10- 3 Erik Skultety <eskultet@redhat.com>
    
    ci: Fix the stage of the api-coverage job
    The 'extends' stanza supports a list, however there's a merge algorithm
    in place where a subsequent list entry overwrites all conflicting
    settings from the previous one - which is exactly what happened here as
    the gitlab-build-{local,prebuilt}-env job template overwrote
    api-coverage's stage to 'builds' whereas the original was
    'sanity_checks'.
    
    Fixes: 4733e2a2d13cb9a85127ba17c04cc29278b31e89
    
    
    
 2022- 10- 3 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.9.0
    
    
 2022- 9- 30 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh with latest lcitool manifest
    This refresh switches the CI for contributors to be triggered by merge
    requests. Pushing to a branch in a fork will no longer run CI pipelines,
    in order to avoid consuming CI minutes. To regain the original behaviour
    contributors can opt-in to a pipeline on push
    
    git push <remote> -o ci.variable=RUN_PIPELINE=1
    
    This variable can also be set globally on the repository, though this is
    not recommended. Upstream repo pushes to branches will run CI.
    
    The use of containers has changed in this update, with only the upstream
    repo creating containers, in order to avoid consuming contributors'
    limited storage quotas. A fork with existing container images may delete
    them. Containers will be rebuilt upstream when pushing commits with CI
    changes to the default branch. Any other scenario with CI changes will
    simply install build pre-requisite packages in a throaway environment,
    using the ci/buildenv/ scripts. These scripts may also be used on a
    contributor's local machines.
    
    With pipelines triggered by merge requests, it is also now possible to
    workaround the inability of contributors to run pipelines if they have
    run out of CI quota. A project member can trigger a pipeline from the
    merge request, which will run in context of upstream, however, note
    this should only be done after reviewing the code for any malicious
    CI changes.
    
    
    
 2022- 9- 9 Bastian Germann <bage@linutronix.de>
    
    Link libvirtmod_* modules also with libvirt
    The -lvirt linker flag has to be added to the libvirtmod_qemu and
    libvirtmod_lxc modules as well.
    
    
    
 2022- 9- 9 Bastian Germann <bage@linutronix.de>
    
    Replace uint with unsigned int
    Mingw-w64 target does not support uint definition.
    
    
    
 2022- 9- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.8.0
    
    
 2022- 8- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.7.0
    
    
 2022- 7- 8 Michal Privoznik <mprivozn@redhat.com>
    
    libvirt-utils: Clear error when guessing typed param type
    Our APIs which accept typed parameters are usually exposed in
    python as accepting dictionary, for instance:
    
    virDomainSetIOThreadParams(..., virTypedParameterPtr params, ...) ->
    virDomain.setIOThreadParams(..., {}, ...)
    
    Now, before calling the C API, the dictionary is processed by
    virPyDictToTypedParams() which accepts an additional argument:
    array that hints types for each typed parameter. However, if a
    key is not in the array we guess what the correct type might be.
    This is done by attempting conversion from python into string, if
    that fails then into boolean, then into long, only to fall back
    to double. Now, for the long type we can have two cases: the
    value is non-negative (ULL) or it is negative (LL). Therefore, we
    firstly attempt ULL case and if that fails we stick with the
    latter.
    
    However, after we attempted the ULL conversion, python records an
    error internally (which is then queried via PyErr_Occurred()),
    but the error is never cleared out. This leads to spurious paths
    taken afterwards: e.g. when libvirt_longlongUnwrap() is trying to
    convert -1, it fails. But not rightfully - the PyErr_Occurred()
    check it performs has nothing to do with any of its actions,
    rather than our guessing work done before.
    
    Therefore, clear the error after we've guessed the type.
    
    
    
 2022- 7- 8 Michal Privoznik <mprivozn@redhat.com>
    
    Add VIR_DOMAIN_IOTHREAD_THREAD_POOL_{MIN,MAX} macros
    The python version of virDomainSetIOThreadParams
    (setIOThreadParams()), expects two arguments on input: the thread
    ID and a dictionary which is then translated into our typed
    parameters. During this translation we use a helper array which
    holds type for each typed parameter supported
    (virPyDomainSetIOThreadParams[]). Otherwise we guess what the
    correct type is. Now, when introducing
    VIR_DOMAIN_IOTHREAD_THREAD_POOL_{MIN,MAX} typed params into
    libvirt I forgot to update the array. Do that now.
    
    
    
 2022- 7- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.6.0
    
    
 2022- 6- 25 Pino Toscano <ptoscano@redhat.com>
    
    setup: make 'clean' command compatible again with distutils
    After the switch of 'my_clean' to a simple Command, the 'clean' command
    has no more bits for options, resulting in distutils (either external
    or embedded in setuptools) complaining about it:
    
    distutils.errors.DistutilsClassError: command class <class '__main__.my_clean'> must provide 'user_options' attribute (a list of tuples)
    
    To overcome that, provide all the standard bits from options, i.e. the
    'user_options' list, and the 'initialize_options' & 'finalize_options'
    methods. In addition, add a dummy 'all' option, as distutils wants it:
    
    error: error in [...]/.pydistutils.cfg: command 'my_clean' has no such option 'all'
    
    Fixes commit a965c91c6fa1275613edbbef75c0422574eb9ff2
    
    
    
 2022- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: advertize Python 3.9 and 3.10 support
    Add classifiers that indicate we intend to support python versions
    3.9 and 3.10.
    
    
    
 2022- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    examples: remove use of deprecated setDaemon method
    In Python 3.10 the setDaemon method was deprecated. It is redundant
    since the 'daemon' parameter can be given when creating the thread,
    or the 'daemon' attribute can be set after it was created.
    
    
    
 2022- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    tests: expand AIO tests and add more comments
    Add a test for one more usage scenario that was possible in the past,
    whereby libvirt events are registered before starting the asyncio
    loop, but we let libvirt find the loop associated with the current
    thread.
    
    Skip the test relies on auto-creating an event loop with Python >= 3.10
    since it now triggers a deprecation warning which will soon turn into a
    RuntimeError.
    
    
    
 2022- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    tests: use mocks to allow calling virEventRegisterImpl many times
    We currently have to run each of the test_aio.py test cases in a
    separate process, because libvirt.virEventRegisterImpl can only be
    called once per process. This leads to quite unpleasant console
    output when running tests.
    
    By introducing a mock for libvirt.virEventRegisterImpl we can
    regain the ability to run everything in a single process. The only
    caveat is that it relies on tests to fully cleanup, but in practice
    this is ok for our current tests.
    
    
    
 2022- 6- 8 Chris Gunn <chrisgun@microsoft.com>
    
    tests: add libvirtaio test coverage
    
    
 2022- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    libvirtaio: add better docs on best practice usage pattern
    
    
 2022- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    libvirtio: lazy create the Event object in drain()
    The drain method uses an asyncio.Event object to be notified when other
    coroutines have removed all registered callbacks. The Event object needs
    to be associated with the coroutine that the event loop is running with
    and currently this is achieved by passing in the 'loop' parameter.
    
    Unfortunately Python 3.10 has removed the 'loop' parameter and now the
    object is associated implicitly with the current thread's event loop.
    At the time the virEventAsyncIOImpl constructor is called, however,
    there is no guarantee that an event loop has been set for the thread.
    The explicitly passed in 'loop' parameter would handle this scenario.
    
    For portability with Python >= 3.10 we need to delay creation of the
    Event object until we have a guarantee that there is a loop associated
    with the current thread. This is achieved by lazily creating the Event
    object inside the 'drain' method, which is expected to be invoked from
    coroutine context and thus ensure a loop is associated.
    
    
    
 2022- 6- 8 Chris Gunn <chrisgun@microsoft.com>
    
    libvirtaio: convert to using 'async' / 'await' syntax
    The 'async' keyword is new in Python 3.5, as a way to declare that a
    method is a coroutine. This replaces the '@asyncio.coroutine' decorator
    that is deprecated since 3.8 and scheduled to be removed in 3.11
    
    The 'await' keyword has to be used instead of 'yield' from any
    coroutines declared with 'async'.
    
    [DB: Split off from a larger patch mixing multiple changes]
    
    
 2022- 6- 8 Chris Gunn <chrisgun@microsoft.com>
    
    libvirtaio: drop back compat for python < 3.4.4
    setup.py ensures we have python >= 3.5, so there is no need to do
    back compat with the 'asyncio.ensure_future' method, which was new
    in 3.4.4
    
    [DB: Split off from a larger patch mixing multiple changes]
    
    
 2022- 6- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.5.0
    
    
 2022- 5- 13 Michal Privoznik <mprivozn@redhat.com>
    
    Add an override impl for virDomainRestoreParams and virDomainSaveParams
    
    
 2022- 5- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.4.0
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: switch to running API coverage test using pytest
    The API coverage test is no longer a special case.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: skip tests when seeing broken lxml implementation
    The python lxml registers some global callbacks with libxml2. As a
    result when another user of libxml2 calls APIs, it can trigger the
    python callbacks that lxml previously registered. Execution of the
    python callbacks in this case is often unsafe and leads to SEGVs.
    
    This hasn't been a problem since the sanitytest.py test has been
    a standalone program we execute. When it gets turned into a real
    python unit test, it will run in the same process as all the other
    tests and trigger the crash.
    
    A mitigation was added in lxml 4.5.2 which is good enough to let
    us continuing using lxml.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: turn into a normal python unittest
    The sanitytest.py file is now using the normal python unittest
    pattern, though we invoke the one test explicitly for now.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move function/enum identification into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move class identification into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move initial class method mapping into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move class method mapping fixup into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move C to python API mapping check into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move python to C API mapping check into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: move C API binding check into a helper method
    This is a step towards turning the sanitytest.py file into a normal
    python unittest.
    
    Best viewed with the '-b' flag to diff.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: stop passing python module path into sanity test
    We want to move over to make sanitytest.py operate like a more normal
    test script, which means making it self contained.
    
    The setup.py already sets the PYTHONPATH thanks to changes introduced
    in:
    
    commit eaded7bdadf3ccdc4b208ec0ed65a1b23b8b5f69
    Author: Daniel P. Berrange <berrange@redhat.com>
    Date:   Tue Mar 18 11:11:48 2014 +0000
    
    Add support for running unit tests with nose
    
    so passing the python module path into sanitytest.py is redundant.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: stop passing API XML path into sanity test
    We want to move over to make sanitytest.py operate like a more normal
    test script, which means making it self contained.
    
    The test already knows how to find the libvirt API XML path using
    pkg-config and if an override location is required, this can be done
    by pointing $PKG_CONFIG_PATH to a suitable place.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: switch from distutils to setuptools
    The distutils package is deprecated and targetted for deletion in Python
    3.12, so we need to switch to setuptools. Thanks to all the preceeding
    changes this is no more difficult than changing the import statements.
    
    Closes https://gitlab.com/libvirt/libvirt-python/-/issues/1
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: remove use of distutils.util.get_platform
    The 'get_platform' function is used to determine the platform specific
    component of the build output directory containing the loadable
    modules and python code. There is no nice replacement for this
    function, but we can achieve our goal by simply scaning for the desired
    subdirectory, which should exist by the time 'test' runs.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: override 'build_ext' / 'build_py' commands rather than 'build'
    We override the 'build' command to invoke the code generator before the
    extensions are compiled. The 'build' command, however, is merely a
    wrapper around several other commands. It is possible for the user to
    directly invoke those commands, in which case our code generator won't
    get a chance to run:
    
    $ python setup.py build_ext
    running build_ext
    building 'libvirtmod' extension
    creating build/temp.linux-x86_64-3.10
    creating build/temp.linux-x86_64-3.10/build
    gcc ..snip... -c build/libvirt.c -o build/temp.linux-x86_64-3.10/build/libvirt.o
    cc1: fatal error: build/libvirt.c: No such file or directory
    compilation terminated.
    error: command '/usr/lib64/ccache/gcc' failed with exit code 1
    
    To solve this we instead override 'build_ext' and 'build_py'. This in
    turn means we call the generator to emit C code separately from Python
    code.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: replace distutils.dir_util.remove_tree with shutils
    The distutils.dir_util.remove_tree method has no compelling benefit
    over using the standard python shutils module.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: replace distutils.spawn with subprocess
    The distutils.spawn method has no compelling benefit over using the
    standard python subprocess module.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: replace distutils.spawn.find_executable with shutils
    The distutils.spawn.find_executable method has no compelling benefit
    over using the standard python shutils module.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: introduce an explicit check for pkg-config operation
    Instead of searching for the pkg-config binary manually, just try to run
    it and catch the exception raised if it isn't found. Use the --version
    flag as a way to validate that it is at least somewhat functional.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: stop inheriting from 'clean' command
    The default 'clean' command impl deletes only intermediate files from
    the 'build' directory. We've overridden it to delete everything. There
    is no benefit in inheriting from the default impl, given our subclass
    will delete everything.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: drop the 'rpm' command
    This duplicates funtionality already provided by the 'bdist_rpm'
    command.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: introduce ability to selectively generate code
    Currently we always generate both the C code and Python code at the same
    time. To cope with following changes to the build process, we want to be
    able to generate C and Python separately.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: rename methods for code generation
    The names make it clearer exactly what is being generated by each.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: split function skip logic out of C generator
    The python generator needs to know whether certain functions were
    skipped in the C generator. This is achieved by the C generator
    deleting skipped functions as it runs. This is an unhelpful side
    effect as it makes it impossible to run the python generator
    without first running the C generator.
    
    This refactors buildStubs to get rid of the global side effects
    it has, by providing some helper functions for buildWrappers
    to use.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: split function type validation out of C generator
    As a side effect of generating the C code, the buildStubs methods
    checks for various unsupported types and reports errors. This is
    an undesirable side effect, if we want to skip C code generation.
    
    Splitting function type validation out into a separate method
    allows better reuse.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: split loading of APIs out from writing stubs
    The buildStubs method has a side effect of loading and parsing the API
    XML files, which the buildWrappers method then relies on.
    
    Splitting API loading into a separate method will facilitate running
    only the buildWrappers method in future.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: merge python wrapper generator methods
    Instead of having three separate methods for generating python
    wrappers, merge them all together.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: refactor buildWrappers to make it more generic
    Prepare for using buildWrappers to generate code for the QEMU / LXC
    APIs too.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: simplify some repeated code patterns
    Now that we're using common data structures for all the main libvirt,
    QEMU and LXC APIs, several of the functions have code duplication
    that can be eliminated.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: use single function for registering all enums
    Now that we only use a single dict for tracking all enums, we
    only need a single function for registering them.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: use single dict for tracking all enums
    A single invokation of the generator only handles processing of one
    libvirt API module, so there is no need to use separate dicts for
    tracking enums.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: use single function for registering all functions
    Now that we only use a single dict for tracking all functions, we
    only need a single function for registering them.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: use single dict for tracking all skipped functions
    A single invokation of the generator only handles processing of one
    libvirt API module, so there is no need to use separate dicts for
    tracking skipped functions.
    
    
    
 2022- 4- 21 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: use single dict for tracking all functions
    A single invokation of the generator only handles processing of one
    libvirt API module, so there is no need to use separate dicts for
    tracking functions.
    
    
    
 2022- 4- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.3.0
    
    
 2022- 3- 28 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: switch to using 'pip' for package installation
    The distutils/setuptools 'install' command is deprecated in favour of
    'pip', and with recent versiosn, using it will create a bad install
    that triggers a traceback on all future use of setuptools:
    
    Traceback (most recent call last):
    File "/builds/berrange/libvirt-python/setup.py", line 328, in <module>
    setup(name = 'libvirt-python',
    File "/usr/lib/python3.10/site-packages/setuptools/__init__.py", line 154, in setup
    _install_setup_requires(attrs)
    File "/usr/lib/python3.10/site-packages/setuptools/__init__.py", line 143, in _install_setup_requires
    dist = MinimalDistribution(attrs)
    File "/usr/lib/python3.10/site-packages/setuptools/__init__.py", line 135, in __init__
    super().__init__(filtered)
    File "/usr/lib/python3.10/site-packages/setuptools/dist.py", line 456, in __init__
    for ep in metadata.entry_points(group='distutils.setup_keywords'):
    File "/usr/lib64/python3.10/importlib/metadata/__init__.py", line 1009, in entry_points
    return SelectableGroups.load(eps).select(**params)
    File "/usr/lib64/python3.10/importlib/metadata/__init__.py", line 459, in load
    ordered = sorted(eps, key=by_group)
    File "/usr/lib64/python3.10/importlib/metadata/__init__.py", line 1006, in <genexpr>
    eps = itertools.chain.from_iterable(
    File "/usr/lib64/python3.10/importlib/metadata/_itertools.py", line 16, in unique_everseen
    k = key(element)
    File "/usr/lib64/python3.10/importlib/metadata/__init__.py", line 941, in _normalized_name
    return self._name_from_stem(stem) or super()._normalized_name
    File "/usr/lib64/python3.10/importlib/metadata/__init__.py", line 622, in _normalized_name
    return Prepared.normalize(self.name)
    File "/usr/lib64/python3.10/importlib/metadata/__init__.py", line 871, in normalize
    return re.sub(r"[-_.]+", "-", name).lower().replace('-', '_')
    File "/usr/lib64/python3.10/re.py", line 209, in sub
    return _compile(pattern, flags).sub(repl, string, count)
    
    This is certainly a bug in distutils/setuptools, but given the
    'install' command is deprecated, instead of waiting for a fix,
    just switch to the recommend 'pip install .' command.
    
    
    
 2022- 3- 28 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh from lcitool manifest
    This drops the CentOS 8 job and replaces Fedora 33 with 35.
    
    
    
 2022- 3- 10 Michal Privoznik <mprivozn@redhat.com>
    
    Implement virDomainQemuMonitorCommandWithFiles() override
    With libvirt-8.2.0 there's a new API:
    virDomainQemuMonitorCommandWithFiles(). Since the API has both
    input and output arguments we need to provide an alternative
    implementation. Moreover, since FD passing works only on
    UNIX-like systems we can query the returned FDs for their flags
    and construct mode for python File object.
    
    
    
 2022- 3- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.2.0
    
    
 2022- 2- 11 Daniel P. Berrangé <berrange@redhat.com>
    
    add missing files to MANIFEST.in
    
    
 2022- 1- 14 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.1.0
    
    
 2022- 1- 5 Daniel P. Berrangé <berrange@redhat.com>
    
    Add an override impl for virDomainSetLaunchSecurityState
    
    
 2021- 12- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 8.0.0
    
    
 2021- 12- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    Switch to new GitHub repo-lockdown configuration
    The repo-lockdown service used to run as a bot outside GitHub, but has
    now switched to using the GitHub Actions workflow framework. This
    requires use of a new configuration file.
    
    
    
 2021- 11- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.10.0
    
    
 2021- 10- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    Add support for domain event for memory device size change
    
    
 2021- 10- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.9.0
    
    
 2021- 9- 24 Michal Privoznik <mprivozn@redhat.com>
    
    sanitytest: Add virNetworkCreateXMLFlags() to list of name fixups
    When checking whether each C API is exported to Python and vice
    versa the sanitytest script is doing some name fixing. For
    instance virNetworkCreateXML() is translated into
    virConnect.networkCreateXML(). However, we have new C API on the
    way: virNetworkCreateXMLFlags() which is not on the list for
    these name fixups. Add it there.
    
    Mind you, the python code generator works just fine because
    generator.py:1082 compares just the prefix.
    
    
    
 2021- 9- 21 Jonathon Jongsma <jjongsma@redhat.com>
    
    Don't mention email patch submission in README
    Since patches are now submitted via gitlab merge requests, don't mention
    mailing list patch submission in the README. Point to the CONTRIBUTING
    file instead.
    
    
    
 2021- 9- 21 Jonathon Jongsma <jjongsma@redhat.com>
    
    Update readme to mention pytest instead of nose
    Commit a376a2ab switch from python-nose to python-pytest for tests, but
    the README was not updated.
    
    
    
 2021- 9- 21 Jonathon Jongsma <jjongsma@redhat.com>
    
    Add new autostart API for node devices
    Provide a manual override for the virNodeDeviceGetAutostart() API
    modeled on what's done for the network and storage APIs.
    
    
    
 2021- 9- 2 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: remove obsolete refresh script and documentation
    We now use lcitool's manifest feature to generate files.
    
    
    
 2021- 9- 2 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: re-generate containers/gitlab config from manifest
    This uses the command "lcitool manifest ci/manifest.yml" to re-generate
    all existing dockerfiles and gitlab CI config.
    
    
    
 2021- 9- 2 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: define a CI manifest file
    This is to be used with the command "lcitool manifest ci/manifest.yml"
    to re-generate all existing dockerfiles and gitlab CI config.
    
    
    
 2021- 9- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: drop support for RHEL-7
    We no longer support libvirt on this distro
    
    
    
 2021- 9- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.8.0
    
    
 2021- 8- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.7.0
    
    
 2021- 7- 27 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: use custom docker:dind image
    The current docker:dind container has broken default seccomp filter that
    results in clone3 being blocked, which in turn breaks Fedora 35 rawhide.
    
    This custom image has a workaround that causes the seccomp filter to
    return ENOSYS for clone3 instad of EPERM, thus triggering glibc to
    fallback to clone correctly.
    
    
    
 2021- 7- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.6.0
    
    
 2021- 6- 25 Peter Krempa <pkrempa@redhat.com>
    
    Fix BlockThreshold Callback argument conversion once more
    The conversion was changed from "OssiiO" to "OssLLO". Unfortunately the
    arguments are unsigned long long, where the proper coversion character
    is 'K'.
    
    Fixes: https://gitlab.com/libvirt/libvirt-python/-/merge_requests/40
    Fixes: fd069ac85c8cf1593587dc9287a3d5eb6bd4bdb9
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1976109
    
    
 2021- 6- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.5.0
    
    
 2021- 5- 27 w00506750 <hogan.wang@huawei.com>
    
    iothread: fix memory access out of bounds
    When the 'pcpu' is larger then the last 'iothr->cpumap' bits,
    set the list element to False to avoid out of bounds access
    'iothr->cpumap'.
    
    Reviewed-by: Hogan Wang <hogan.wang@huawei.com>
    
    
 2021- 5- 27 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.4.0
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    containers: refresh containers with latest libvirt-ci
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: don't set RPM variable on container job
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: add OpenSUSE Tumbleweed container and build
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: introduce Fedora 34 container and build
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: rename opensuse-152 to opensuse-leap-152
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: rename centos-stream to centos-stream-8
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: drop Fedora 32 container and build
    
    
 2021- 5- 25 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: drop centos-7 container and build
    
    
 2021- 4- 15 Michal Privoznik <mprivozn@redhat.com>
    
    generator.py: Untangle virNodeDevice name fixup
    The way that virNodeDevice method name fixup is written makes it
    hard to find via grep (matching the virNodeDevice prefix and then
    matching only the operation like "Get", "Lookup", ...). Expand
    the string matching to match the pattern of other cases.
    
    
    
 2021- 4- 15 Michal Privoznik <mprivozn@redhat.com>
    
    generator.py: Fix method names for new virNodeDevice*() APIs
    In the 7.3.0 release we are going to have three new public APIs:
    
    virNodeDeviceDefineXML()
    virNodeDeviceUndefine()
    virNodeDeviceCreate()
    
    The first one is slightly problematic, because it takes
    virConnectPtr argument and thus our generator wants to put its
    wrapper under virConnect python class, which is correct, but
    what's incorrect is the name it chooses for the method:
    defineXML(). Such method already exists and wraps
    virDomainDefineXML() around. Also, the name is rather confusing
    anyway - it's missing the 'nodeDevice' prefix.
    
    Fortunately, the fix is easy - add another case into nameFixup().
    
    The story with virNodeDeviceCreate() is similar. Except, this time
    the class in which the method was put is correct. But the name is
    still wrong, because our generator matched 'virNodeDeviceCreate'
    thinking it's the good old virNodeDeviceCreateXML() API and
    "fixed" the name of the method to nodeDeviceCreate().
    
    Luckily, virNodeDeviceUndefine() is just fine.
    
    
    
 2021- 4- 12 Ján Tomko <jtomko@redhat.com>
    
    spec: use pytest instead of nose
    
    
 2021- 4- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: use HTTPS for URLs
    
    
 2021- 4- 9 Daniel P. Berrangé <berrange@redhat.com>
    
    Don't run sanity checks by default
    The sanity check scripts verify that the binding covers all APIs in the
    libvirt library/headers being built against. This is primarily there for
    libvirt maintainers to identify when there are gaps in API coverage.
    
    This is not something downstream consumers of libvirt-python should be
    running themselves, so we shouldn't added it to tests by default.
    
    In addition if people are working on branches or submitting merge
    requests for python changes, we shouldn't block their work for failed
    API coverage sanity tests, if the python binding otherwise builds fine
    and passes regular unit tests.
    
    Thus, we introduce a new gitlab job "api-coverage" with some conditions:
    
    - If pushing to a branch, the job is treated as non-fatal
    - For regular scheduled builds, it is mandatory
    - Don't run in any other scenarios
    
    This job uses the artifacts from the centos-8-git-build job and re-runs
    the test suite, requesting the sanity tests to be run too.
    
    This will achieve the result of letting us see missing API coverage
    in nightly builds, without blocking other contributions.
    
    
    
 2021- 4- 7 Ján Tomko <jtomko@redhat.com>
    
    tests: use assertEqual instead of assertEquals
    tests/test_conn.py:17: DeprecationWarning: Please use assertEqual instead.
    
    
    
 2021- 4- 7 Ján Tomko <jtomko@redhat.com>
    
    ci: refresh containers for nose->pytest switch
    Matches libvirt-ci commit facd5d855c97bf5b127ff9bf245c8fdf514dd916
    
    
    
 2021- 4- 7 Ján Tomko <jtomko@redhat.com>
    
    setup: use pytest instead of nose to run the test suite
    The software we use for running tests - nose - has been
    deprecated in favor of nose2.
    
    We don't use anything nose-specific, just unittest.TestCase,
    which pytest can handle just fine.
    
    Switch to using pytest, which we already use for libvirt-dbus.
    
    
    
 2021- 4- 7 Ján Tomko <jtomko@redhat.com>
    
    setup: drop have_libvirtaio
    This function says we have libvirtaio on Python >= 3.3,
    however we already mandate Python >= 3.5 at the start of the file.
    
    
    
 2021- 4- 7 Andrea Bolognani <abologna@redhat.com>
    
    ci: Move dco job to sanity_checks stage
    If the DCO check fails we still want the pipeline to fail, but
    that doesn't mean there's no value in running the other jobs to
    get a better picture.
    
    
    
 2021- 4- 7 Andrea Bolognani <abologna@redhat.com>
    
    ci: Use 'extends' GitLab CI feature
    This is the recommended way to use templates in job
    definitions.
    
    
    
 2021- 4- 6 Ján Tomko <jtomko@redhat.com>
    
    ci: drop openSUSE leap 15.1 in favor of 15.2
    
    
 2021- 4- 6 Ján Tomko <jtomko@redhat.com>
    
    ci: refresh dockerfiles
    Refresh to match libvirt-ci commit 94c25bde639eb31ff2071fb6abfd3d5c777f4ab2
    
    
    
 2021- 4- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.3.0
    
    
 2021- 3- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.2.0
    
    
 2021- 3- 1 renlei4 <ren.lei4@zte.com.cn>
    
    Fix wrong type for BlockThreshold Callback
    type of threshold and excess are unsigned long long,
    but PyObject_CallMethod incorrectly set it to int.
    
    if threshold or excess greater than 0x7FFFFFFF(max int),
    those variables will overflow.
    
    
    
 2021- 2- 15 Daniel P. Berrangé <berrange@redhat.com>
    
    Add impl override for virDomainGetMessages
    
    
 2021- 2- 9 Beraldo Leal <bleal@redhat.com>
    
    improving readme with requirements
    When installing this library in a fresh system, some basic packages are
    necessary to compile and run. This patch will add basic instructions
    with some requirements to help new contributors and users.
    
    
    
 2021- 1- 15 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.1.0
    
    
 2020- 12- 15 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh containers for CentOS-8 PowerTools repo rename
    A recent CentOS-8 update renamed the "PowerTools" repo to "powertools"
    and since dnf is case sensitive wrt repo names, this broke ability to
    build new containers.
    
    The refresh fixes the repo name and pulls in other misc improvements
    to containers.
    
    
    
 2020- 12- 3 Daniel P. Berrangé <berrange@redhat.com>
    
    Avoid signed/unsigned warnings in loop over SSH keys
    libvirt-override.c: In function ‘libvirt_virDomainAuthorizedSSHKeysGet’:
    libvirt-override.c:10455:19: warning: comparison of integer expressions of different signedness: ‘size_t’ {aka ‘long unsigned int’} and ‘int’ [-Wsign-compare]
    10455 |     for (i = 0; i < nkeys; i++)
    |                   ^
    
    
    
 2020- 12- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: replace "libvirt-" prefix with "ci-" in dockerfiles
    This makes the dockerfile name match the output container name
    
    
    
 2020- 12- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: refresh containers with lcitool for fully minimized base
    
    
 2020- 12- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: re-generate container images from lcitool
    This introduces Fedora 33 and removes some redundant packages.
    
    
    
 2020- 12- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: move dockerfiles into ci/containers sub-directory
    This brings the repo into alignment with the main libvirt.git practice.
    
    
    
 2020- 12- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 7.0.0
    
    
 2020- 11- 27 Erik Skultety <eskultet@redhat.com>
    
    MANIFEST.in: Distribute MANIFEST.in in the source tarball
    Follow the same procedure as we do with specfiles in the main library
    where we distribute libvirt.spec.in along with the generated
    libvirt.spec inside the tarball.
    
    Fixes: https://gitlab.com/libvirt/libvirt-python/-/issues/5
    
    
    
 2020- 11- 19 Michal Privoznik <mprivozn@redhat.com>
    
    Implement virDomainAuthorizedSSHKeys{Get,Set}
    Both APIs work with string lists (the getter returns it, the
    setter gets keys to set from it) -> represent that as a python
    list. The rest is kept as is in C.
    
    
    
 2020- 11- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    Add support for memory failure event callbacks
    
    
 2020- 11- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    Replace deprecated PyEval_CallObject with PyObject_Call
    The former is deprecated since Python 3.9, and the latter has existed
    for all 3.x and probably before.
    
    
    
 2020- 11- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    Pass -Werror when building extension
    This ensures we pick up warnings from new python headers or other
    problems.
    
    
    
 2020- 11- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    Avoid truncating python version number when running sanity test
    The current code assumes the version number string will be only three
    characters long, which fails with "3.10".
    
    
    
 2020- 11- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    Avoid use of thread function deprecated in 3.9
    PyEval_ThreadsInitialized was deprecated in 3.9, with deletion targetted
    for 3.11. Furthermore since 3.7 it is guaranteed that threads are always
    initialized by Py_Initialize(), so checking it is redundant.
    
    
    
 2020- 11- 6 Daniel P. Berrangé <berrange@redhat.com>
    
    Add unit tests for openAuth method
    Validate that the type hinting is working as expected
    
    
    
 2020- 11- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 6.10.0
    
    
 2020- 10- 6 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: optimize CI job dependencies
    Allow more parallelization by giving explicit dependencies between jobs.
    
    
    
 2020- 10- 6 Daniel P. Berrangé <berrange@redhat.com>
    
    tests: start basic unit tests for more APIs
    To prevent regressions, especially with generated code, we need to have
    test coverage of more APIs. This starts off with coverage for object
    creation for all object types supported by the test driver
    currently. This exercises constructors which have been broken several
    times in the past.
    
    Related https://gitlab.com/libvirt/libvirt-python/-/issues/4
    
    
 2020- 10- 6 Daniel P. Berrangé <berrange@redhat.com>
    
    fix constructor param name for virDomainSnapshot / virDomainCheckpoint
    Fixes 7f021c21d6a091ca33615852d6061e75b2500f3f
    Resolves https://gitlab.com/libvirt/libvirt-python/-/issues/4
    
    
    
 2020- 10- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 6.9.0
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Work around type change
    a variable should not change its type.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Add PEP 484 type annotations
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Merge common code of print_function_wrapper
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Merge code for __init__ genration
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Expand tuple to names in for loop
    Assign tuple to multiple loop variables for better readability
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: break lines in generated code
    to be closes to pep8 which makes reading the generated code easier and
    reduces the number of issues found by flake8.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use empty string instead of None
    for better type checking: both are bool()==False, but None is not str.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Convert to defaultdict()
    for nested dictionaries allows to remove the case distinction for
    "first" from "all other" cases.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Move funcs_failed into buildStubs()
    The variables are local to that funcion
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Convert list() to set()
    tuple() and list() are sequences, while dict() and set() are hash-based,
    which is more efficient for contains().
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Convert dict() to set()
    Python has a native type for set()s.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Simplify boolean condition
    no need to compare with None or empty string.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Simplify loop break
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Simplify sorting
    Use sorted(..., key=...) instead of using explicit list.sort()
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Fixed writing cached=None
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Store arguments and return as tuple
    instead of list.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Expand tuple to names in for loop
    Assign tuple to multiple loop variables for better readability
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Initialize with empty strings
    instead of using None as this has a different type.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Simplify XML attribute fetching
    Use attr.get(key, default) instead.
    
    Also use the empty sting "" as the default value instead of "None": Both
    are "False" when used as a bool()ean, but "None" would require an
    explicit check for "not None" in many places as str() and None have
    different types.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Convert in_function to bool
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use string formatting
    instead of sting concatenating.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use SAX method names
    directly instead of using legacy method names from xmllib.
    
    Depends: 3740a5e4c701281ac76a55e3f02b1d4221f1f9f0
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Remove unused SAX content handler methods
    getmethodname()
    close()
    cdata()
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Refactor parser creation
    to use closing context manager.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Open file with context manager
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use splitlines()
    instead of hand-coded implementation.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Just walk the dict
    instead of generating a list first.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Directly get dict length
    instead of generating a list and then counting the elements.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Walk only the values
    instead of the keys and then doing a lookup.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use dict.item() to walk keys and values
    which saves a lookup of each key.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Check contained in hash
    directly instead of explicitly requesting only the keys as a list and
    converting that list to another list.
    Checking directly for an element to be contained in a hash is much more
    efficient as this is done using hashing O(1) instead of walking the list
    in half on average O(n).
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Initialize function_classes directly
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Remove global declarations
    for variables with are not assigned.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use string concatenation
    :%s,\(\w\+\)\s*=\s*\1\s*+,\1 +=,
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use increment assignment
    :%s,\(\w\+\)\s*=\s*\1\s*+,\1 +=,
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use enumerate()
    instead of manual iteration counting.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Simplify string concatentaion
    by using ''.join() instead of concatenating string fragments in a loop,
    which is slower as it required re-hashing the string multiple times.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use more string formatting
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Merge now identical if-elif-else cases
    Commit ca394b9f "generator: Fix parent type" fixed the case for creating
    `virStorage*` instances, which require a reference to `virConnect`, so
    the special handling for `._conn` is no longer needed.
    
    Commit ee5c856a "Remove legacy libvirtError arguments" removed the
    different arguments, so all cases are the same now.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Fix return type on failure
    to return a negative value instead of None for consistency.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Remove useless sort key
    tuples are sorted by first component anyway.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Remove skipped_modules
    Unused.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Remove dead variable assignments
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Use raw-string for regular expression
    "\(" is not a valid escape sequence for a Python string, but currently
    is passed on unmodified. This might breaks in the future when new escape
    sequences are introduced.
    
    > generator.py:1001:7: W605 invalid escape sequence '\('
    > generator.py:1001:18: W605 invalid escape sequence '\)'
    
    Use raw python string instead.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Convert to 'not in' and 'is not'
    as recommended by pep8
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Change type of quiet to bool
    Use `bool` instead of `int`.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Simplify exception handling
    sys.exc_info() returns a 3-tuple (type, value, traceback), where `value`
    is the instance captured by `except type as value`.
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Cleanup imports
    Move imports to top
    Remove unused import string
    Remove duplicate import os
    
    
    
 2020- 9- 1 Philipp Hahn <hahn@univention.de>
    
    generator: Do not use bare except
    as it also catches SystemExit, InterruptedError, SyntaxError and such.
    
    
    
 2020- 9- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 6.8.0
    
    
 2020- 8- 28 Philipp Hahn <hahn@univention.de>
    
    Revert "libvirtaio: Drop object(*args, **kwargs)"
    This reverts commit f4be03b330125ab1e5a2bb10b4f12674aeff4691.
    
    While object.__init__() does not expect any additional arguments, this
    construct is required for Pythons multiple inheritance implementation.
    The original author Wojtek Porczyk <woju@invisiblethingslab.com>
    explained is this way:
    
    > I'm sorry I didn't notice this earlier, but the commit f4be03b3 dated
    > 2020-04-20 [0] is wrong. The super().__init__(*args, **kwargs) in
    > Callback.__init__ was there on purpose, because of how Python's inheritance in
    > new-style classes works.
    >
    > Let me explain this a bit, because it is not obvious.
    >
    > Suppose you had diamond inheritance like this:
    >
    >     class A(object): pass
    >     class B(A): pass
    >     class C(A): pass
    >     class D(B,C): pass
    >
    > And those classes needed a common function with varying arguments:
    >
    >     class A(object):
    >         def spam(self, a): print(f'A: {a}')
    >     class B(A):
    >         def spam(self, b): print(f'B: {b}')
    >     class C(A):
    >         def spam(self, c): print(f'C: {c}')
    >     class D(B,C):
    >         def spam(self, d): print(f'D: {d}')
    >
    > The way to call all parent's functions exactly once (as per MRO) and accept
    > all arguments and also forbid unknown arguments is to accept **kwargs
    > everywhere and pass them to super().spam():
    >
    >     class A:
    >         def spam(self, a):
    >             print(f'A: {a}')
    >     class B(A):
    >         def spam(self, b, **kwargs):
    >             print(f'B: {b}')
    >             super().spam(**kwargs)
    >     class C(A):
    >         def spam(self, c, **kwargs):
    >             print(f'C: {c}')
    >             super().spam(**kwargs)
    >     class D(B, C):
    >         def spam(self, d, **kwargs):
    >             print(f'D: {d}')
    >             super().spam(**kwargs)
    >
    > Let's run this:
    >
    >     >>> B().spam(a=1, b=2)
    >     B: 2
    >     A: 1
    >     >>> D().spam(a=1, b=2, c=3, d=4)
    >     D: 4
    >     B: 2
    >     C: 3
    >     A: 1
    >
    > You may notice that super() in B.spam refers to two different classes, either
    > A or C, depending on inheritance order in yet undefined classes (as of B's
    > definition).
    >
    > That's why the conclusion that super() in Callback.__init__ refers to object
    > is wrong. In this example, spam=__init__, A=object, B=Callback and C and D are
    > not yet written, but theoretically possible classes that could be written by
    > someone else. Why would they be needed, I don't know, but if someone writes
    > them, s/he would be out of options to invent new arguments to C.__init__.
    >
    > Note that super().__init__(*args, **kwargs) when super() refers to object
    > isn't harmful, and just ensures that args and kwargs are empty (i.e. no
    > unknown arguments were passed). In fact, this is exactly why object.__init__()
    > takes no arguments since Python 2.6 [1][2], as you correctly point out in the
    > commit message.
    >
    > I don't think this breaks anything (I very much doubt anyone would need to
    > write code that would trigger this), nevertheless, as the commit is both
    > pointless and wrong, and as the original author of libvirtaio I'd like to ask
    > for this commit to be reverted. If this breaks some static analysis tool,
    > could you just suppress it for this particular line?
    >
    >
    > [0] https://gitlab.com/libvirt/libvirt-python/-/commit/f4be03b330125ab1e5a2bb10b4f12674aeff4691
    > [1] https://bugs.python.org/issue1683368
    > [2] https://docs.python.org/3/whatsnew/2.6.html#porting-to-python-2-6
    >     (fourth point)
    >
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    connect: Just clear all event handlers
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    domain: Fix None comparison
    None should be compared with "is None" instead of "== None", as the
    later would invoke a "__cmp__()" method.
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    stream: Return None from callback
    nobody evaluates the return value.
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    stream: Convert type() to isinstance()
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    stream: no type change
    static typing forbids re-declaring a variable with different types.
    Rename the variable.
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    stream: Simplify boolean condition
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    stream: Fix exception traceback handling
    sys.exc_info() returns a 3-tuple (type, value, traceback). Raising just
    `value` again looses the traceback information as this creates a new
    exception.
    
    Just use `raise` which re-raises the previous exception including the
    original traceback.
    
    FYI: There is a subtile difference between Python 2 and Python 3:
    
    > try:
    >     raise ValueError()
    > except ValueError:
    >     try:
    >         raise TypeError()
    >     except TypeError:
    >         pass
    >     raise
    
    With Python 3 the exception environment is dropped after the exception
    has been handled - as such Python 3 re-raises the outer ValueError.
    
    With Python 2 the last (inner) exception is raised: TypeError
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    stream: Do not use bare except
    as it also catches SystemExit, InterruptedError, SyntaxError and such.
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    override: Convert to list comprehension
    :%s/retlist = list()\n\s*\(for \w\+ in ret\):\n\s*retlist.append(\(.*\))\n\n\s*return retlist/return [\2 \1]/
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    override: Catch type error
    handler() should either return bytes or -2 or -3.
    Explicitly raise ValueError or TypeError to silence mypy.
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    override: no type change
    static typing forbids re-declaring a variable with different types.
    Rename the variable.
    
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    override: Add manual PEP 484 type annotations
    
    
 2020- 8- 18 Philipp Hahn <hahn@univention.de>
    
    override: Simplify exception handling
    sys.exc_info() returns a 3-tuple (type, value, traceback), where `value`
    is the instance captured by `except type as value`.
    
    
    
 2020- 8- 17 Vincent Vanlaer <vincent.vanlaer@skynet.be>
    
    Include libvirt-qemu-override.py in sdist
    libvirt-qemu-override.py was introduced in e3da8f17 but never added to
    MANIFEST.in. It was therefore not contained in the official releases on
    libvirt.org.
    
    
    
 2020- 8- 7 Philipp Hahn <hahn@univention.de>
    
    libvirtaio: Add manual PEP 484 type annotations
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    libvirtaio: assert callback type
    self.callbacks contains a mix of FDCallback and TimeoutCallback, while
    the update code does not explicitly check for.
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    libvirtaio: Fix return type
    libvirtaio.py:364: error: "virEventInvokeFreeCallback" does not return a value
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    libvirtaio: Drop object(*args, **kwargs)
    object.__init__() does not expect those parameters.
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    libvirtaio: Cleanup imports
    Move imports to top
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: no type change
    static typing forbids re-declaring a variable with different types.
    Rename the variable.
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Use str.startswith() instead of str[0]
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Use set for tracking used functions
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Use 3-tuple for finalklassmap
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Use 3-tuple for basicklassmap
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Add PEP 484 type annotations
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Drop Python 2 compatibility
    Python 3 only has int, remove the Python 2 long type
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Drop else:pass
    useless
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Do not re-declare set
    is a built-in python type
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Convert type() to isinstance()
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Skip type annotations
    Teach sanitytest to ignore typing imports
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    sanitytest: Remove unused import
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    Remove legacy libvirtError arguments
    The fields have been deprecated in C with
    git:f60dc0bc09f09c6817d6706a9edb1579a3e2b2b8
    
    They are only passed to the libvirtError constructor, but not stored for
    later or used anywhere else.
    
    sed -ri '/raise libvirtError/s/, \w+=self(\._dom)?//' *.py
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    Normalize white space
    indent by 4 spaces
    one spaces around assignments
    
    
    
 2020- 8- 6 Philipp Hahn <hahn@univention.de>
    
    examples/event-test: Fix remove return type
    The remove function are supposed to return 0 on success and -1 on failure.
    <https://libvirt.org/html/libvirt-libvirt-event.html#virEventRemoveTimeoutFunc>
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Fix white space
    indent by 4 spaces
    one spaces around assignments
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Replace sys.exit() with exit()
    No need to import sys.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Cleanup imports
    Break import into multiple lines as recommended by PEP-8
    
    Move imports to top
    
    Remove unused imports
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Do not use bare except
    as it also catches SystemExit, InterruptedError, SyntaxError and such.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Convert to ArgumentParser
    Replace getopt() and hand-rolled-parser with argparse.ArgumentParser.
    
    Fix wrong header comments copy-pasted from domstart.py
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Add/fix PEP 484 type annotation
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples: Add missing return values
    examples/dhcpleases.py:45: error: Missing return statement
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/nodestat: Fix None comparison
    "is" compares for "points to the same object", which for strings is the
    same as comparing the byte sequence itself as Python hashes each strings
    to only stores a unique copy of each string.
    
    > examples/nodestats.py:86:43: F632 use ==/!= to compare constant literals (str, bytes, int, float, tuple)
    > examples/nodestats.py:91:12: F632 use ==/!= to compare constant literals (str, bytes, int, float, tuple)
    > examples/nodestats.py:94:40: F632 use ==/!= to compare constant literals (str, bytes, int, float, tuple)
    
    Use "==" and "!=" for string comparsion.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/consolecallback: Fix assorted errors
    Assert stream is opened before receiving bytes.
    
    Need to check for bytes() instead of [unicode]str().
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/consolecallback: Add var to save callback
    > examples/consolecallback.py:98: error: "Console" has no attribute "stdin_watch"
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/esxlist: Fix Python 2 raw_input()
    which was renamed to input() for Python 3.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/event-test: Use atexit for Python 3
    Assigning sys.exitfunc no longer works with Python 3.
    
    Use atexit.register() instead.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/event-test: Remove unneeded global statement
    It only needed when a value is assigned.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/dhcp*: Fix None comparison
    None should be compared with "is None" instead of "== None", as the
    later would invoke a "__cmp__()" method.
    
    
    
 2020- 8- 5 Philipp Hahn <hahn@univention.de>
    
    examples/*: Remove stray semicolon
    This is Python, not C
    
    
    
 2020- 8- 4 Daniel P. Berrangé <berrange@redhat.com>
    
    ci: refresh dockerfiles for changed libvirt build system
    Libvirt changed from autotools to meson. All the containers need
    refreshing and the CI recipes updated.
    
    
    
 2020- 8- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 6.7.0
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    generator: Fix parent type
    The constructors for virDomain, virStoragePool, virDomainCheckpoint,
    virDomainSnapshot expect virConnect as their first argument. The current
    code always uses `self`, which is okay when such an instance is created
    from a method of virConnect itself, but there are several cases where
    this is not the case:
    
    virDomain.migrate() -> virDomain
    virDomain.migrate2() -> virDomain
    virDomain.migrate3() -> virDomain
    virDomainCheckpoint.getParent() -> virDomainCheckpoint
    virDomainSnapshot.getParent() -> virDomainSnapshot
    virStorageVol.storagePoolLookupByVolume() -> virStoragePool
    
    > libvirt.py:1850: error: Argument 1 to "virDomain" has incompatible type "virDomain"; expected "virConnect"
    > libvirt.py:1871: error: Argument 1 to "virDomain" has incompatible type "virDomain"; expected "virConnect"
    > libvirt.py:1888: error: Argument 1 to "virDomain" has incompatible type "virDomain"; expected "virConnect"
    > libvirt.py:3422: error: Argument 1 to "virStorageVol" has incompatible type "virStoragePool"; expected "virConnect"
    > libvirt.py:6835: error: Argument 1 to "virDomainCheckpoint" has incompatible type "virDomainCheckpoint"; expected "virDomain"
    > libvirt.py:6943: error: Argument 1 to "virDomainSnapshot" has incompatible type "virDomainSnapshot"; expected "virDomain"
    
    >>> import libvirt
    >>> con = libvirt.open('test:///default')
    >>> dom = con.lookupByName("test")
    >>> first = dom.checkpointCreateXML("""<domaincheckpoint><name>First</name></domaincheckpoint>""")
    >>> first.domain()
    <libvirt.virDomain object at 0x7f728c3b6b80>
    ^^^^^^
    >>> second = dom.checkpointCreateXML("""<domaincheckpoint><name>Second</name></domaincheckpoint>""")
    >>> parent = second.getParent()
    >>> parent.domain()
    <libvirt.virDomainCheckpoint object at 0x7f728c424d30>
    ^^^^^^^^^^^^^^^^
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    debug: Fix bit-rot in debug output
    Let the compiler optimize out the printf() call instead of doing it with the
    pre-processor as the later does not catch format string errors or the following
    case, where NULLSTR() is used but not defined:
    
    > libvirt-qemu-override.c: In function ‘libvirt_qemu_virConnectDomainQemuMonitorEventRegister’:
    > libvirt-qemu-override.c:271:34: warning: implicit declaration of function ‘NULLSTR’; did you mean ‘NULL’? [-Wimplicit-function-declaration]
    >   271 |           pyobj_conn, pyobj_dom, NULLSTR(event), pyobj_cbData, flags);
    >       |                                  ^~~~~~~
    > libvirt-qemu-override.c:39:28: note: in definition of macro ‘DEBUG’
    >    39 |     while (0) {printf(fmt, __VA_ARGS__);}
    >       |                            ^~~~~~~~~~~
    > libvirt-qemu-override.c:270:11: warning: format ‘%s’ expects argument of type ‘char *’, but argument 4 has type ‘int’ [-Wformat=]
    >   270 |     DEBUG("libvirt_qemu_virConnectDomainQemuMonitorEventRegister(%p %p %s %p %x) called\n",
    >       |           ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    >   271 |           pyobj_conn, pyobj_dom, NULLSTR(event), pyobj_cbData, flags);
    >       |                                  ~~~~~~~~~~~~~~
    >       |                                  |
    >       |                                  int
    > libvirt-qemu-override.c:39:23: note: in definition of macro ‘DEBUG’
    >    39 |     while (0) {printf(fmt, __VA_ARGS__);}
    >       |                       ^~~
    > libvirt-qemu-override.c:270:73: note: format string is defined here
    >   270 |     DEBUG("libvirt_qemu_virConnectDomainQemuMonitorEventRegister(%p %p %s %p %x) called\n",
    >       |                                                                        ~^
    >       |                                                                         |
    >       |                                                                         char *
    >       |                                                                        %d
    
    Copy the definition of NULLSTR from libvirt/src/internal.h to typewrappers.h
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    libvirtaio: Fix return types of callback
    libvirt defines the signature for the callback functions, e.g. the
    functions for remove() must return -1 on error and 0 on success. Raising
    an exception violates that contract.
    
    _remove_timeout() did not explicitly handle a double-remove and
    implicitly passed on the exception.
    
    update() expects no return value, so remove the pointless return to pass
    on None.
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    qemu-api: Fix return type
    The API XML description uses "C types": "str *" is not valid.
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    generator: Fix domainCheckpoint.listAllChildren()
    virDomainCheckpoint(dom, _obj)
    expects a reference to the virDomain as its first argument, but
    virDomainCheckpoint.listAllChildren()
    passes `self` instead:
    
    libvirt.py:7056: error: Argument 1 to "virDomainCheckpoint" has incompatible type "virDomainCheckpoint"; expected "virDomain"
    
    >>> import libvirt
    >>> con = libvirt.open('test:///default')
    >>> dom = con.lookupByName("test")
    >>> first = dom.checkpointCreateXML("""<domaincheckpoint><name>First</name></domaincheckpoint>""")
    >>> second = dom.checkpointCreateXML("""<domaincheckpoint><name>Second</name></domaincheckpoint>""")
    >>> child, = first.listAllChildren()
    >>> second.domain()
    <libvirt.virDomain object at 0x7f828d777b80>
    ^^^^^^^^^
    >>> child.domain()
    <libvirt.virDomainCheckpoint object at 0x7f828d8160a0>
    ^^^^^^^^^^^^^^^^^^^
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    generator: Fix domainSnapshot.listAllChildren()
    virDomainSnapshot(dom, _obj)
    expects a reference to the virDomain as its first argument, but
    virDomainSnapshot.listAllChildren()
    passes `self` instead:
    
    libvirt.py:6459: error: Argument 1 to "virDomainSnapshot" has incompatible type "virDomainSnapshot"; expected "virDomain"
    
    >>> import libvirt
    >>> con = libvirt.open('test:///default')
    >>> dom = con.lookupByName("test")
    >>> first = dom.snapshotCreateXML("""<domainsnapshot><name>First</name></domainsnapshot>""")
    >>> second = dom.snapshotCreateXML("""<domainsnapshot><name>Second</name></domainsnapshot>""")
    >>> child, = first.listAllChildren()
    >>> second.domain()
    <libvirt.virDomain object at 0x7fb32be3cfd0>
    ^^^^^^^^^
    >>> child.domain()
    <libvirt.virDomainSnapshot object at 0x7fb32bdb9080>
    ^^^^^^^^^^^^^^^^^
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    generator: Fix string formatting
    remove excessive arguments.
    
    
    
 2020- 7- 27 Philipp Hahn <hahn@univention.de>
    
    generator: Fix undefined variables file
    generator.py:931:15: F821 undefined name 'file'
    generator.py:951:15: F821 undefined name 'file'
    
    
    
 2020- 7- 22 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 6.6.0
    
    
 2020- 7- 17 Radostin Stoyanov <rstoyanov@fedoraproject.org>
    
    generator: Fix typos
    
    
 2020- 7- 15 Radostin Stoyanov <rstoyanov@fedoraproject.org>
    
    examples: Refactor domipaddrs
    This patch makes domipaddrs example compatible with Python3.
    
    
    
 2020- 7- 6 Cole Robinson <crobinso@redhat.com>
    
    Fix PY_SSIZE_T_CLEAN deprecation warning
    Seen running on fedora 32:
    
    DeprecationWarning: PY_SSIZE_T_CLEAN will be required for '#' formats
    ret = libvirtmod.virDomainLookupByUUID(self._o, uuid)
    
    This comes from here: https://bugs.python.org/issue36381
    See the section about PY_SSIZE_T_CLEAN here:
    https://docs.python.org/3/c-api/arg.html#strings-and-buffers
    
    Solution is to use Py_ssize_t instead of int for unpacked '#' values,
    combined with defined PY_SSIZE_T_CLEAN before importing Python.h. The
    latter turns these deprecation warnings into runtime segfaults though
    if we missed an instance.
    
    I verified the virt-manager's test suite works fine after this change
    
    
    
 2020- 7- 5 Cole Robinson <crobinso@redhat.com>
    
    generator: Fix SyntaxWarning
    $ ./setup.py build
    running build
    /usr/bin/pkg-config --print-errors --atleast-version=0.9.11 libvirt
    /usr/bin/python3 generator.py libvirt /usr/share/libvirt/api/libvirt-api.xml
    generator.py:1562: SyntaxWarning: "is" with a literal. Did you mean "=="?
    if classname is "virStorageVol":
    ...
    
    
    
 2020- 7- 3 Michal Privoznik <mprivozn@redhat.com>
    
    virStream: Use larger buffer for sendAll/recvAll methods
    There are four methods which receive/send entire stream
    (sendAll(), recvAll(), sparseSendAll() and sparseRecvAll()). All
    these have an intermediary buffer which is either filled by
    incoming stream and passed to a user provided callback to handle
    the data, or the other way round - user fills it with data they
    want to send and the buffer is handed over to virStream.
    
    But the buffer is incredibly small which leads to smaller packets
    being sent and thus increased overhead. What we can do is to use
    the same buffer as their C counterparts do (e.g.
    virStreamSendAll()) - they all use VIR_NET_MESSAGE_LEGACY_PAYLOAD_MAX
    long buffer (which is the maximum size of a stream packet we
    send) - this is almost exactly 256KiB (it's 256KiB - 24B for the
    header).
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2020- 7- 3 Michal Privoznik <mprivozn@redhat.com>
    
    MANIFEST: Distribute sparsestream.py example
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2020- 6- 8 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: post-release version bump to 6.5.0
    
    
 2020- 5- 22 Andrea Bolognani <abologna@redhat.com>
    
    ci: Test installation
    
    
 2020- 5- 22 Andrea Bolognani <abologna@redhat.com>
    
    ci: Make job skips more flexible
    Instead of hardcoding the names of the targets for which certain
    steps should be skipped, use a separate variable to store that
    information.
    
    
    
 2020- 5- 14 Daniel P. Berrangé <berrange@redhat.com>
    
    examples: remove docs about non-existent XML files
    The docs refers to XML files that don't exist in the python binding
    since it was split off from the main libvirt.git repo.
    
    Fixes #3
    
    
 2020- 5- 14 Daniel P. Berrangé <berrange@redhat.com>
    
    Drop largely empty and unused NEWS file
    We bundle a git generated ChangeLog file in the dist, and never add
    any entries to the NEWS file.
    
    Fixes #2
    
    
 2020- 5- 14 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: add testing of the rpmbuild process
    
    
 2020- 5- 5 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: add CONTRIBUTING.rst file to indicate use of merge requests
    With the introduction of automated CI pipelines, we are now ready to switch
    to using merge requests for the project. With this switch we longer wish
    to have patches sent to the mailing list, and thus the git-publish
    config is removed.
    
    
    
 2020- 5- 5 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: post-release version bump to 6.4.0
    
    
 2020- 5- 5 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 6.3.0
    * setup.py: updated for the release
    
    
    
 2020- 5- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: fix typo s/perl/python/ in docker cached image name
    Reported-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2020- 5- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    travis: delete redundant configuration
    Now that we're standardizing on GitLab CI for both official gating CI
    and developer CI, there's no compelling reason to continue to support
    Travis CI.
    
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2020- 5- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: introduce CI jobs testing git master & distro libvirt
    The python build needs to validate two axis
    
    - A variety of libvirt versions
    - A variety of python versions
    
    We get coverage for both these axis by running a build against the
    distro provided libvirt packages. All that is then missing is a build
    against the latest libvirt git master, which only needs to be run on
    a single distro, for which CentOS 8 is picked as a stable long life
    base.
    
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2020- 5- 1 Daniel P. Berrangé <berrange@redhat.com>
    
    test: workaround missing VIR_TYPED_PARAM enums in API definition
    On Ubuntu 18.04 with libvirt 4.0.0 libvirt-python build fails
    
    running test
    /usr/bin/python3 sanitytest.py build/lib.linux-x86_64-3.6 /usr/share/libvirt/api/libvirt-api.xml
    Cannot get a value of enum VIR_TYPED_PARAM_BOOLEAN (originally VIR_DOMAIN_BLKIO_PARAM_BOOLEAN)
    Cannot get a value of enum VIR_TYPED_PARAM_DOUBLE (originally VIR_DOMAIN_BLKIO_PARAM_DOUBLE)
    Cannot get a value of enum VIR_TYPED_PARAM_INT (originally VIR_DOMAIN_BLKIO_PARAM_INT)
    ...snip...
    
    The code generated for the binding is still correct and so we can just
    whitelist this error scenario.
    
    
    
 2020- 4- 30 Daniel P. Berrangé <berrange@redhat.com>
    
    gitlab: add CI job for validating DCO signoff
    This job uses the shared "check-dco" image to validate that all
    commits on a branch in a developer's repo fork have a suitable
    
    
    
 2020- 4- 27 Philipp Hahn <hahn@univention.de>
    
    examples: Fix connection error handling 2
    Fix two more cases in examples as
    libvirt.open*() does not return None but raises an exception
    
    Fixes: 283e2bc693746164b22226e14d6fe3ccd38a07bf
    Reviewed-by: Michal Privoznik <mprivozn@redhat.com>
    
    
 2020- 4- 22 Daniel P. Berrangé <berrange@redhat.com>
    
    setup: require python >= 3.5 to build
    Python 3.5 is the oldest Python version available across our supported
    build platforms.
    
    Reviewed-by: Philipp Hahn <hahn@univention.de>
    
    
 2020- 4- 20 Philipp Hahn <hahn@univention.de>
    
    examples: Fix connection error handling
    libvirt.open*() does not return None but raises an exception
    
    
    
 2020- 4- 7 Daniel P. Berrangé <berrange@redhat.com>
    
    github: enable lockdown of issues and merge requests
    Libvirt uses GitHub as an automated read-only mirror. The goals were to
    have a disaster recovery backup for libvirt.org, a way to make it easy
    for people to clone their own private copy of libvirt Git, and finally
    as a way to interact with apps like Travis.
    
    The project description was set to a message telling people that we
    don't respond to pull requests. This was quite a negative message to
    potential contributors, and also did not give them any guidance about
    the right way to submit to libvirt. Many also missed the description and
    submitted issues or pull requests regardless.
    
    It is possible to disable the issue tracker in GitHub, but there is no
    way to disable merge requests. Disabling the issue tracker would also
    leave the problem of users not being given any positive information
    about where they should be reporting instead.
    
    There is a fairly new 3rd party application built for GitHub that
    provides a bot which auto-responds to both issues and merge requests,
    closing and locking them, with a arbitrary comment:
    
    https://github.com/apps/repo-lockdown
    
    This commit adds a suitable configuration file for libvirt, which
    tries to give a positive response to user's issue/pullreq and guide
    them to the desired contribution path on GitLab.
    
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    Reviewed-by: Eric Blake <eblake@redhat.com>
    
    
 2020- 4- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 6.2.0
    * setup.py: bumped version to 6.2.0
    
    
    
 2020- 3- 30 Radostin Stoyanov <rstoyanov@fedoraproject.org>
    
    tox: Test with Python 3.6, 3.7 and 3.8
    Support for Python 2.X has been dropped with commit b22e4f2.
    
    Reviewed-by: Michal Privoznik <mprivozn@redhat.com>
    
    
 2020- 3- 3 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 6.1.0
    * setup.py : updated for release
    
    
    
 2020- 1- 16 Daniel P. Berrangé <berrange@redhat.com>
    
    gitpublish: add 'libvirt-' to subject prefix
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2020- 1- 15 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-6.0.0
    * setup.py: updated for the release
    
    
    
 2020- 1- 3 Daniel P. Berrangé <berrange@redhat.com>
    
    Add overrides for network port UUID getter/lookup methods
    The generator creates broken code for all these methods.
    
    Reviewed-by: Fabiano Fidêncio <fidencio@redhat.com>
    
    
 2020- 1- 3 Daniel P. Berrangé <berrange@redhat.com>
    
    fix class type instantiated when listing network ports
    Reviewed-by: Erik Skultety <eskultet@redhat.com>
    
    
 2019- 12- 9 Andrea Bolognani <abologna@redhat.com>
    
    setup: Accept 'nosetests3' as nosetests binary
    This is the name used on Ubuntu.
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 12- 6 Daniel P. Berrangé <berrange@redhat.com>
    
    Fix RPM deps for centos 7
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2019- 12- 4 Daniel P. Berrangé <berrange@redhat.com>
    
    Drop support for python 2
    python2 will be end of life by the time of the next
    libvirt release. All our supported build targets, including
    CentOS7, have a python3 build available.
    
    Reviewed-by: Michal Privoznik <mprivozn@redhat.com>
    
    
 2019- 12- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.10.0
    * setup.py: update for release
    
    
    
 2019- 11- 28 Pavel Hrdina <phrdina@redhat.com>
    
    generator.py: add mapping for VIR_DOMAIN_QEMU_AGENT_COMMAND_*
    Libvirt commit <95f5ac9ae52455e9da47afc95fa31c9456ac27ae> changed the
    VIR_DOMAIN_QEMU_AGENT_COMMAND_* enum values to use different enum values
    instead of direct numbers.  We need to translate it back.
    
    Traceback (most recent call last):
    File "generator.py", line 2143, in <module>
    qemuBuildWrappers(sys.argv[1])
    File "generator.py", line 2008, in qemuBuildWrappers
    items.sort(key=lambda i: (int(i[1]), i[0]))
    File "generator.py", line 2008, in <lambda>
    items.sort(key=lambda i: (int(i[1]), i[0]))
    ValueError: invalid literal for int() with base 10: 'VIR_DOMAIN_AGENT_RESPONSE_TIMEOUT_BLOCK'
    
    Reviewed-by: Peter Krempa <pkrempa@redhat.com>
    
    
 2019- 11- 6 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.9.0
    * setup.py: update for release
    
    
    
 2019- 10- 5 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.8.0
    * setup.py: updated version
    
    
    
 2019- 9- 23 Pavel Hrdina <phrdina@redhat.com>
    
    virDomainMigrate3Params: add missing parallel connections param
    Introduced in libvirt 5.2.0 by commit <d3ea986af24>.
    
    Reported-by: Liping Cheng <lcheng@redhat.com>
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 9- 23 Pavel Hrdina <phrdina@redhat.com>
    
    virDomainMigrate3Params: add missing bandwidth postcopy param
    Introduced in libvirt 5.1.0 by commit <c830187a015>.
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 9- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    Custom impl for virConnectSetIdentity which can't be generated
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2019- 9- 20 Pavel Hrdina <phrdina@redhat.com>
    
    virDomainMemoryStats: include hugetlb pgalloc and pgfail
    Introduced in libvirt 5.4.0 by commit <a699b19f6c3>.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1683516
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 9- 20 Pavel Hrdina <phrdina@redhat.com>
    
    virDomainMemoryStats: include disk caches
    Introduced in libvirt 4.6.0 by commit <aee04655089>.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1683516
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 9- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: whitelist 'network' method as having no C impl
    
    
 2019- 9- 12 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: fix constructor for virNetworkPort
    The virNetworkPort class is passed both the virNetwork parent
    python class and the virNetworkPort C object. This needs special
    handling in the generator, similar to how virDomainSnapshots are
    dealt with.
    
    Reviewed-by: Michal Privoznik <mprivozn@redhat.com>
    
    
 2019- 9- 5 Cole Robinson <crobinso@redhat.com>
    
    Fix -Wsign-compare warnings
    libvirt-override.c: In function ‘libvirt_virConnectBaselineHypervisorCPU’:
    libvirt-override.c:9946:23: warning: comparison of integer expressions of different signedness: ‘size_t’ {aka ‘long unsigned int’} and ‘int’ [-Wsign-compare]
    libvirt-override.c:9961:19: warning: comparison of integer expressions of different signedness: ‘size_t’ {aka ‘long unsigned int’} and ‘int’ [-Wsign-compare]
    
    Use ssize_t as was similarly done in 75ec2acb6163b
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2019- 9- 3 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.7.0
    
    
 2019- 9- 3 Nir Soffer <nirsof@gmail.com>
    
    spec: Build python2 package in fedora < 31
    Since commit ee0cfbe65c5d (spec: Unconditionally build python2 on
    Fedora) python2-libvirt is not built on any Fedora version.
    
    Fix the spec to drop python2-libvirt on Fedora 31.
    
    Reviewed-by: Cole Robinson <crobinso@redhat.com>
    
    
 2019- 8- 29 Michal Privoznik <mprivozn@redhat.com>
    
    Implement virDomainGetGuestInfo
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 8- 5 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-5.6.0
    * setup.py: updated for new release
    
    
    
 2019- 7- 29 Eric Blake <eblake@redhat.com>
    
    Define virDomainCheckpointPtr typedef on old libvirt
    Needed prior to 5.6.0
    
    
    
 2019- 7- 29 Eric Blake <eblake@redhat.com>
    
    Add virDomainCheckpoint APIs
    Copies heavily from existing virDomainSnapshot handling, regarding
    what special cases the generator has to be taught and what overrides
    need to be written.
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2019- 7- 9 Cole Robinson <crobinso@redhat.com>
    
    spec: Bump minimum supported Fedora version to 29
    Reviewed-by: Fabiano Fidêncio <fidencio@redhat.com>
    
    
 2019- 7- 9 Cole Robinson <crobinso@redhat.com>
    
    spec: Unconditionally build python2 on Fedora
    In Fedora we are currently shipping python2 bindings for all builds,
    so this conditional is out of date. Fedora 31 may be the time that
    python2 bindings are dropped:
    
    https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal
    
    But I think it's better to wait for that to actually happen before
    we change this again
    
    Reviewed-by: Fabiano Fidêncio <fidencio@redhat.com>
    
    
 2019- 7- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.5.0
    * setup.py: update for release
    
    
    
 2019- 6- 26 Sergei Turchanov <turchanov@farpost.com>
    
    Fix regression in lxcOpenNamespace
    This fixes regression caused by the 1d39dbaf637db03f6e597ed56b96aa065710b4a1
    
    fdlist[i] erroneously was replaced by fdlist[1] which caused
    lxcOpenNamespace to return a list with identical elements.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    Add new override file to dist
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    Add missing impl of virNetworkListAllPorts
    This API needs manual impl as the generator cannot cope
    
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    sanitytest: add some special cases for virNetworkPort APIs
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    generator: fix naming of getter APIs for virNetworkPort
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    Define virNetworkPortPtr typedef on old libvirt
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    Fix syntax error with missing ; and too many )
    
    
 2019- 6- 20 Daniel P. Berrangé <berrange@redhat.com>
    
    Add support for virNetworkPort object & APIs
    Define the various rules in the generator to wire up methods into the
    virNetwork class and create the new virNetworkPort class.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2019- 6- 3 Daniel Veillard <veillard@redhat.com>
    
    Release of Libvirt-python 5.4.0
    
    
 2019- 5- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.3.0
    * setup.py: bumped release version
    
    
    
 2019- 4- 29 Michal Privoznik <mprivozn@redhat.com>
    
    Allow virConnect.getDomainCapabilities() to have no arguments
    Our C API allows no values to be passed (well, it accepts all
    NULLs). There's no reason that python binding should require all
    arguments.
    
    Reviewed-by: Kashyap Chamarthy <kchamart@redhat.com>
    
    
 2019- 4- 4 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: use new python macros for build/install rules
    The new %py{2,3}_{build,install} macros ensure that the right compiler
    and linker flags are used when building python modules.
    
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2019- 4- 3 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.2.0
    * setup.py: bumped release version up
    
    
    
 2019- 3- 12 Nir Soffer <nirsof@gmail.com>
    
    Fix handling of optional params in blockCopy()
    Commit 2b4bd07e0a22 (Add check for params, nparams being a dictionary)
    changed the way the optional params argument is treated. If
    libvirt.virDomain.blockCopy() is called without specifying params,
    params is None, and the call will fail with:
    
    TypeError: block params must be a dictionary
    
    This is wrong as params is defined as kwarg, breaking existing libvirt
    users like oVirt. Add a check for Py_None, so we accept either a dict or
    None and fail with TypeError with anything else.
    
    Resolves: https://bugzilla.redhat.com/1687114
    
    
    
 2019- 3- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.1.0
    * setup.py: updated for release
    
    
    
 2019- 2- 25 Pavel Hrdina <phrdina@redhat.com>
    
    Fix virDomainPinIOThread typed params check
    The VIR_DOMAIN_IOTHREAD_POLL_SHRINK is unsigned int.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1680546
    
    
    
 2019- 2- 7 Eric Blake <eblake@redhat.com>
    
    generator.py: typo fix
    
    
 2019- 1- 24 Daniel P. Berrangé <berrange@redhat.com>
    
    travis: add testing of 5.0.0 release
    Update to test against very latest release. Since we dropped two
    python versions, we can afford to add new libvirt version without
    dropping a previous one.
    
    Reviewed-by: Cole Robinson <crobinso@redhat.com>
    
    
 2019- 1- 24 Daniel P. Berrangé <berrange@redhat.com>
    
    travis: switch from trusty to xenial dist
    The trusty gnutls version is too old to support modern libvirt
    
    Reviewed-by: Cole Robinson <crobinso@redhat.com>
    
    
 2019- 1- 24 Daniel P. Berrangé <berrange@redhat.com>
    
    travis: remove python 2.6 and 3.6 from build matrix
    The lxml package that we download with pip no longer supports either
    of these versions of python.
    
    Reviewed-by: Cole Robinson <crobinso@redhat.com>
    
    
 2019- 1- 22 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm spec: remove %{extra_release} from spec
    The %{extra_release} field was previously populated by data from the old
    autobuild.sh file but is no longer used.
    
    
    
 2019- 1- 15 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 5.0.0
    * setup.py: updated for release
    
    
    
 2018- 12- 3 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-4.10.0
    * setup.py: update to bump release number
    
    
    
 2018- 11- 26 Philipp Hahn <hahn@univention.de>
    
    Add daemon to list of shutdown reasons
    Add the support to work with libvirt commit 66a85cb13.
    
    
    
 2018- 11- 20 John Ferlan <jferlan@redhat.com>
    
    Fix copy paste error on the version check value
    
    
 2018- 11- 20 John Ferlan <jferlan@redhat.com>
    
    Implement API binding for virDomainSetIOThreadParams
    Similar to libvirt_virDomainBlockCopy (and migration API's). Create
    the code for the new API.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 11- 20 John Ferlan <jferlan@redhat.com>
    
    Add check for params, nparams being a dictionary
    If PyDict_Check fails, we should force an error rather than
    blindly continuing on.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 11- 20 John Ferlan <jferlan@redhat.com>
    
    Add missing virPyDictToTypedParams for libvirt_virDomainBlockCopy
    Need to free params like similar API's such as libvirt_virDomainMigrate3
    and libvirt_virDomainMigrateToURI3.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 11- 20 John Ferlan <jferlan@redhat.com>
    
    Fix typos in virDomainSetSchedulerParameters name
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 11- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 4.9.0
    * setup.py: update for new release
    
    
    
 2018- 11- 1 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Report ERROR events
    VIR_DOMAIN_EVENT_ID_IO_ERROR and VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON
    callbacks receive the same 'action' parameter, so also translate that
    numeric action to a descriptive text for the first callback.
    
    
    
 2018- 11- 1 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Fix ERROR event
    ERROR_EVENTS translates the numeric 'action' argument to a description,
    not the 'reason' argument which already contains a descriptive string
    like 'enospc'.
    
    > Traceback (most recent call last):
    >   File "/usr/lib/python2.7/dist-packages/libvirt.py", line 4661, in _dispatchDomainEventIOErrorReasonCallback
    >     reason, opaque)
    >   File "libvirt-python/examples/event-test.py", line 536, in myDomainEventIOErrorReasonCallback
    >     dom.name(), dom.ID(), srcpath, devalias, action, ERROR_EVENTS[reason]))
    >   File "libvirt-python/examples/event-test.py", line 474, in __getitem__
    >     data = self.args[item]
    > TypeError: tuple indices must be integers, not str
    
    Fixes: f5928c6711654f1496707ca77f626b3192843d57
    
    
 2018- 10- 1 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 4.8.0
    
    - setup.py : updated for release
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Fix blanks
    Closer to pep8
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert CONNECTION events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert SECRET events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert DEVICE events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert STORAGE events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert NETWORK events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert TRAY events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert DISK events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert GRAPHICS events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert AGENT events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert ERROR events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert WATCHDOG events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert BLOCKJOB events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Convert LIVECYCLE events
    to use new Description class
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Add class for event descriptions
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Simplify event ID lists
    by directly building the list with the IDs instead of appending them
    explicitly.
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Merge livecycle callbacks
    Registering the same function twice using the old domainEventRegister()
    interface would not work, as the function reference is used for
    un-registering.
    
    But it is not a problem with the new interface domainEventRegisterAny(),
    as that returns a unique ID.
    
    While at it also demonstrate the 'opaque' mechanism.
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Use __file__
    instead of sys.argv[0]
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Add missing globale statement
    to fix loop termination on exit.
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Remove dead assignment
    variable is unused
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Remove extra parenthesis
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Handle closed connection
    If libvirtd terminates while event-test.py has an open connection to it,
    it will crash with the following traceback:
    
    > myConnectionCloseCallback: qemu:///session: Error
    > Exception in thread libvirtEventLoop:
    > Traceback (most recent call last):
    >   File "/usr/lib/python2.7/threading.py", line 801, in __bootstrap_inner
    >     self.run()
    >   File "/usr/lib/python2.7/threading.py", line 754, in run
    >     self.__target(*self.__args, **self.__kwargs)
    >   File "examples/event-test.py", line 424, in virEventLoopPollRun
    >     eventLoop.run_loop()
    >   File "examples/event-test.py", line 242, in run_loop
    >     self.run_once()
    >   File "examples/event-test.py", line 187, in run_once
    >     libvirt.virEventInvokeFreeCallback(opaque)
    > AttributeError: 'module' object has no attribute 'virEventInvokeFreeCallback'
    >
    > libvirt: XML-RPC error : internal error: client socket is closed
    > Traceback (most recent call last):
    >   File "examples/event-test.py", line 872, in <module>
    >     main()
    >   File "examples/event-test.py", line 854, in main
    >     vc.secretEventDeregisterAny(id)
    >   File "/usr/lib/python2.7/dist-packages/libvirt.py", line 4987, in secretEventDeregisterAny
    >     if ret == -1: raise libvirtError ('virConnectSecretEventDeregisterAny() failed', conn=self)
    > libvirt.libvirtError: internal error: client socket is closed
    > Closing qemu:///session
    
    Skip unregistering the event callbacks and closing the connection if the
    connection is already broken / closed.
    
    
    
 2018- 9- 24 Philipp Hahn <hahn@univention.de>
    
    event-test.py: Sync list of domain lifecycle events
    Add new events to prevent crash:
    > Traceback (most recent call last):
    >   File "/usr/lib/python2.7/dist-packages/libvirt.py", line 4601, in _dispatchDomainEventCallbacks
    >     cb(self, virDomain(self, _obj=dom), event, detail, opaque)
    >   File "libvirt-python/examples/event-test.py", line 505, in myDomainEventCallback1
    >     domDetailToString(event, detail)))
    >   File "libvirt-python/examples/event-test.py", line 484, in domDetailToString
    >     return domEventStrings[event][detail]
    > IndexError: tuple index out of range
    
    
    
 2018- 9- 3 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python=4.7.0
    * setup.py: updated for release
    
    
    
 2018- 8- 6 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-4.6.0
    * setup.py: updated for release
    
    
    
 2018- 7- 23 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: update min required rhel/fedora
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2018- 7- 23 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: add BuildRequires on gcc
    The gcc RPM is no longer part of the default build root.
    
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2018- 7- 23 Daniel P. Berrangé <berrange@redhat.com>
    
    rpm: use the versioned python2 macro names
    The use of non-versioned python2 macro names is deprecated in Fedora
    
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2018- 7- 16 Daniel P. Berrangé <berrange@redhat.com>
    
    travis: add libvirt 4.5.0 version to build matrix
    
    
 2018- 7- 16 Daniel P. Berrangé <berrange@redhat.com>
    
    fix build with older libvirt missing virNWFilterBindingPtr
    While we correctly disable all public API bindings that rely on
    virNWFilterBindingPtr, the generator is still creating a helper function
    that needs it - libvirt_virNWFilterBinding_pointer. Making this helper
    conditional is a little hairy, so just provide a trivial typedef to keep
    it happy.
    
    
    
 2018- 7- 10 Cole Robinson <crobinso@redhat.com>
    
    spec: Remove Group: and %defattr
    These are only needed for RHEL5 builds, which are no longer supported
    
    https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/CMCUBB4SWS3URHTRRS3OPFM4HF5CGKBW/
    https://fedoraproject.org/wiki/RPMGroups
    
    
    
 2018- 7- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-4.5.0
    * setup.py: updated for release
    
    
    
 2018- 6- 28 Daniel P. Berrangé <berrange@redhat.com>
    
    Fix bugs in nwfilter binding APIs
    We did not correctly mangle the API names in two cases, and we also
    forgot to specialize the lookup method name in the sanity test.
    
    
    
 2018- 6- 28 Daniel P. Berrangé <berrange@redhat.com>
    
    Add support for nwfilter binding objects / apis
    
    
 2018- 6- 27 Cole Robinson <crobinso@redhat.com>
    
    libvirtaio: Fix compat with python 3.7
    In python 3.7, async is now a keyword, so this throws a syntax error:
    
    File "/usr/lib64/python3.7/site-packages/libvirtaio.py", line 49
    from asyncio import async as ensure_future
    ^
    SyntaxError: invalid syntax
    
    Switch to getattr trickery to accomplish the same goal
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    Reviewed-by: Andrea Bolognani <abologna@redhat.com>
    
    
 2018- 6- 14 Erik Skultety <eskultet@redhat.com>
    
    Add support for virNodeGetSEVInfo
    This binding allows to query the AMD's SEV firmware for various platform
    specific things, like a PDH certificate and a certificate chain to
    establish a trusted connection with the firmware. Because the API uses
    typed params, it's exempted from generation.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 6- 14 Erik Skultety <eskultet@redhat.com>
    
    Add support for virDomainGetLaunchSecurityInfo
    Libvirt recently introduced support for getting launch security
    parameters, most notably AMD SEV VM memory measurement. This API can't
    be generated as it's using typed parameters which we need to allocate.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 6- 12 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt_charPtrUnwrap: remove unnecessary check of returned string
    Function libvirt_charPtrUnwrap() either fails or always sets the
    unwrapped string so there is no need to check it explicitly.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 6- 12 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-override: Reset exception if the error is ignored
    In virConnectCredCallbackWrapper() we ignore the error case of
    libvirt_charPtrUnwrap() function so we should also reset the exception.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 6- 12 Pavel Hrdina <phrdina@redhat.com>
    
    typewrappers: Fix libvirt_charPtrUnwrap to set an exception if it fails
    If the function fails it should always set an exception.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 6- 12 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-utils: remove unused py_str function
    Commit <57a160b5248ba47d4e1c9d22d95847dad8e0524f> removed last usage
    but did not remove the function itself.
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 6- 6 Daniel P. Berrangé <berrange@redhat.com>
    
    Blacklist virGetLastError{Code,Domain}
    These methods will not be exposed to apps, since we auto raise
    all errors.
    
    
    
 2018- 6- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-4.4.0
    * setup.py: update for release
    
    
    
 2018- 6- 1 Jiri Denemark <jdenemar@redhat.com>
    
    Add support for virConnectBaselineHypervisorCPU
    The python bindings for this API cannot be generated because are
    generator is not capable of handling string arrays (char **) parameters.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1584676
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 5- 22 Michal Privoznik <mprivozn@redhat.com>
    
    event-test.py: Sync list of storage lifecycle events
    https://bugzilla.redhat.com/show_bug.cgi?id=1578337
    
    Since libvirt 3.8.0 we have 6 events: defined, undefined,
    started, stopped, created, deleted. However, the last two were
    missing in a string list that translates libvirt events (int)
    into human readable strings.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 5- 16 Marc Hartmayer <mhartmay@linux.vnet.ibm.com>
    
    Allow virConnect to be used as a context manager
    The libvirt python bindings are now more 'pythonic' as virConnect can
    now be used as a context manager.
    
    For example, it's possible to write the following code:
    
    with libvirt.open() as conn:
    # do something with the connection...
    print(conn.listAllDomains())
    
    At the end of this with-block the connection will be closed
    automatically.
    
    Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
    Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
    
    
 2018- 5- 16 Marc Hartmayer <mhartmay@linux.vnet.ibm.com>
    
    libvirt-override.py: remove unused import
    Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
    Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
    
    
 2018- 5- 16 Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
    
    libvirt-override.py: fix sparseSendAll
    Variable ret is used before assignment.
    
    
    
 2018- 5- 16 Marc Hartmayer <mhartmay@linux.vnet.ibm.com>
    
    libvirt_qemu/lxc: fix a namespace issue
    Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
    Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
    
    
 2018- 5- 16 Marc Hartmayer <mhartmay@linux.vnet.ibm.com>
    
    libvirt_qemu/lxc: import 'sys' package
    This fixes the pylint [1] warning "E: 25,16: Undefined variable
    'sys' (undefined-variable)".
    
    [1] https://www.pylint.org/
    
    Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
    Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
    
    
 2018- 5- 3 Andrea Bolognani <abologna@redhat.com>
    
    maint: Drop autobuild.sh
    The Test-AutoBuild project, that this script is supposed
    to be used with, hasn't seen any activity in ~7 years;
    these days, libvirt-python CI builds are happening on the
    Jenkins-based CentOS CI environment under the libvirt
    umbrella[1], and in that context the script is not used
    at all.
    
    [1] https://ci.centos.org/view/libvirt/
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2018- 4- 24 Daniel P. Berrangé <berrange@redhat.com>
    
    git: add config file telling git-publish how to send patches
    The "git-publish" tool is a useful git extension for sending patch
    series for code review. It automatically creates versioned tags
    each time code on a branch is sent, so that there is a record of
    each version. It also remembers the cover letter so it does not
    need re-entering each time the series is reposted.
    
    With this config file present it is now sufficient[1] to run
    
    $ git publish
    
    to send all patches in a branch to the list for review, with the
    correct subject prefix added for this non-core libvirt module.
    
    [1] Assuming your $HOME/.gitconfig has an SMTP server listed
    at least e.g.
    
    [sendemail]
    smtpserver = smtp.example.com
    
    
    
 2018- 4- 19 Daniel P. Berrangé <berrange@redhat.com>
    
    Fix build with older libvirt versions
    The libvirt python module is supposed to build with historical versions
    of the API back to 0.9.1, which means all constants / methods must be
    wrapped in conditionals. This was accidentally forgotten in:
    
    commit 314b2346df2d8e2d7d705b003c693b4fa0189bdf
    Author: Edgar Kaziakhmedov <edgar.kaziakhmedov@virtuozzo.com>
    Date:   Wed Feb 7 17:49:30 2018 +0300
    
    Set hints for virPyDictToTypedParams
    
    Predefine hints for all parameters possible to avoid wrong type
    convert.
    
    This broke the build against any libvirt < 2.0.0
    
    Reviewed-by: Ján Tomko <jtomko@redhat.com>
    
    
 2018- 4- 3 Daniel P. Berrangé <berrange@redhat.com>
    
    Post-release version bump to 4.3.0
    
    
 2018- 3- 23 Daniel P. Berrangé <berrange@redhat.com>
    
    Disable Python 2 on future RHEL and Fedora > 29
    The end of Python 2 is nearing, so declare when it will be removed
    from libvirt Python binding RPMs.
    
    NB, this doesn't imply we'll be removing py2 support from upstream
    libvirt-python on the same timeframe - we'll consider what todo
    wrt that when upstream Python 2 finally goes EOL.
    
    Reviewed-by: Jiri Denemark <jdenemar@redhat.com>
    
    
 2018- 3- 5 Daniel P. Berrangé <berrange@redhat.com>
    
    Post-release version bump to 4.2.0
    
    
 2018- 3- 5 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 4.1.0
    
    
 2018- 2- 19 Pavel Hrdina <phrdina@redhat.com>
    
    Fix virPyDictToTypedParams type hint for block copy params
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2018- 2- 19 Pavel Hrdina <phrdina@redhat.com>
    
    Add missing virPyDictToTypedParams hint for migration params
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2018- 2- 19 Pavel Hrdina <phrdina@redhat.com>
    
    Fix order of virPyDictToTypedParams hints
    This corresponds to the order in libvirt-domain.h header file.
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2018- 2- 19 Pavel Hrdina <phrdina@redhat.com>
    
    Use static variables to store virPyDictToTypedParams hints
    There is no need to have dynamic allocation every time the API
    is called.  Rewrites commit <314b2346df>.
    
    Reviewed-by: Daniel P. Berrangé <berrange@redhat.com>
    
    
 2018- 2- 19 Edgar Kaziakhmedov <edgar.kaziakhmedov@virtuozzo.com>
    
    Set hints for virPyDictToTypedParams
    Predefine hints for all parameters possible to avoid wrong type
    convert.
    
    
    
 2018- 2- 9 Daniel P. Berrangé <berrange@redhat.com>
    
    tests: add special case for virStoragePoolLookupByTargetPath
    This new API trips up the sanity test for checking mapping of
    all C APIs into Python.
    
    
    
 2018- 2- 6 Jiri Denemark <jdenemar@redhat.com>
    
    event-test.py: Remove extra ( in --help output
    
    
 2018- 1- 19 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-4.0.0
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Use python*_sitearch macros instead of manually defining the dir
    Note we use python_sitearch not python2_sitearch, since the former
    is more portable.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Fix filtering of RPM provides for .so files
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Require libvirt native version matching py version by default
    Although we're capable of building against any libvirt >= 0.9.11, 99% of the
    time we want RPM builds to be done against matching libvirt version, otherwise
    we might silently build against an unexpected/wrong version.
    
    We don't support building against a native libvirt that's newer than the
    python binding, since the generator may incorrectly handle new APIs. So use
    == instead of >= too.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Turn on python3 sub-RPMs for RHEL > 7
    It is expected that future RHEL-8 will have python3 by default, so enable that.
    It is unclear whether python2 will still be available, so leave that enabled
    for now.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Adapt to rename of py2 RPMs from python- to python2- prefix
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Add emacs mode marker to activate rpm-spec highlighting
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Add checks for min supported distros
    Be clear about which distros we aim to support with the specfile, so we know
    what we can cleanup in the spec later.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Allow override of which sub-RPMs to build
    Allow using
    
    rpmbuild --define "with_python2 0"
    
    to override the default logic about which python sub-RPMs to build
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2018- 1- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Allow disabling of python2 RPM build
    With Fedora modularity, it is possible to have add-on repos for multiple
    versions of python3. It is thus desirable to be able to build libvirt-python
    in these repos, with only the python3 sub-RPMs enabled.
    
    Thus also helps if future RHEL/Fedora drop python2 entirely from their default
    repos.
    
    Reviewed-by: Pavel Hrdina <phrdina@redhat.com>
    
    
 2017- 12- 11 Peng Hao <peng.hao2@zte.com.cn>
    
    libvirt-python : PyObject memory leak
    libvirt_virConnectDomainEventTunableCallback leak a PyObject.
    
    
    
 2017- 12- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 3.10.0
    
    
 2017- 11- 30 Cédric Bosdonnat <cbosdonnat@suse.com>
    
    Don't hardcode interpreter path
    This is particularly useful on operating systems that don't ship
    Python as part of the base system (eg. FreeBSD) while still working
    just as well as it did before on Linux.
    
    Reviewed-by: Daniel P. Berrange <berrange@redhat.com>
    
    
 2017- 11- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.9.0
    
    
 2017- 9- 29 Nir Soffer <nirsof@gmail.com>
    
    Unify whitespace around *_ALLOW_THREADS macros
    Most of the code treats libvirt API calls as separate block, keeping one
    blank line before the LIBVIRT_BEGIN_ALLOW_THREAD, and one blank line
    after LIBVIRT_END_ALLOW_THREADS. Unify the whitespace so all calls
    wrapped with these macros are treated as a separate block.
    
    
 2017- 9- 27 Nir Soffer <nirsof@gmail.com>
    
    Release the GIL during virDomainGetMemoryStats & virDomainGetDiskErrors
    We discovered that the entire python process get stuck for about 30
    seconds when calling virDomain.getMemoryStats() if libvirt is stuck in
    virConnect.getAllDomainStats() on inaccessible storage. This blocking
    cause a horrible mess in oVirt.
    
    This patches adds the standard *_ALLOW_THREADS around the call to avoid
    this unwanted blocking.
    
    
    
 2017- 9- 26 Daniel P. Berrange <berrange@redhat.com>
    
    Avoid implicit treatment of an arithmetic result as a boolean
    Latest GCC versions are unhappy with us treating an integer
    arithmetic result as a boolean:
    
    libvirt-utils.c: In function ‘virReallocN’:
    libvirt-utils.c:111:23: warning: ‘*’ in boolean context, suggest ‘&&’ instead [-Wint-in-bool-context]
    if (!tmp && (size * count)) {
    ~~~~~~^~~~~~~~
    
    Add an explicit comparison '!= 0' to keep it happy, since its
    suggestion to use '&&' is nonsense.
    
    
    
 2017- 9- 26 Daniel P. Berrange <berrange@redhat.com>
    
    Fix comparisons between signed & unsigned integers
    When python3 builds C modules, it adds the -Wsign-compare flag to GCC.
    This creates lots of warnings where we compare a 'size_t' value against
    an 'int' value due to signed/unsigned difference.  Change all the size_t
    types to ssize_t to address this.
    
    
    
 2017- 9- 26 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    libvirtaio: add .drain() coroutine
    The intended use is to ensure that the implementation is empty, which is
    one way to ensure that all connections were properly closed and file
    descriptors reclaimed.
    
    
    
 2017- 9- 26 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    libvirtaio: keep track of the current implementation
    Since 7534c19 it is not possible to register event implementation twice.
    Instead, allow for retrieving the current one, should it be needed
    afterwards.
    
    
    
 2017- 9- 26 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    libvirtaio: fix closing of the objects
    - Descriptor.close() was a dead code, never used.
    - TimeoutCallback.close(), as a cleanup function, should have called
    super() as last statement, not first
    
    
    
 2017- 9- 26 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    libvirtaio: do not double-add callbacks
    This was a harmless bug, without any impact, but it is wrong to manage
    the collection of callbacks from it's members.
    
    
    
 2017- 9- 26 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    libvirtaio: cache the list of callbacks when calling
    When the callback causes something that results in changes wrt
    registered handles, python aborts iteration.
    
    Relevant error message:
    
    Exception in callback None()
    handle: <Handle cancelled>
    Traceback (most recent call last):
    File "/usr/lib64/python3.5/asyncio/events.py", line 126, in _run
    self._callback(*self._args)
    File "/usr/lib64/python3.5/site-packages/libvirtaio.py", line 99, in _handle
    for callback in self.callbacks.values():
    RuntimeError: dictionary changed size during iteration
    
    QubesOS/qubes-issues#2805
    
    
 2017- 9- 26 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    libvirtaio: add more debug logging
    This logging is helpful for tracing problems with unclosed connections
    and leaking file descriptors.
    
    
    
 2017- 9- 19 Daniel P. Berrange <berrange@redhat.com>
    
    Add travis build config
    Enable builds on several python versions, and against several versions
    of libvirt. Ideally we would build all the way back to 0.9.11, since
    that is the min supported libvirt for python binding. It is not possible
    to build this old libvirt version on modern distros though, so using
    1.2.0 as the oldest for now.
    
    Reviewed-by: Martin Kletzander <mkletzan@redhat.com>
    
    
 2017- 9- 18 Daniel P. Berrange <berrange@redhat.com>
    
    Skip sparseRecvAll / sparseSendAll in sanity test
    The sanity test check aims to ensure that every function listed in
    the Python code maps to a corresponding C function. The Sparse
    send/recv methods are special though - we're never calling the
    corresponding C APIs, instead we have a pure python impl.
    
    
    
 2017- 9- 6 Daniel P. Berrange <berrange@redhat.com>
    
    Post-release version bump to 3.8.0
    
    
 2017- 9- 6 Daniel P. Berrange <berrange@redhat.com>
    
    Report an error if registering an event loop twice
    The C library will now ignore an attempt to register an event
    loop twice. It is unable to report an error in this case though
    due to the C API returning 'void'. To improve this we must
    manually report an error at the python level.
    
    
    
 2017- 9- 6 Daniel P. Berrange <berrange@redhat.com>
    
    Remove unused variables for event callbacks
    
    
 2017- 9- 4 Daniel P. Berrange <berrange@redhat.com>
    
    Change Obsoletes to an explicit version
    We only want to obsolete versions which actually had the
    original name, not all future versions.
    
    
    
 2017- 9- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 3.7.0
    * setup.py: updated for release
    
    
 2017- 8- 26 John Ferlan <jferlan@redhat.com>
    
    Implement virDomainMigrateGetMaxDowntime
    Add override code for virDomainMigrateGetMaxDowntime
    
    
 2017- 8- 26 John Ferlan <jferlan@redhat.com>
    
    Introduce virDomainMigrateGetMaxDowntime API
    Introduce wrapper for virDomainMigrateGetMaxDowntime
    
    
 2017- 8- 10 Daniel P. Berrange <berrange@redhat.com>
    
    Fix package name in description of sub-RPMs
    
    
 2017- 8- 10 Daniel P. Berrange <berrange@redhat.com>
    
    Revert "rpm: assume python3 is always available"
    This reverts commit b302b6d884ad4c6c917203a463f3377f3615b030.
    
    Only drop the Fedora 18 test - RHEL must still build without
    python 3
    
    
 2017- 8- 10 Daniel P. Berrange <berrange@redhat.com>
    
    rpm: rename packages to python2-libvirt / python3-libvirt
    This complies with Fedora naming policy for python packages
    
    Reviewed-by: Martin Kletzander <mkletzan@redhat.com>
    
    
 2017- 8- 10 Daniel P. Berrange <berrange@redhat.com>
    
    rpm: assume python3 is always available
    Reviewed-by: Martin Kletzander <mkletzan@redhat.com>
    
    
 2017- 8- 2 Tomáš Golembiovský <tgolembi@redhat.com>
    
    virDomainMemoryStats: include usable memory and last update
    We've forgot to include VIR_DOMAIN_MEMORY_STAT_USABLE and
    VIR_DOMAIN_MEMORY_STAT_LAST_UPDATE constants.
    
    
    
 2017- 8- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.6.0
    virtually identical to 3.5.0 except for the bump of version in setup.py
    
    
 2017- 7- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.5.0
    * setup.py: bump version number
    
    
 2017- 6- 20 Martin Kletzander <mkletzan@redhat.com>
    
    Add details for shutdown event
    In commit a8eba5036cb4b0e2ec827e9e6e019ce70e451377, libvirt added
    support for two more details.  In python bindings it all worked fine
    automagically except an example that was not updated.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1463188
    
    
    
 2017- 6- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.4.0
    
    
 2017- 5- 24 Daniel P. Berrange <berrange@redhat.com>
    
    Fix error check for virDomainGetTime method
    The virDomainGetTime returns either a dict or None, but the python
    glue layer for checking for '-1'. Thus it failed to raise an
    exception on error.
    
    
    
 2017- 5- 24 Michal Privoznik <mprivozn@redhat.com>
    
    examples: Introduce sparsestream.py
    Sparse streams are not that straight forward to use for the very
    first time. Especially the sparseRecvAll() and sparseSendAll()
    methods which expects callbacks. What we can do to make it easier
    for developers is to have an example where they can take an
    inspiration from.
    
    
    
 2017- 5- 24 Michal Privoznik <mprivozn@redhat.com>
    
    virStream: Introduce virStreamSparse{Recv,Send}All
    Yet again, our parser is not capable of generating proper
    wrapper. To be fair, this one wold be really tough anyway.
    
    
    
 2017- 5- 23 Michal Privoznik <mprivozn@redhat.com>
    
    virStream: Introduce virStreamRecvFlags
    Yet again, we need a custom wrapper over virStreamRecvFlags
    because our generator is not capable of generating it.
    
    
    
 2017- 5- 23 Michal Privoznik <mprivozn@redhat.com>
    
    Implement virStreamSendHole/virStreamRecvHole
    The return value for virStreamRecvHole is slightly different to
    its C counterpart. In python, either it returns the hole size or
    None if C API fails.
    
    
    
 2017- 5- 17 Xavier Fernandez <xav.fernandez@gmail.com>
    
    Use better comparison in virStream.sendAll for Python 3
    In Python 3, if the file is open in binary mode, @got will end up
    being equal to b"" and b"" != "" in Python 3.
    
    
 2017- 5- 15 Martin Kletzander <mkletzan@redhat.com>
    
    spec: Install egg-info with rpm package
    This was being done due to now deprecated policy and that file should
    be installed so that pip can recognize that the packages is already
    installed in the system.
    
    
    
 2017- 5- 5 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.3.0
    
    
 2017- 4- 4 Daniel P. Berrange <berrange@redhat.com>
    
    event-test: add ability to run the asyncio event loop
    The event test program '--loop' arg is modified to take the name
    of an event loop impl to run. eg 'event-test.py --loop asyncio'
    
    
    
 2017- 4- 4 Daniel P. Berrange <berrange@redhat.com>
    
    event-test: rename example event loop impl
    Use the name 'Poll' instead of 'Pure' for the event loop demo,
    since there's now a second pure python loop impl available.
    
    
    
 2017- 4- 4 Daniel P. Berrange <berrange@redhat.com>
    
    event-test: unregister callbacks & close conn on exit
    In order to test cleanup code paths we must unregister all callbacks
    and close the connection on shutdown. Since cleanup happens in the
    background, we do a short sleep to allow the main loop to run its
    cleanup too.
    
    
    
 2017- 4- 4 Daniel P. Berrange <berrange@redhat.com>
    
    event-test: add timeout to exit event loop
    
    
 2017- 4- 4 Daniel P. Berrange <berrange@redhat.com>
    
    event-test: free opaque data when removing callbacks
    The pure python event loop impl has to call
    
    libvirt.virEventInvokeFreeCallback
    
    to free the event opaque data from a clean stack context
    
    
    
 2017- 4- 4 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    Add asyncio event loop implementation
    This is usable only on python >= 3.4 (or 3.3 with out-of-tree asyncio),
    however it should be harmless for anyone with older python versions.
    
    In simplest case, to have the callbacks queued on the default loop:
    
    >>> import libvirtaio
    >>> libvirtaio.virEventRegisterAsyncIOImpl()
    
    The function is not present on non-compatible platforms.
    
    
    
 2017- 4- 4 Wojtek Porczyk <woju@invisiblethingslab.com>
    
    Allow for ff callbacks to be called by custom event implementations
    The documentation says:
    > If the opaque user data requires free'ing when the handle is
    > unregistered, then a 2nd callback can be supplied for this purpose.
    > This callback needs to be invoked from a clean stack. If 'ff'
    > callbacks are invoked directly from the virEventRemoveHandleFunc they
    > will likely deadlock in libvirt.
    
    And they did deadlock. In removeTimeout too. Now we supply a custom
    function to pick it from the opaque blob and fire.
    
    
    
 2017- 4- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.2.0
    * setup.py: bumped version
    
    
 2017- 3- 29 Peter Krempa <pkrempa@redhat.com>
    
    event: Add handler for block threshold event
    Unfortunately python doesn't generate those.
    
    
 2017- 3- 29 Peter Krempa <pkrempa@redhat.com>
    
    event: fix comment for _dispatchDomainEventMetadataChangeCallback
    The comment was copied from the device removal failed event.
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'functions_list_exception_test' code from generator
    The 'functions_list_exception_test' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'converter_type' code from generator
    The 'converter_type' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'classes_ancestor' code from generator
    The 'classes_ancestor' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'py_return_types' code from generator
    The 'py_return_types' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'foreign_encoding_args' code from generator
    The 'foreign_encoding_args' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'function_post' code from generator
    The 'function_post' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Removed unused 'reference_keepers' code from generator
    The 'reference_keepers' data structure and associated code
    in the generator is inherited from libxml. This has never
    been used in libvirt, so delete it to simplify the generator.
    
    
    
 2017- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Protect against user accidentally calling constructors directly
    When using libvirt python you must never call the object
    constructors directly, as these are expecting to be passed
    a wrapped C object. For example
    
    import libvirt
    c = libvirt.virConnect("qemu:///system")
    c.listAllDomains()
    
    will mysteriously segfault. With this change the user now
    gets an slightly more helpful error
    
    Traceback (most recent call last):
    File "<stdin>", line 1, in <module>
    File "/home/berrange/src/virt/libvirt-python/build/libvirt.py", line 3409, in __init__
    raise Exception("Expected a wrapped C Object but got %s" % type(_obj))
    Exception: Expected a wrapped C Object but got <type 'str'>
    
    
    
 2017- 1- 18 Wu Zongyong <wuzongyo@mail.ustc.edu.cn>
    
    Fix the incorrect memory freeing which will result in crash
    Commit id '71fd95409' neglected to adjust a couple of API's do that now.
    
    The number of elements in new_params is equal to the length of info,
    instead of nparams, so it's wrong to free new_params using nparams.
    
    
    
 2017- 1- 18 John Ferlan <jferlan@redhat.com>
    
    Post-release version bump to 3.1.0
    
    
 2017- 1- 17 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-3.0.0
    
    
 2017- 1- 10 Michal Privoznik <mprivozn@redhat.com>
    
    examples: Update event-test.py
    With recent changes there are new events known to libvirt.
    Reflect those changes in our event-test.py example script.
    
    
    
 2017- 1- 10 Daniel P. Berrange <berrange@redhat.com>
    
    Fix typos in previous secrets event patch
    
    
 2017- 1- 9 Daniel P. Berrange <berrange@redhat.com>
    
    Add support for domain metadata change event
    
    
 2017- 1- 9 Daniel P. Berrange <berrange@redhat.com>
    
    Add support for secret event APIs
    
    
 2016- 12- 21 Daniel P. Berrange <berrange@redhat.com>
    
    Add override impl for virStorageVolGetInfoFlags
    
    
 2016- 12- 21 Daniel P. Berrange <berrange@redhat.com>
    
    Remove bogus \o escape in regex
    One of the regexes has a bogus \o instead of plain 'o'. Somehow
    this magically worked on all versions of python, until 3.6 came
    along and complained
    
    
    
 2016- 12- 14 Daniel P. Berrange <berrange@redhat.com>
    
    Fix running of nosetests on python 3
    Previously the way Fedora installed /usr/bin/nosetests allowed it
    to be invoked with either python 2 or 3. Since Fedora 25 though,
    it contains a module name that only exists on python 2. So we need
    to be more intelligent and pick a different nosetests binary per
    version.
    
    
    
 2016- 12- 13 Prabodh Agarwal <prabodh1194@users.noreply.github.com>
    
    HACKING: fix grammar
    
    
 2016- 12- 5 Daniel P. Berrange <berrange@redhat.com>
    
    Fill out more fields for PKG-INFO file
    Ensure the description and license are set in PKG-INFO,
    and clarify the summary field.
    
    
    
 2016- 11- 11 Konstantin Neumoin <kneumoin@virtuozzo.com>
    
    don't overrun buffer when converting cpumap
    If we pass large(more than cpunum) cpu mask to any libvirt_virDomainPin*
    function, it could leads to crash. So we have to check tuple size in
    virPyCpumapConvert and ignore extra tuple members.
    
    Since we allocate a zeroed buffer, we don't need to bother with setting
    the bits to zero.
    
    
    
 2016- 11- 11 Konstantin Neumoin <kneumoin@virtuozzo.com>
    
    move cpumap conversion code to a common helper
    All libvirt_virDomainPin* functions do the same thing for convert
    pycpumap to cpumap, so this patch moves all common logic to new
    helper - virPyCpumapConvert.
    
    
    
 2016- 11- 2 Pavel Hrdina <phrdina@redhat.com>
    
    Post-release version bump to 2.5.0
    
    
 2016- 11- 1 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-2.4.0
    * setup.py: just bumped up the release number
    
    
 2016- 9- 19 Peter Krempa <pkrempa@redhat.com>
    
    override: Properly override wrapper for virDomainGetGuestVcpus
    Without the change to libvirt-override-api.xml generator.py would
    generate the following function header:
    
    def guestVcpus(self, params, nparams, flags=0):
    
    Since @params and @nparams are output-only in C and the python C
    implementation actualy creates a dict from them we should not need to
    pass them. Add the API definition to drop the two unnecessary args:
    
    def guestVcpus(self, flags=0):
    
    The code did not work at all until this change as the C impl expects
    only two arguments but the python required use of four.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1377071
    
    
 2016- 9- 19 Peter Krempa <pkrempa@redhat.com>
    
    Post-release version bump to 2.3.0
    
    
 2016- 8- 24 Michal Privoznik <mprivozn@redhat.com>
    
    PyArg_ParseTuple: Provide correct function names
    At the end of the format string we put :virFunctionName where ':'
    says "this is the end of argument list", and virFunctionName is
    the prefix for error messages then.  However, in some cases we
    have had wrong names there. Some of them are actually quite
    funny: xmlRegisterErrorHandler.
    
    
    
 2016- 8- 17 Jovanka Gulicoska <jovanka.gulicoska@gmail.com>
    
    event-test: support node device update callback
    
    
 2016- 8- 17 Jovanka Gulicoska <jovanka.gulicoska@gmail.com>
    
    Add support for node device update callback
    
    
 2016- 8- 2 Jovanka Gulicoska <jovanka.gulicoska@gmail.com>
    
    event-test: Add node device lifecycle event tests
    
    
 2016- 8- 2 Jovanka Gulicoska <jovanka.gulicoska@gmail.com>
    
    Python binding for node poll lifecycle events API
    
    
 2016- 8- 2 Cole Robinson <crobinso@redhat.com>
    
    Post-release version bump to 2.2.0
    
    
 2016- 7- 28 Markus Rothe <markusr815@gmail.com>
    
    allow pkg-config binary to be set by env
    https://bugzilla.redhat.com/show_bug.cgi?id=1350523
    
    
 2016- 7- 25 Pavel Hrdina <phrdina@redhat.com>
    
    Post-release version bump to 2.1.0
    
    
 2016- 7- 23 Pavel Hrdina <phrdina@redhat.com>
    
    Fix crash in storage pool refresh callback
    Fixes copy-paste typo introduced by commit cb84e36c.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1354271
    
    
    
 2016- 6- 24 Daniel P. Berrange <berrange@redhat.com>
    
    Add support for storage pool refesh callback
    
    
 2016- 6- 24 Daniel P. Berrange <berrange@redhat.com>
    
    Fix signedness of arg to virDomainGetGuestVcpus
    
    
 2016- 6- 23 Michal Privoznik <mprivozn@redhat.com>
    
    Add support for virDomainGetGuestVcpus
    This function has virTypedParameterPtr as one of the args and our
    generator is unable to deal with that. Therefore we must provide
    implementation.
    
    
    
 2016- 6- 16 Jovanka Gulicoska <jovanka.gulicoska@gmail.com>
    
    event-test: Add storage pool lifecycle event tests
    
    
 2016- 6- 16 Jovanka Gulicoska <jovanka.gulicoska@gmail.com>
    
    Python binding for storage pool lifecycle events API
    Code matches the network event API implementation
    
    
 2016- 6- 14 Daniel P. Berrange <berrange@redhat.com>
    
    Post-release version bump to 2.0.0
    
    
 2016- 6- 4 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-1.3.5
    * setup.py: bumped to 1.3.5, the release is virtually identical to 1.3.4
    
    
 2016- 4- 21 Peter Krempa <pkrempa@redhat.com>
    
    generator.py: Consider symbols from libvirt-common
    Some of the libvirt public API was moved into the libvirt-common.h file.
    We should consider it while building python too.
    
    
 2016- 4- 20 Cole Robinson <crobinso@redhat.com>
    
    spec: Don't pull in dependencies for example scripts
    If the scripts are marked as executable, RPM magic will scan them
    for dependencies, which can pull in python2 for the python3 package
    
    
 2016- 4- 18 Pavel Hrdina <phrdina@redhat.com>
    
    fix crash in getAllDomainStats
    Commits 1d39dbaf and 827ed9b4 broke the libvirt-python API by removing
    virDomainRef() and virDomainFree().  virDomainStatsRecordListFree() will
    free that domain pointer and later when virDomain (python object) call
    its destructor and tries to free that same pointer again.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1326839
    
    
    
 2016- 4- 18 Peter Krempa <pkrempa@redhat.com>
    
    event: Add support VIR_DOMAIN_EVENT_ID_DEVICE_REMOVAL_FAILED
    
    
 2016- 4- 18 Peter Krempa <pkrempa@redhat.com>
    
    Post-release version bump to 1.3.4
    
    
 2016- 4- 6 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-1.3.3
    
    
 2016- 3- 31 Qiaowei Ren <qiaowei.ren@intel.com>
    
    python: add python binding for Perf API
    This patch adds the python binding for virDomainSetPerfEvents and
    virDomainSetPerfEvents API.
    
    
    
 2016- 3- 8 Jiri Denemark <jdenemar@redhat.com>
    
    Add support for JOB_COMPLETED event
    
    
 2016- 2- 23 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-override: fix PyArg_ParseTuple for size_t
    Format string uses 'n' for Py_ssize_t but size_t is unsigned long, we
    need to use 'k'.
    
    
    
 2016- 2- 23 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-override: fix PyArg_ParseTuple for unsigned long long
    Format string uses 'L' for long long type and 'K' for unsigned long long
    type.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1260356
    
    
    
 2016- 2- 23 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-override: fix PyArg_ParseTuple for unsigned int
    Format string uses 'i' for int type and 'I' for unsigned int type.
    
    
    
 2016- 2- 23 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-override: all flags should be defined as unsigned int
    
    
 2016- 1- 18 Jiri Denemark <jdenemar@redhat.com>
    
    Add support for MIGRATION_ITERATION event
    
    
 2016- 1- 18 Jiri Denemark <jdenemar@redhat.com>
    
    setup: Use cflags and ldflags properly
    The setup.py script reads cflags and ldflags from pkg-config and uses
    them when compiling/linking C modules. Since both cflags and ldflags may
    include multiple compiler arguments we need to split them rather than
    concatenating them into a single argument.
    
    
    
 2016- 1- 18 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 1.3.2
    
    
 2016- 1- 17 Daniel Veillard <veillard@redhat.com>
    
    Version bump to 1.3.1
    For release but no change from 1.3.0
    
    
 2015- 11- 24 Pavel Hrdina <phrdina@redhat.com>
    
    Post-release version bump to 1.3.0
    
    
 2015- 10- 31 Pavel Hrdina <phrdina@redhat.com>
    
    fix crash introduced by commit 1d39dbaf
    Some of the libvirt_*Wrap functions steals the reference and we need to
    set the item in array to NULL no not free it on success.  Those three
    places was accidentally removed by commit 1d39dbaf.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1270977
    
    
    
 2015- 10- 15 Martin Kletzander <mkletzan@redhat.com>
    
    Post-release version bump to 1.2.21
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    use VIR_PY_DICT_SET_GOTO
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    use VYR_PY_LIST_SET_GOTO and VIR_PY_LIST_APPEND_GOTO
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    use VIR_PY_TUPLE_GOTO
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    utils: introduce new macro helpers for tuple, list and dict objects
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    improve usage of cleanup paths
    This removes several code duplicates and also some unusual code structures.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    drop unnecessary py_retval variable
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    change the order of some statements
    This change makes it easier to free allocated object especially for
    python objects.  We can benefit from the fact, that if you call
    Py_DECREF on any python object it will also remove reference for all
    assigned object to the root object.  For example, calling Py_DECREF on
    dict will also remove reference recursively on all elements in that
    dictionary.  Our job is then just call Py_DECREF on the root element and
    don't care about anything else.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    Must check return value for all Py*_New functions
    If the function fails, we need to cleanup memory and return NULL.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    use Py_CLEAR instead of Py_XDECREF followed by NULL assignment
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    Use VIR_PY_NONE instead of increment and Py_None
    To insert Py_None into some other python object like dict or tuple, you
    need to increase reference to the Py_None.  We have a macro to do that.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    Return NULL and set an exception if allocation fails
    This is a recommended work-flow for allocation failures and we should
    follow it.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    Return correct python object
    In case of error without setting an python exception we need to return
    a correct python object.  For functions that returns anything else than
    a number the return value is 'None', otherwise it's '-1'.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    Return NULL if python exception is set
    There is a rule, python API fails, it also in those cases sets an
    exception.  We should follow those rules and in those cases return NULL.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    wrap lines to 80 columns
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    fix indentation
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    indent labels by one space
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    cleanup functions definition
    Follow the libvirt hacking guide and make the code consistent.
    
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    Move utils and shared code into libvirt-utils
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    drop unnecessary goto
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    remove useless check for NULL before Py_XDECREF
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    refactor the function to not override python exceptions
    
    
 2015- 10- 5 Pavel Hrdina <phrdina@redhat.com>
    
    update virDomainGetVcpus xml API description
    Python api returns a tuple with the vcpus information.
    
    
    
 2015- 10- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-1.2.20
    
    
 2015- 9- 21 Luyao Huang <lhuang@redhat.com>
    
    generator: fix build fail with old xml lib
    https://bugzilla.redhat.com/show_bug.cgi?id=1222795#c6
    
    if build libvirt-python with some old xml lib (python-pyxml),
    build will fail and error like this:
    
    File "generator.py", line 139, in start
    if "string" in attrs:
    File "/usr/local/lib/python2.7/site-packages/_xmlplus/sax/xmlreader.py" \
    , line 316, in __getitem__
    return self._attrs[name]
    KeyError: 0
    
    This is an old issue and have been mentioned in commit 3ae0a76d.
    There is no __contains__ in class AttributesImpl, python will use
    __getitem__ in this place, so we will get error.
    Let's use 'YYY in XXX.keys()' to avoid this issue.
    
    
    
 2015- 8- 26 Luyao Huang <lhuang@redhat.com>
    
    examples: small fix for nodestats.py example
    Add nodestats.py in MANIFEST.in and add a
    small description for nodestats.py in README
    
    
    
 2015- 8- 3 Jiri Denemark <jdenemar@redhat.com>
    
    Check return value of PyList_Append
    libvirt_virDomainGetSecurityLabelList called PyList_Append without
    checking its return value. While looking at it I noticed the function
    did not properly check several other return values either so I fixed
    them all.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1249511
    
    
    
 2015- 8- 3 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 1.2.19
    
    
 2015- 8- 3 Daniel Veillard <veillard@redhat.com>
    
    Forgot to bump version to 1.2.18
    
    
 2015- 7- 30 Peter Krempa <pkrempa@redhat.com>
    
    iothread: Fix crash if virDomainGetIOThreadInfo returns error
    The cleanup portion of libvirt_virDomainGetIOThreadInfo would try to
    clean the returned structures but the count of iothreads was set to -1.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1248295
    
    
 2015- 7- 17 Michal Privoznik <mprivozn@redhat.com>
    
    examples: Introduce nodestats example
    So, this is an exercise to show libvirt capabilities. Firstly, for
    each host NUMA nodes some statistics are printed out, i.e. total
    memory and free memory. Then, for each running domain, that has memory
    strictly bound to certain host nodes, a small statistics of how much
    memory it takes is printed out too. For instance:
    
    # ./examples/nodestats.py
    NUMA stats
    NUMA nodes:     0       1       2       3
    MemTotal:       3950    3967    3937    3943
    MemFree:        66      56      42      41
    Domain 'fedora':
    Overall memory: 1536 MiB
    Domain 'fedora22':
    Overall memory: 2048 MiB
    Domain 'fedora21':
    Overall memory: 1024 MiB nodes 0-1
    Node 0: 1024 MiB nodes 0-1
    Domain 'gentoo':
    Overall memory: 4096 MiB nodes 0-3
    Node 0: 1024 MiB nodes 0
    Node 1: 1024 MiB nodes 1
    Node 2: 1024 MiB nodes 2
    Node 3: 1024 MiB nodes 3
    
    We can see 4 host NUMA nodes, all of them having roughly 4GB of RAM.
    Yeah, all of them has nearly all the memory consumed. Then, there are
    four domains running. For instance, domain 'fedora' has 1.5GB memory
    which is not pinned onto any specific host NUMA node. Domain 'gentoo' on
    the other hand has 4GB memory and has 4 NUMA nodes which are pinned 1:1
    to host nodes.
    
    
    
 2015- 6- 29 Pavel Boldin <pboldin@mirantis.com>
    
    virPyDictToTypedParams: packing lists of values
    Pack a list or a tuple of values passed to a Python method to the
    multi-value parameter.
    
    
 2015- 6- 28 Martin Kletzander <mkletzan@redhat.com>
    
    Revert "Change livbirt version to 1.3.0 for the next release"
    This reverts commit 751e016f09a6a0dd372667bdd2b322731718e359.
    
    Since Admin API was deferred for a release and the minor version bump
    didn't happen, it must not happen in libvirt-python either, for
    compatibility reasons.
    
    
 2015- 6- 16 Martin Kletzander <mkletzan@redhat.com>
    
    Change livbirt version to 1.3.0 for the next release
    Since the background for Admin API is merged upstream, we are bumping
    the minor release version as discussed previously
    
    
    
 2015- 6- 8 Jiri Denemark <jdenemar@redhat.com>
    
    Provide symbolic names for typed parameters
    https://bugzilla.redhat.com/show_bug.cgi?id=1222795
    
    
    
 2015- 6- 5 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 1.2.17
    
    
 2015- 6- 1 Daniel P. Berrange <berrange@redhat.com>
    
    Include tests in MANIFEST
    The unit tests were missing from the tar.gz archives due to not
    being listed in the MANIFEST.in file
    
    
    
 2015- 5- 28 Jim Fehlig <jfehlig@suse.com>
    
    Fix duplicate entries in AUTHORS
    The generated AUTHORS file contains many duplicates.  If an author
    has N commits, there will be N entries for the author in AUTHORS.
    Check if an author already exists in the list before appending.
    While at it, add a .mailmap (derived from libivrt's .mailmap) to
    futher tidy the generated AUTHORS list.
    
    
 2015- 5- 20 Guido Günther <agx@sigxcpu.org>
    
    Sort tuples on both items
    In order to achieve reproducible builds[0] we want the items within
    enums always generated in the same order so sort on both items in the
    tuple.
    
    [0] https://wiki.debian.org/ReproducibleBuilds/About
    
    
 2015- 5- 20 Guido Günther <agx@sigxcpu.org>
    
    Simplify sorting
    funcs.keys() can't be None, only the empty array
    
    
 2015- 5- 20 Guido Günther <agx@sigxcpu.org>
    
    Sort dictionary keys
    In order to achive reproducible builds[0] we want functions and enums
    always generated in the same order.
    
    [0] https://wiki.debian.org/ReproducibleBuilds/About
    
    
 2015- 5- 11 Peter Krempa <pkrempa@redhat.com>
    
    examples: Add example to make guest agent lifecycle event useful
    This example allows to use the guest agent event and metadata to track
    vCPU count set via the guest agent (agent-based onlining/offlining) and
    keep it persistent accross domain restarts.
    
    The daemon listens for the agent lifecycle event, and if it's received
    it looks into doman's metadata to see whether a desired count was set
    and issues the guest agent command.
    
    
 2015- 5- 11 Peter Krempa <pkrempa@redhat.com>
    
    Post-release version bump to 1.2.16
    
    
 2015- 4- 22 Victor Stinner <victor.stinner@gmail.com>
    
    libvirt-python: add classifiers to setup.py
    Add the Python 3 classifier, needed by the caniusepython3 tool to check
    if dependencies of a projects are Python 3 compatible:
    
    https://caniusepython3.com/
    
    
 2015- 4- 22 Victor Stinner <victor.stinner@gmail.com>
    
    Add tox.ini to run tests on Python 2.6, 2.7 & 3.4
    
    
 2015- 4- 22 Victor Stinner <victor.stinner@gmail.com>
    
    sanitytest.py parameters are now optional
    When called without parameters, sanitytest.py doesn't touch sys.path and
    locates itself the patch to the libvirt-api.xml file using pkg-config.
    
    This change makes possible to run sanitytest.py from tox.
    
    
 2015- 4- 15 Ján Tomko <jtomko@redhat.com>
    
    Implement the DEVICE_ADDED event
    
    
 2015- 4- 2 Jiri Denemark <jdenemar@redhat.com>
    
    Post-release version bump to 1.2.15
    
    
 2015- 3- 28 Pavel Hrdina <phrdina@redhat.com>
    
    Expose virDomainInterfacesAddresses to python binding
    examples/Makefile.am:
    * Add new file domipaddrs.py
    
    examples/README:
    * Add documentation for the python example
    
    libvirt-override-api.xml:
    * Add new symbol for virDomainInterfacesAddresses
    
    libvirt-override.c:
    * Hand written python api
    
    Example:
    $ python examples/domipaddrs.py qemu:///system f18
    Interface  MAC address          Protocol     Address
    vnet0      52:54:00:20:70:3d    ipv4         192.168.105.240/16
    
    
    
 2015- 3- 26 Ján Tomko <jtomko@redhat.com>
    
    Rename virDomainGetIOThreadsInfo to virDomainGetIOThreadInfo
    
    
 2015- 3- 26 Ján Tomko <jtomko@redhat.com>
    
    Rename virDomainIOThreadsInfoFree to virDomainIOThreadInfoFree
    
    
 2015- 3- 19 Pavel Hrdina <phrdina@redhat.com>
    
    Post-release version bump to 1.2.14
    
    
 2015- 3- 11 John Ferlan <jferlan@redhat.com>
    
    Support virDomainPinIOThread
    Support the libvirt_virDomainSetIOThreads method using code that mimics
    the existing libvirt_virDomainPinVcpuFlags method
    
    The following is a sample session assuming guest 'iothr-gst' has IOThreads
    configured (it's currently running, too)
    
    >>> import libvirt
    >>> con=libvirt.open("qemu:///system")
    >>> dom=con.lookupByName('iothr-gst')
    >>> dom.ioThreadsInfo()
    [(1, [False, False, True, False]), (2, [False, False, False, True]), (3, [True, True, True, True])]
    >>> cpumap=(True,True,True,False)
    >>> dom.pinIOThread(3,cpumap)
    0
    >>> print dom.ioThreadsInfo()
    [(1, [False, False, True, False]), (2, [False, False, False, True]), (3, [True, True, True, False])]
    >>>
    
    merge
    
    
 2015- 3- 11 John Ferlan <jferlan@redhat.com>
    
    Support virDomainGetIOThreadsInfo and virDomainIOThreadsInfoFree
    Add support for the libvirt_virDomainGetIOThreadsInfo method. This
    code mostly follows the libvirt_virDomainGetVcpuPinInfo method, but
    also takes some from the libvirt_virNodeGetCPUMap method with respect
    to building the cpumap into the returned tuple rather than two separate
    tuples which vcpu pinning generates
    
    Assuming two domains, one with IOThreads defined (eg, 'iothr-gst') and
    one without ('noiothr-gst'), execute the following in an 'iothr.py' file:
    
    import libvirt
    con=libvirt.open("qemu:///system")
    dom=con.lookupByName('iothr-gst')
    print dom.ioThreadsInfo()
    dom2=con.lookupByName('noiothr-gst')
    print dom2.ioThreadsInfo()
    
    $ python iothr.py
    [(1, [False, False, True, False]), (2, [False, False, False, True]), (3, [True, True, True, True])]
    []
    $
    
    
 2015- 3- 5 Ján Tomko <jtomko@redhat.com>
    
    Clarify description for virNodeGetSecurityModel
    s/host/hypervisor/ to match the wording used by the C binding.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1198518
    
    
 2015- 1- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Post-release version bump to 1.2.13
    
    
 2015- 1- 19 Pavel Hrdina <phrdina@redhat.com>
    
    sanitytest: fix mapping test for virDomainDefineXMLFlags
    The libvirt API has in the name "virDomain" but it's correctly mapped
    into "virConnect" class. Create an exception in the sanity test.
    
    
    
 2015- 1- 15 Eric Blake <eblake@redhat.com>
    
    build: make it easier to backport event ids
    In some cases, it is very easy for downstream distros to backport
    enum values without requiring a .so bump.  Keying the conditional
    code off of the upstream version where the enum value was added
    is not ideal, because downstream then has to patch that the feature
    is available in their build that still reports an earlier version
    number.  For example, if RHEL 7 backports events from 1.2.11 into
    a build based on 1.2.8, building the python bindings would warn:
    
    libvirt-override.c: In function ‘libvirt_virConnectDomainEventRegisterAny’:
    libvirt-override.c:6653:5: warning: enumeration value ‘VIR_DOMAIN_EVENT_ID_TUNABLE’ not handled in switch [-Wswitch]
    switch ((virDomainEventID) eventID) {
    ^
    libvirt-override.c:6653:5: warning: enumeration value ‘VIR_DOMAIN_EVENT_ID_AGENT_LIFECYCLE’ not handled in switch [-Wswitch]
    
    The solution is simple - use feature-based probes instead of
    version probes.  Since we already scrape the XML API document of
    whatever libvirt build we are binding, and that XML already
    documents any downstream enum additions, we can use those as the
    features for gating conditional compilation.
    
    * generator.py (enum): Track event id names.
    (buildStubs): Output define wrappers for events.
    * libvirt-override.c
    (libvirt_virConnectDomainEventBalloonChangeCallback)
    (libvirt_virConnectDomainEventPMSuspendDiskCallback)
    (libvirt_virConnectDomainEventDeviceRemovedCallback)
    (libvirt_virConnectDomainEventTunableCallback)
    (libvirt_virConnectDomainEventAgentLifecycleCallback)
    (libvirt_virConnectDomainEventRegisterAny): Use them.
    
    
    
 2014- 12- 16 Michal Privoznik <mprivozn@redhat.com>
    
    Bump version to 1.2.12 for new dev cycle
    
    
 2014- 12- 11 Richard W.M. Jones <rjones@redhat.com>
    
    Add c_pointer method to classes.
    This returns the raw C pointer to the underlying object, eg:
    
    conn = libvirt.open(None)
    print "0x%x" % conn.c_pointer()   # returns virConnectPtr of the connection
    dom = conn.lookupByName("test")
    print "0x%x" % dom.c_pointer()    # returns virDomainPtr of the domain
    
    The reason behind this is to allow us to transparently pass Python dom
    objects through the libguestfs Python API.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1075164
    
    
 2014- 12- 2 Tomoki Sekiyama <tomoki.sekiyama@hds.com>
    
    override: iterate virDomainFSInfo.devAliases using ndevAliases
    Currently devAliases in virDomainFSInfo struct are iterated as a
    NULL-terminated list, but that is not guaranteed. It should use
    ndevAliases which stores the number of the items in devAliases.
    
    
    
 2014- 12- 1 Pavel Hrdina <phrdina@redhat.com>
    
    fix examples
    The dhcpleases example had an old usage of print function. The formating
    of leases record was also wrong.
    
    The event-test example had an old usage of exceptions.
    
    It's mainly to make examples compatible with python3.
    
    
    
 2014- 11- 24 Peter Krempa <pkrempa@redhat.com>
    
    event: Add bindings for agent lifecycle event
    Also add the example.
    
    
 2014- 11- 24 Tomoki Sekiyama <tomoki.sekiyama@hds.com>
    
    override: Implement bindings for virDomainGetFSInfo as domain.fsInfo
    Implement the function which returns a list of tuples, that contains members
    of virDomainFSInfo struct.
    
    
    
 2014- 11- 11 Luyao Huang <lhuang@redhat.com>
    
    Add dict check for setTime and allow pass 'seconds' parameter
    When pass None or a empty dictionary to time, it will report
    error. This commit allows a one-element dictionary which contains
    just 'seconds' field, which results in the same as passing 0 for
    'nseconds' field. Moreover, dict is checked for unknown fields.
    
    
    
 2014- 11- 6 Jiri Denemark <jdenemar@redhat.com>
    
    Check return value of libvirt_uintUnwrap
    libvirt_virDomainSendKey didn't check whether libvirt_uintUnwrap
    succeeded or not.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1161039
    
    
 2014- 11- 3 John Ferlan <jferlan@redhat.com>
    
    Bump version to 1.2.11 for new dev cycle
    
    
 2014- 10- 28 Dmitry Guryanov <dguryanov@parallels.com>
    
    fix libvirt headers list
    Since libvirt.h has been split out, generator.py
    should be fixed accordingly. So add full list of header
    files.
    
    
    
 2014- 10- 22 Pavel Hrdina <phrdina@redhat.com>
    
    virDomainBlockCopy: initialize flags to 0
    An optional argument if not passed isn't modified by the
    PyArg_ParseTuple function.
    
    
    
 2014- 10- 22 Pavel Hrdina <phrdina@redhat.com>
    
    flags cannot get right value for blockCopy function
    When use blockCopy, flags cannot get a right value, because
    PyArg_ParseTuple want to get 6 parameters and blockCopy only
    pass 5. Flags will get a unpredictable value, this will make
    the function fail with error:
    
    unsupported flags (0x7f6c) in function qemuDomainBlockCopy
    
    
    
 2014- 10- 22 Peter Krempa <pkrempa@redhat.com>
    
    Fix rest of unsigned integer handling
    As in the previous patch, fix all places where 'flags' is converted as a
    signed argument to unsigned including the python code generator.
    
    
 2014- 10- 22 Luyao Huang <lhuang@redhat.com>
    
    Fix parsing of 'flags' argument for bulk stats functions
    When 'flags' is set to
    'libvirt.VIR_CONNECT_GET_ALL_DOMAINS_STATS_ENFORCE_STATS,
    python will report a  error:
    
    OverflowError: signed integer is greater than maximum
    
    as VIR_CONNECT_GET_ALL_DOMAINS_STATS_ENFORCE_STATS is defined as 1<<31.
    This happens as PyArg_ParseTuple's formatting string containing 'i' as a
    modifier expects a signed integer.
    
    With python >= 2.3, 'I' means unsigned int and 'i' means int so we
    should use 'I' in the formatting string.
    
    See: https://docs.python.org/2/c-api/arg.html
    
    
    
 2014- 10- 22 Peter Krempa <pkrempa@redhat.com>
    
    Fix function name when parsing arguments in libvirt_virNodeAllocPages
    The override function was copied&pasted from virConnectGetAllDomainStats
    and the function name after the colon was not changed. Fix the issue as
    an invalid name would appear in the error message.
    
    
 2014- 10- 20 Luyao Huang <lhuang@redhat.com>
    
    Improve error output when use getTime with a nonzero flags.
    When give a nonzero flags to getTime, c_retval will get -1 and goto
    cleanup. But py_retval still is NULL, so set py_retval =  VIR_PY_NONE.
    This will make the output message more correct.
    
    
    
 2014- 10- 16 Pradipta Kr. Banerjee <pradipta.banerjee@gmail.com>
    
    Change the comment in getPyNodeCPUCount method reflecting correct called methods
    Comment mentions virGetNodeCPUMap whereas the actual method is
    virNodeGetCPUMap. Similarly comment mentions virGetNodeInfo whereas the actual
    method is virNodeGetInfo
    
    
    
 2014- 10- 7 Pavel Hrdina <phrdina@redhat.com>
    
    setup.py: fix rpm build to return 1 on error
    
    
 2014- 10- 7 Martin Kletzander <mkletzan@redhat.com>
    
    sanitytest: define long for python version >= 3
    Commit c58c7f362aab37e4961407c2efc8a74925ed9c37 fixed 32-bit python
    build but broke build with python3 due to the lack of 'long' in the
    newer version of python.  This patch aims to fix it with a simple
    string comparison of sys.version and '3'.
    
    
    
 2014- 10- 7 Martin Kletzander <mkletzan@redhat.com>
    
    sanitytest: count with the fact that large enums can be long
    On 32-bit systems, one new flag that has the value of 1 << 31, namely
    VIR_CONNECT_GET_ALL_DOMAINS_STATS_ENFORCE_STATS, fails to fit into an
    'int' on python and is therefore of type 'long'.  Fix sanitytest to
    count with such fact in order to avoid build failures on 32-bit systems.
    
    
    
 2014- 10- 6 Martin Kletzander <mkletzan@redhat.com>
    
    sanitytest: check for exported enums
    We are already collecting list of enums exported and list of enums we
    want to have available.  Event though there was an issue with one enum
    fixed with 014d9bbaf368b33a881f1d6b2fd8a5dd285a4f71, there was no test
    for it and this commit tries to fix that.
    
    
    
 2014- 10- 2 Pavel Hrdina <phrdina@redhat.com>
    
    Post-release version bump for new dev cycle
    
    
 2014- 9- 30 Pavel Hrdina <phrdina@redhat.com>
    
    implement new tunable event
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1147639
    
    
    
 2014- 9- 26 Michal Privoznik <mprivozn@redhat.com>
    
    Implement new virNodeAllocPages API
    
    
 2014- 9- 12 Michal Privoznik <mprivozn@redhat.com>
    
    generator: Free strings after libvirt_charPtrWrap
    https://bugzilla.redhat.com/show_bug.cgi?id=1140998
    
    Up till bb3301ba the wrapper was freeing the passed strings for us.
    However that changed after the commit. So now we don't free any
    strings which results in memory leaks as reported upstream [1]:
    
    ==14265== 2,407 bytes in 1 blocks are definitely lost in loss record 1,457 of 1,550
    ==14265==    at 0x4C2845D: malloc (in /usr/lib64/valgrind/vgpreload_memcheck-amd64-linux.so)
    ==14265==    by 0x5C46624: xdr_string (in /usr/lib64/libc-2.17.so)
    ==14265==    by 0xCFD9FCD: xdr_remote_nonnull_string (remote_protocol.c:31)
    ==14265==    by 0xCFDC2C8: xdr_remote_domain_get_xml_desc_ret (remote_protocol.c:1617)
    ==14265==    by 0xCFF0811: virNetMessageDecodePayload (virnetmessage.c:407)
    ==14265==    by 0xCFE68FB: virNetClientProgramCall (virnetclientprogram.c:379)
    ==14265==    by 0xCFBE8B1: callFull.isra.2 (remote_driver.c:6578)
    ==14265==    by 0xCFC7F04: remoteDomainGetXMLDesc (remote_driver.c:6600)
    ==14265==    by 0xCF8167C: virDomainGetXMLDesc (libvirt.c:4380)
    ==14265==    by 0xCC2C4DF: libvirt_virDomainGetXMLDesc (libvirt.c:1141)
    ==14265==    by 0x4F12B93: PyEval_EvalFrameEx (in /usr/lib64/libpython2.7.so.1.0)
    ==14265==    by 0x4F141AC: PyEval_EvalCodeEx (in /usr/lib64/libpython2.7.so.1.0)
    
    The python documentation clearly advise us to call free() [2]. From
    an example in their docs:
    
    PyObject *res;
    char *buf = (char *) malloc(BUFSIZ); /* for I/O */
    
    if (buf == NULL)
    return PyErr_NoMemory();
    ...Do some I/O operation involving buf...
    res = PyString_FromString(buf);
    free(buf); /* malloc'ed */
    return res;
    
    Moreover, instead of using VIR_FREE() (which we are not exporting),
    I'll just go with bare free().
    
    1: https://www.redhat.com/archives/libvir-list/2014-September/msg00736.html
    2: https://docs.python.org/2/c-api/memory.html
    
    
    
 2014- 9- 2 Peter Krempa <pkrempa@redhat.com>
    
    override: Fix two uninitialized variables in convertDomainStatsRecord
    py_record_domain and py_record_stats would be accessed uninitialized if
    an out-of-memory condition would happen in the first loop. Unlikely, but
    coverity complained.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1136354
    
    
 2014- 9- 2 Pavel Hrdina <phrdina@redhat.com>
    
    libvirt-override: fix some build warnings
    Remove unused label 'cleanup' in 'libvirt_virConnectGetAllDomainStats'
    function and remove unused variable 'conn' in function
    'libvirt_virDomainListGetStats'.
    
    
    
 2014- 9- 2 Michal Privoznik <mprivozn@redhat.com>
    
    Post-release version bump for new dev cycle
    
    
 2014- 9- 1 Pavel Hrdina <phrdina@redhat.com>
    
    Implement API bindings for virDomainBlockCopy
    
    
 2014- 9- 1 Pavel Hrdina <phrdina@redhat.com>
    
    API: Implement bindings for virDomainListGetStats
    Implement the function by returning a list of tuples instead the array
    of virDomainStatsRecords and store the typed parameters as dict.
    
    
    
 2014- 9- 1 Peter Krempa <pkrempa@redhat.com>
    
    API: Implement bindings for virConnectGetAllDomainStats
    Implement the function by returning a list of tuples instead the array
    of virDomainStatsRecords and store the typed parameters as dict.
    
    
    
 2014- 9- 1 Peter Krempa <pkrempa@redhat.com>
    
    API: Skip 'virDomainStatsRecordListFree'
    The new API function doesn't make sense to be exported in python. The
    bindings will return native types instead of the struct array.
    
    
    
 2014- 9- 1 Pavel Hrdina <phrdina@redhat.com>
    
    generator: resolve one level of enum reference
    In the libvirt.h we have one enum defined by references from another
    enum and it leads in wrong order of definitons in python code. To
    prevent this we should resolve that references before we generate the
    python code.
    
    For now we have only one level of references so we will count with that
    in the generator but we should update it in the future to be more
    flexible.
    
    
    
 2014- 8- 19 Mo Yuxiang <Moyuxiang@huawei.com>
    
    build: Fix build warning on libvirt-python
    On compiling libvirt-python, we get such a warning:
    
    libvirt-qemu-override.c: In function ‘libvirt_qemu_virConnectDomainQemuMonitorEventRegister’:
    libvirt-qemu-override.c:304: warning: suggest explicit braces to avoid ambiguous ‘else’
    
    Py_DECREF is a macro using if/else on older Python releases.
    The solution is to add braces.
    Python 2.7 and newer has the macro wrapped in a do { } while(0) block.
    
    
    
 2014- 8- 11 Zhou Yimin <zhouyimin@huawei.com>
    
    Fix libvirt_longlongWrap returning a very large value
    If hypervisor is not Xen, the errs in struct _virDomainBlockStats will be -1.
    But in KVM when we call domain.blockStats(), errs is 18446744073709551615.
    
    To fix that, this patch has two changes:
    1. Replace use of the PyLong_FromUnsignedLongLong with PyLong_FromLongLong
    in function libvirt_longlongWrap
    2. If the paramemter of libvirt_longlongWrap is unsigned long long,
    use libvirt_ulonglongWrap instead because of above change.
    
    After this patch, errs is -1 which is consistent with virDomainBlockStats api.
    
    
    
 2014- 8- 4 Eric Blake <eblake@redhat.com>
    
    maint: document use of libvirt's run script
    Ever since libvirt commit 78c09530, it's easier to just use the
    run script.
    
    * README: Mention run script.
    
    
    
 2014- 8- 4 Eric Blake <eblake@redhat.com>
    
    Bump version to 1.2.8 for new dev cycle
    
    
 2014- 7- 29 Jiri Denemark <Jiri.Denemark@gmail.com>
    
    spec: Reorganize to satisfy buggy spectool
    spectool parses a specfile and strips everything but a preamble.
    However, if the first section is preceded by %if clause, it keeps it
    there which then makes rpmbuild complain about unmatched %if. Let's make
    the buggy tool happy by moving sections around so that the first one is
    not in any conditional.
    
    
 2014- 7- 22 Martin Kletzander <mkletzan@redhat.com>
    
    Bump version to 1.2.7 for new dev cycle
    
    
 2014- 6- 27 Nehal J Wani <nehaljw.kkd1@gmail.com>
    
    Implement new virNetworkGetDHCPLeases API
    This API returns a list of DHCP leases for all network interfaces
    connected to the given virtual network or limited output just for one
    interface if mac is specified.
    
    Example Output:
    [{'iface': 'virbr3', 'ipaddr': '192.168.150.181', 'hostname': 'ubuntu14',
    'expirytime': 1403737495L, 'prefix': 24, 'clientid': None,
    'mac': '52:54:00:e8:73:eb', 'iaid': None, 'type': 0},
    {'iface': 'virbr3', 'ipaddr': '2001:db8:ca2:2:1::bd', 'hostname': 'fedora20-test',
    'expirytime': 1403738587L, 'prefix': 64, 'clientid': '00:04:b1:d8:86:42:e1:6a:aa:cf:d5:86:94:23:6f:94:04:cd',
    'mac': '52:54:00:5b:40:98', 'iaid': '5980312', 'type': 1}]
    
    
    
 2014- 6- 25 Eric Blake <eblake@redhat.com>
    
    maint: document development against uninstalled libvirt
    Thanks to Dan's recent work in libvirt.git, it is much easier to
    develop against uninstalled libvirt.  Mention how.
    
    * README: More details.
    
    
    
 2014- 6- 25 Nehal J Wani <nehaljw.kkd1@gmail.com>
    
    build: use correct int conversion in NodeGetFreePages
    Commit c8ba859bc7 introduced a compiler warning while un-wrapping
    a python object to uint in libvirt_virNodeGetFreePages.
    
    On compiling libvirt-python against libvirt 1.2.6, we get:
    
    libvirt-override.c: In function ‘libvirt_virNodeGetFreePages’:
    libvirt-override.c:7811:9: warning: pointer targets in passing argument 2 of ‘libvirt_intUnwrap’ differ in signedness [-Wpointer-sign]
    if (libvirt_intUnwrap(tmp, &pages[i]) < 0)
    ^
    In file included from libvirt-override.c:24:0:
    typewrappers.h:169:5: note: expected ‘int *’ but argument is of type ‘unsigned int *’
    int libvirt_intUnwrap(PyObject *obj, int *val);
    ^
    
    
    
 2014- 6- 20 Michal Privoznik <mprivozn@redhat.com>
    
    Implement new virNodeGetFreePages API
    The API expose information on host's free pages counts. For easier
    access, in python this API returns a dictionary such as:
    
    In [4]: conn.getFreePages([2048,1*1024*1024], -1, 5)
    Out[4]:
    {-1: {2048: 114, 1048576: 4},
    0: {2048: 3, 1048576: 1},
    1: {2048: 100, 1048576: 1},
    2: {2048: 10, 1048576: 1},
    3: {2048: 1, 1048576: 1}}
    
    At the top level of the returned dictionary there's a pair of <NUMA
    node> and another dictionary that contains detailed information on
    each supported page size. The information then consists of fairs of
    <page size> and <count of free pages>.
    
    
    
 2014- 6- 19 Jason Andryuk <andryuk@aero.org>
    
    Correct virDomainMigrateToURI3 definition
    dconnuri is a string, so update the definition to match.  Without this,
    the generated python would fail when passed a string.
    
    
 2014- 6- 18 Eric Blake <eblake@redhat.com>
    
    build: provide wrapper makefile
    After years of finger training, I'm so used to 'make check' just
    working, that I lose quite a bit of time re-learning that in this
    project, it is spelled 'python setup.py build check'.  A shim
    makefile bridges the gap.
    
    * Makefile: New file.
    
    
    
 2014- 6- 18 Eric Blake <eblake@redhat.com>
    
    event-test: add missing events
    Update the example to be able to trace all events.
    
    * examples/event-test.py (main): Match full list of domain events.
    (myDomainEventIOErrorReasonCallback)
    (myDomainEventControlErrorCallback)
    (myDomainEventBlockJobCallback, myDomainEventBlockJob2Callback)
    (blockJobTypeToString, blockJobStatusToString): New functions.
    
    
    
 2014- 6- 18 Eric Blake <eblake@redhat.com>
    
    blockjob: support new BLOCK_JOB_2 event
    Libvirt 1.2.6 is introducing a new block job event that passes disk
    information by target device rather than host file name.  At the
    python level, we are just a passthrough, so we can reuse all the
    existing code and just wire up the new enum value.
    
    * libvirt-override-virConnect.py
    (_dispatchDomainEventBlockPullCallback): Rename...
    (_dispatchDomainEventBlockJobCallback): ...to this, and make
    generic to both events.
    * libvirt-override.c
    (libvirt_virConnectDomainEventBlockJobCallback): Match naming.
    (libvirt_virConnectDomainEventRegisterAny): Allow new registration.
    
    
    
 2014- 6- 2 Martin Kletzander <mkletzan@redhat.com>
    
    Bump version to 1.2.6 for new dev cycle
    
    
 2014- 5- 27 Martin Kletzander <mkletzan@redhat.com>
    
    fix leak in memoryStats with older python
    libvirt_virDomainMemoryStats() function creates a dictionary without
    any checks whether the additions were successful, whether the python
    objects were created and, most importantly, without decrementing the
    reference count on the objects added to the dictionary.  This is
    somehow not an issue with current upstream versions, however with
    python 2.6 this exposes a leak in our bindings.  The following patch
    works on both old and new CPython versions and is already used in
    other parts of the code, so it's also most straightforward.
    
    Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1099860
    
    
    
 2014- 5- 20 Michal Privoznik <mprivozn@redhat.com>
    
    Implement virDomain{Get,Set}Time APIs
    While the setter can be generated automatically, the getter is not.
    However, it would be a lot easier if they both share the same logic:
    a python dictionary to represent the time: dict['seconds'] to
    represent seconds, and dict['nseconds'] to represent nanoseconds.
    
    
    
 2014- 5- 16 Tomoki Sekiyama <tomoki.sekiyama@hds.com>
    
    override: add virDomainFSFreeze and virDomainFSThaw API
    Add binding for the new virDomainFSFreeze and virDomainFSThaw functions
    added in libvirt 1.2.5. These require override since these take a list
    of mountpoints path string. The methods are named 'fsFreeze' and
    'fsThaw'.
    
    
    
 2014- 5- 5 Martin Kletzander <mkletzan@redhat.com>
    
    Bump version to 1.2.5 for new dev cycle
    
    
 2014- 4- 7 Laine Stump <laine@laine.org>
    
    build: add BuildRequires for python-lxml and python3-lxml
    python-lxml is likely always already present anyway (due to so many
    packages being dependent on it), but at least on my F20 system,
    python3-lxml wasn't installed, leading to a failure of "python
    setup.py rpm" without an informative error message.
    
    
 2014- 4- 7 Laine Stump <laine@laine.org>
    
    increment version post-release
    As is now done with libvirt. git head will always have the version
    number of the expected *next* release.
    
    
 2014- 4- 2 Daniel P. Berrange <berrange@redhat.com>
    
    Fix nosetests usage with python3
    Add RPM deps on python/python3-nose, make RPM build run the
    test suite and invoke nosetests using correct python binary
    
    
    
 2014- 3- 31 Brian Rak <brak@gameservers.com>
    
    Fix potential crash when setting partial cpu/memory/numa/interface limits on domains
    The number of parameters in new_params is not guaranteed to be the
    same as the number of parameters in params.  Use the correct count
    when freeing new_params to avoid crashes.
    
    
 2014- 3- 25 Cole Robinson <crobinso@redhat.com>
    
    setup.py: Allow running --help or clean without pkg-config
    If pkg-config isn't installed, or a too old libvirt, we can't even
    do 'python setup.py --help' without throwing an exception.
    
    Have the pkg-config checks and validation only throw an exception if
    being called from the 'build' step.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1074170
    
    
 2014- 3- 25 Cole Robinson <crobinso@redhat.com>
    
    setup.py: Make have_libvirt_lxc a function
    This means we call it twice for a build operation, but I don't think
    that's a big deal.
    
    
 2014- 3- 25 Cole Robinson <crobinso@redhat.com>
    
    setup.py: Move module list building to its own function
    Makes it a bit more clear what all that code is used for, rather than
    intermixing it with function definitions.
    
    Besides the comment additions, this is a no-op and just reindents the
    block, into a function.
    
    
 2014- 3- 25 Cole Robinson <crobinso@redhat.com>
    
    setup.py: Remove unused import
    
    
 2014- 3- 25 Eric Blake <eblake@redhat.com>
    
    qemu: support arbitrary monitor events
    Wrap the new virConnectDomainQemuMonitorEventRegister function
    added in libvirt 1.2.3.  This patch copies heavily from
    network events (commit 6ea5be0) and from event loop callbacks
    in libvirt-override.c, since in the libvirt_qemu module, we
    must expose top-level functions rather than class members.
    
    * generator.py (qemu_skip_function): Don't generate event code.
    (qemuBuildWrappers): Delay manual portion until after imports.
    * libvirt-qemu-override.py (qemuMonitorEventRegister)
    (qemuMonitorEventDeregister): New file.
    * libvirt-qemu-override.c
    (libvirt_qemu_virConnectDomainQemuMonitorEventFreeFunc)
    (libvirt_qemu_virConnectDomainQemuMonitorEventCallback)
    (libvirt_qemu_virConnectDomainQemuMonitorEventRegister)
    (libvirt_qemu_virConnectDomainQemuMonitorEventDeregister)
    (libvirt_qemu_lookupPythonFunc, getLibvirtQemuDictObject)
    (getLibvirtQemuModuleObject): New functions.
    
    
    
 2014- 3- 25 Eric Blake <eblake@redhat.com>
    
    event: fix domain reference bugs
    Noticed this bug while adding qemu monitor events; there's probably
    lots of other misuse of libvirt_virDomainPtrWrap, but for now I'm
    limiting the fix to all copied-and-pasted event callbacks, since
    I'm about to copy it again in the next patch.  While at it, check
    for failure to extract the "conn" key from the opaque callback
    struct, and hoist that check to occur before we reach the point
    where it is harder to undo on failure (the network code was the
    only code that had it in the right place, but then it failed to
    restore thread state on failure).
    
    The graphics callback is still not clean; but incremental
    improvements are better than nothing.
    
    * libvirt-override.c (libvirt_virConnectDomainEventCallback)
    (libvirt_virConnectDomainEvetnLifecycleCallback)
    (libvirt_virConnectDomainEventGenericCallback)
    (libvirt_virConnectDomainEventRTCChangeCallback)
    (libvirt_virConnectDomainEventWatchdogCallback)
    (libvirt_virConnectDomainEventIOErrorCallback)
    (libvirt_virConnectDomainEventIOErrorReasonCallback)
    (libvirt_virConnectDomainEventGraphicsCallback)
    (libvirt_virConnectDomainEventBlockJobCallback)
    (libvirt_virConnectDomainEventDiskChangeCallback)
    (libvirt_virConnectDomainEventTrayChangeCallback)
    (libvirt_virConnectDomainEventPMWakeupCallback)
    (libvirt_virConnectDomainEventPMSuspendCallback)
    (libvirt_virConnectDomainEventBalloonChangeCallback)
    (libvirt_virConnectDomainEventPMSuspendDiskCallback)
    (libvirt_virConnectDomainEventDeviceRemovedCallback): Don't pass
    NULL to PyObject_CallMethod.
    (libvirt_virConnectNetworkEventLifecycleCallback): Likewise, and
    don't corrupt thread state.
    
    
    
 2014- 3- 25 Martin Kletzander <mkletzan@redhat.com>
    
    generator: Add virConnectDomainQemuMonitorEventCallback to skipped_types
    
    
 2014- 3- 24 Eric Blake <eblake@redhat.com>
    
    maint: balance {} usage
    Emacs gets lost when finding function boundaries when #ifdef
    sections do not have balanced {}.
    
    * libvirt-override.c (libvirt_PyString_Check): New define.
    (virPyDictToTypedParams): Avoid unbalanced {} across ifdef.
    
    
    
 2014- 3- 24 Peter Krempa <pkrempa@redhat.com>
    
    maint: Add ctags configuration file and ignore the output
    Add the config file to ease creation of tags to help navigation in
    editors.
    
    
 2014- 3- 24 Eric Blake <eblake@redhat.com>
    
    maint: set up preferred emacs settings
    Copy the relevant settings from libvirt.git, so that emacs users
    maintain the style previously used before the two repos split.
    
    * .dir-locals.el: New file.
    
    
    
 2014- 3- 21 Eric Blake <eblake@redhat.com>
    
    maint: ignore .pyc files
    * .gitignore: Add exemption.
    
    
    
 2014- 3- 20 Cole Robinson <crobinso@redhat.com>
    
    override: Return NULL on python failure in getCPUModelNames
    Eric pointed this out on the last patch, but I pushed it before noticing
    his message.
    
    
 2014- 3- 20 Cole Robinson <crobinso@redhat.com>
    
    override: GetCPUModelNames should return None on failure
    Right now, on failure, libvirt.py doesn't raise an exception and just
    returns -1 to the user.
    
    
 2014- 3- 19 Daniel P. Berrange <berrange@redhat.com>
    
    Add test for setting scheduler parameters
    Add a test setting scheduler parameters to validate the
    previous bugfix to strncpy of field names.
    
    
    
 2014- 3- 19 Daniel P. Berrange <berrange@redhat.com>
    
    Add support for running unit tests with nose
    Make the 'python setup.py test' able to run unit tests
    found under tests/ through the 'nosetests' command
    
    
    
 2014- 3- 18 Michal Privoznik <mprivozn@redhat.com>
    
    setPyVirTypedParameter: free whole return variable on error
    The @ret value is built in a loop. However, if in one iteration
    there's an error, we should free all the fields built so far. For
    instance, if there's an error and the previous item was
    type of VIR_TYPED_PARAM_STRING we definitely must free it.
    
    
    
 2014- 3- 18 Michal Privoznik <mprivozn@redhat.com>
    
    setPyVirTypedParameter: Copy full field name
    In the setPyVirTypedParameter we try to produce virTypedParameter
    array from a python dictionary. However, when copying field name into
    item in returned array, we use strncpy() as the field name is fixed
    length array. To determine its size we use sizeof() but mistakenly
    dereference it resulting in sizeof(char) which equals to 1 byte.
    Moreover, there's no need for using sizeof() when we have a global
    macro to tell us the length of the field name:
    VIR_TYPED_PARAM_FIELD_LENGTH.
    
    And since array is allocated using VIR_ALLOC() we are sure the memory
    is initially filled with zeros. Hence, there's no need to terminate
    string we've just copied into field name with '\0' character. It's
    there for sure too as we copy up to field length - 1.
    
    
    
 2014- 3- 3 Daniel P. Berrange <berrange@redhat.com>
    
    Post release version bump to 1.2.3
    
    
 2014- 3- 2 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python 1.2.2
    
    
 2014- 2- 20 Martin Kletzander <mkletzan@redhat.com>
    
    generator: Skip exporting only sentinels
    When enum type has '_LAST' in its name, but is not the last type in
    that enum, it's skipped even though it shouldn't be.  Currently, this
    is the case for only VIR_NETWORK_UPDATE_COMMAND_ADD_LAST inside an
    enum virNetworkUpdateCommand.
    
    Also, since _LAST types can have other enums instead of values, that
    needs to be filtered out using a try-except when converting the value.
    
    
    
 2014- 2- 13 Philipp Hahn <hahn@univention.de>
    
    Fix stream related spelling mistakes
    Consistent spelling of all-uppercase I/O.
    
    
    
 2014- 2- 12 Eric Blake <eblake@redhat.com>
    
    examples: demonstrate network events
    Commit 6ea5be0 added network event callback support, so we might
    as well demonstrate that it works by updating our example.
    
    * examples/event-test.py: Add network event, fix typos.
    
    
    
 2014- 2- 4 Eric Blake <eblake@redhat.com>
    
    maint: ignore editor files
    * .gitignore: Exclude emacs cruft.
    
    
    
 2014- 2- 3 Eric Blake <eblake@redhat.com>
    
    Merge tag 'v1.2.1'
    Release of libvirt-python-1.2.1
    
    
 2014- 1- 23 Robie Basak <robie.basak@canonical.com>
    
    Fix calling of virStreamSend method
    Change d40861 removed the 'len' argument from the virStreamSend
    C level wrapper, but forgot to remove it from the python level
    wrapper.
    
    Reported-by: Robie Basak <robie.basak@canonical.com>
    
    
 2014- 1- 16 Daniel Veillard <veillard@redhat.com>
    
    Release of libvirt-python-1.2.1
    
    
 2014- 1- 11 Doug Goldstein <cardoe@cardoe.com>
    
    virStream.sendAll() fix raising an undeclared var
    The exception is raised from the variable 'e', which was undeclared in
    this context. Used code that is compatible with old and new Python
    versions.
    
    
 2014- 1- 2 Doug Goldstein <cardoe@cardoe.com>
    
    Add space after comma for consistency with code style
    
    
 2013- 12- 30 Doug Goldstein <cardoe@cardoe.com>
    
    define __GNUC_PREREQ macro before using it
    We brought over use of the __GNUC_PREREQ macro from libvirt but didn't
    bring over the definition of it. This brings over the macro from libvirt
    sources.
    
    
 2013- 12- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Rewrite libvirt_charPtrUnwrap to work with Python 3.0->3.2
    The PyUnicode_AsUTF8 method doesn't exist prior to Python 3.3.
    It is also somewhat inefficient, so rewrite it to use an
    intermediate PyBytes object.
    
    
    
 2013- 12- 12 Daniel P. Berrange <berrange@redhat.com>
    
    Add python3 to the automated build and RPM
    This updates autobuild.sh to test the python3 build process.
    The RPM specfile is changed to build a libvirt-python3 RPM
    on Fedora > 18
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    Skip network event callbacks in sanity test
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    Fix return type in override method for virStreamRecv
    The virStreamRecv override returns a PyObject not an int
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    sanitytest: remove use of string.lower()
    Call lower() directly on the string object instance, not
    the class
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    sanitytest: Fix broken comparison between int and string
    Python2 was forgiving of a comparison between an int and string
    but Python3 gets very upset.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Switch virStreamSend wrapper to use libvirt_charPtrSizeUnwrap
    Instead of using a 'z#i' format string to receive byte array,
    use 'O' and then libvirt_charPtrSizeUnwrap. This lets us hide
    the Python 3 vs 2 differences in typewrappers.c
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Conditionalize use of PyString_Check and PyInt_Check
    The PyString and PyInt classes are gone in Python 3, so we must
    conditionalize their use to be Python 2 only.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    typewrappers: PyInt/PyLong merge for Python3
    In Python3 the PyInt / PyLong types have merged into a single
    PyLong type. Conditionalize the use of PyInt to Python 2 only
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    typewrappers: Replace use of PyString class
    Replace use of PyString with either PyBytes or PyUnicode.
    The former is used for buffers with explicit sizes, which
    are used by APIs processing raw bytes.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Replace PyInt_AsLong with helper
    Replace use of the PyInt_AsLong libvirt_intUnwrap helper.
    This isolates the need for Python3 specific code in one
    place
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Replace Py{Int,Long}_FromLong with helpers
    Replace use of the PyInt_FromLong and PyLong_FromLongLong
    with libvirt_{int,uint,longlong,ulonglong}Wrap helpers.
    This isolates the need for Python3 specific code in one
    place.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Replace PyString_AsString with libvirt_charPtrUnwrap
    Replace calls to PyString_AsString with the helper method
    libvirt_charPtrUnwrap. This isolates the code that will
    change in Python3.
    
    In making this change, all callers now have responsibility
    for free'ing the string.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Replace PyString_FromString with libvirt_constcharPtrWrap
    Make use of libvirt_constcharPtrWrap in all override code,
    to match generated code. This will isolate Python3 specific
    changes in one place.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    sanitytest: Fix libvirtError class handling for Python 2.4
    The Exception class hiearchy in Python 2.4 reports different
    data types than in later Python versions. As a result the
    type(libvirt.libvirtError) does not return 'type'. We just
    special case handling of this class.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    override: Fix native module registration to work with Python3
    The way native modules are registered has completely
    changed, so the code must be #ifdef'd for Python2 & 3
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    examples: Ensure we write bytes to the self-pipe
    Strings in python3 default to unicode, so when writing to
    the self-pipe we must be sure to use bytes by calling the
    encode() method.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    examples: Invoke print("...") instead of print "..."
    The 'print' method must be called as a function in python3,
    ie with brackets.
    
    
    
 2013- 12- 11 Daniel P. Berrange <berrange@redhat.com>
    
    Don't free passed in args in libvirt_charPtrWrap / libvirt_charPtrSizeWrap
    Functions should not make assumptions about the memory management
    callers use for parameters
    
    
    
 2013- 12- 11 Cédric Bosdonnat <cbosdonnat@suse.com>
    
    Added python binding for the new network events API
    The new network events code requires manual binding code to
    be written.
    
    
    
 2013- 12- 9 Doug Goldstein <cardoe@cardoe.com>
    
    test: Invoke print("...") instead of print "..."
    The 'print' statement no longer exists in Python 3 and now must be
    called as a function. This is compatible down to Python 2.4 as we are
    not using any special syntax of the function.
    
    
 2013- 12- 9 Doug Goldstein <cardoe@cardoe.com>
    
    override: Fix exception handling syntax
    Python 3 no longer accepts 'except Exception, e:' as valid while Python
    2.4 does not accept the new syntax 'except Exception as e:' so this uses
    a fall back method that is compatible with both.
    
    
 2013- 12- 9 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Sort enums and functions when generating code
    To assist in diff comparisons between code generated with
    different versions of Python, do an explicit sort of all
    functions and enums.
    
    
    
 2013- 12- 9 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Remove use of string.replace and string.find functions
    Call the 'replace' and 'find' functions directly on the
    string variables, instead of via the 'string' module.
    Python3 only accepts the latter syntax
    
    
    
 2013- 12- 9 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Update to use sort() 'key' param
    The sort() method previously took either a comparator function
    or a key function. Only the latter is supported in Python3.
    
    
    
 2013- 12- 9 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Remove use of 'has_key' function
    The code 'XXX.has_key(YYYY)' must be changed to be of
    the form  'YYY in XXXX' which works in Python2 and 3
    
    As an added complication, if 'YYY in XXX' is used against
    an object overriding the '__getitem__' method it does not
    work in Python 2.4. Instead we must use 'YYY in XXX.keys()'
    
    
    
 2013- 12- 5 Doug Goldstein <cardoe@cardoe.com>
    
    Update exception catching in generated code
    Use a syntax for exception handling that works in both Python 2 and
    Python 3. The new syntax is 'except Exception as e:' but this does not
    work in older Pythons so we use the most compatible way by just catching
    the exception and getting the type and the exception value after the
    fact.
    
    
 2013- 12- 5 Doug Goldstein <cardoe@cardoe.com>
    
    generator: Support exceptions in Python 2 and 3
    Use a syntax for exception handling that works in both Python 2 and
    Python 3
    
    
 2013- 12- 5 Doug Goldstein <cardoe@cardoe.com>
    
    setup: Drop unused exception variable
    Drop the unused exception variable in setup.py. This has the benefit
    of dropping syntax that is not valid with Python 3.
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Cast iterators to a list() explicitly
    In python3 various methods list 'dict.keys()' do not
    return a list, so we must explicitly cast the result.
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    Revert "Optimize callback lookup in event handlers"
    This reverts commit 084729e26905f574b8c057cc4c732b1b6ce852d3.
    
    The PyImport_ImportModuleNoBlock method does not exist in
    python 2.4
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    Revert accidental change to exception handling syntax
    The previous commit changed the exception handling syntax to
    use 'as' instead of a ','. This doesn't work with python 2.4
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Invoke print("...") instead of print "..."
    The 'print' method must be called as a function in python3,
    ie with brackets.
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Remove string.lower(XXX) with XXX.lower()
    In python3 the string.lower() method doesn't exist, the
    lower() function can only be executed against a string
    variable directly. Python2 supported both approaches so
    this change is compatible
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    generator: Don't use 'list' as a variable name
    In python3 if we use 'list' as a variable name it causes it
    to hide the corresponding 'list()' function from the entire
    function that holds the variable.
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    Optimize callback lookup in event handlers
    The event handler code currently invokes PyImport_ImportModule
    which is very heavyweight. This is not in fact required, since
    we know the libvirt module has already been imported. We can
    thus use PyImport_ImportModuleNoBlock and do away with the
    global variables caching the imported module reference.
    
    
    
 2013- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    Fix use of virDomainEventRegister in python bindings
    If an app used the virDomainEventRegister binding instead
    of the virDomainEventRegisterAny binding, it would never
    have its callback invoked. This is because the code for
    dispatching from the C libvirt_virConnectDomainEventCallback
    method was totally fubar.
    
    If DEBUG macro was set in the python build the error would
    become visible
    
    "libvirt_virConnectDomainEventCallback dom_class is not a class!"
    
    The code in libvirt_virConnectDomainEventCallback was
    inexplicably complex and has apparently never worked. The
    fix is to write it the same way as the other callback handlers.
    
    
    
 2013- 12- 3 Doug Goldstein <cardoe@cardoe.com>
    
    setup: Use user requested python binary
    When setup.py is kicked off with a python interpreter other than the
    system 'python', (e.g. python2.7 setup.py build) the build process would
    switch to 'python' and not use python2.7 as requested by the user. We
    should always respect the user requested python interpreter and use it.
    
    
 2013- 11- 28 Daniel P. Berrange <berrange@redhat.com>
    
    Improve quality of sanitytest check
    Validate that every public API method is mapped into the python
    and that every python method has a sane C API.
    
    
    
 2013- 11- 28 Daniel P. Berrange <berrange@redhat.com>
    
    Skip copying manually written python for C APIs which don't exist
    If the libvirt-override-virXXXX.py file has methods which call
    C APIs that don't exist in the version of libvirt built against
    we need to skip copying their code.
    
    eg for 0.9.13 libvirt we should not copy the 'listAllDomains'
    method.
    
    The way this works is that it breaks the override file into
    individual methods by looking for ' def '. It then collects
    the contents until the next method start, whereupon it looks
    for a libvirtmod.XXXXXX API call. It checks if the XXXXX part
    is present in the XML description we have, and if not, it
    discards the entire method.
    
    
    
 2013- 11- 28 Daniel P. Berrange <berrange@redhat.com>
    
    Fix misc RPM specfile flaws
    Fix the RPM summary line, add placeholder %changelog tag,
    make %setup quiet, add Url: tag and filter out bogus
    provides and add example programs as docs.
    
    
    
 2013- 11- 28 Daniel P. Berrange <berrange@redhat.com>
    
    Fix code for avoiding overrides of non-existant functions
    When reading/writing a global variable from inside a method
    it must be declared as a global, otherwise a local variable
    by the same name will be used.
    
    Special case the virConnectListDomainsID method which is
    bizarrely renamed for no obvious reason.
    
    
    
 2013- 11- 28 Daniel P. Berrange <berrange@redhat.com>
    
    Deal with old filenames for events/error functions
    Older libvirt has files named 'events' and 'virterror'
    rather than 'virevent' and 'virerror'. This is visible
    in the API XML files. We must look for both names to
    ensure we don't lose generation of methods with older
    versions of libvirt.
    
    
    
 2013- 11- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Add missing binding of security model/label APIs
    The virNodeGetSecurityModel, virDomainGetSecurityLabel and
    virDomainGetSecurityLabelList methods were disabled in the
    python binding for inexplicable reasons.
    
    
    
 2013- 11- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Avoid generating the methods in multiple classes
    The python code generator tries to figure out what class a
    method should be in by looking at the list of arguments for
    any which are object types. Unfortunately missing break
    statements meant that methods which have multiple object
    arguments (eg migrate as a virDomainPtr followed by a
    virConnectPtr) got added to multiple classes.
    
    The following incorrect methods are removed by this change
    
    virStream.download       (dup of virStorageVol.download)
    virStream.screenshot     (dup of virDomain.screenshot)
    virStream.upload         (dup of virStorageVol.upload)
    virConnect.migrate       (dup of virDomain.migrate)
    virConnect.migrate2      (dup of virDomain.migrate2)
    virConnect.migrate3      (dup of virDomain.migrate3)
    virConnect.migrateToURI3 (dup of virDomain.migrateToURI3)
    
    
    
 2013- 11- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Make block pull event dispatcher private
    The method dispatchDomainEventBlockPullCallback which is
    used internally to dispatch block pull events to the python
    application code was missing the leading '_', to denote that
    it was private.  All other event callback helpers have a
    leading '_'. No application should have been using this so
    it is justifiable to rename it.
    
    
    
 2013- 11- 27 Daniel P. Berrange <berrange@redhat.com>
    
    Don't include virDomainSnapshotRef in python API
    The reference counting API is for internal use only. Attempts
    to use it from python application code will cause havoc.
    
    
    
 2013- 11- 26 Doug Goldstein <cardoe@cardoe.com>
    
    Call virGetLastError from mod rather than py wrapper
    All other code always calls the methods from the mod rather than using
    the python wrapper so this matches the state of all other callers.
    
    
 2013- 11- 26 Don Dugger <donald.d.dugger@intel.com>
    
    Return right error code for baselineCPU
    This Python interface code is returning a -1 on errors for the
    `baselineCPU' API.  Since this API is supposed to return a pointer
    the error return value should really be VIR_PY_NONE.
    
    
    
 2013- 11- 26 Martin Kletzander <mkletzan@redhat.com>
    
    Make setup.py executable
    
    
 2013- 11- 26 Daniel P. Berrange <berrange@redhat.com>
    
    Update README file contents and add HACKING file
    The previous README file from the python code is more like a
    HACKING file. Rename it and update the content. Then add a
    basic README file
    
    
    
 2013- 11- 25 Eric Blake <eblake@redhat.com>
    
    maint: next release is 1.2.0
    No other hits for:
    git grep '1\.1\.5'
    
    * libvirt-utils.h: Fix comment.
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Ensure API overrides only used if API exists
    Entries in the -overrides.xml files should only be recorded
    if the API also exists in the main API XML file.
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Relax min required libvirt to version 0.9.11
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virConnectGetCPUModelNames API appeared in 1.1.3
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED appeared in 1.1.1
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainCreateXMLWithFiles and virDomainCreateWithFiles APIs appeared in 1.1.1
    virDomainCreateXMLWithFiles() and virDomainCreateWithFiles() were not
    added to libvirt until 1.1.1
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainMigrate3 and virDomainMigrateToURI3 appeared in 1.1.0
    The functions virDomainMigrate3 and virDomainMigrateToURI3 were not
    added to libvirt until v1.1.0.
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virTypedParams* API appeared in 1.0.2 and used in 1.1.0
    When building against versions of libvirt prior to 1.0.2, we can not
    provide wrappers for virTypedParams* APIs. In addition we don't need
    to have the helper APIs until 1.1.0 when the first API we wrap starts
    to use them.
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainMigrateGetCompressionCache API appeared in 1.0.3
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainGetJobStats API appeared in 1.0.3
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virNodeGetCPUMap API appeared in 1.0.0
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    VIR_DOMAIN_EVENT_ID_PMSUSPEND_DISK appeared in 1.0.0
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virStoragePoolListAllVolumes API appeared in 0.10.2
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virNode{Get,Set}MemoryParameters API appeared in 0.10.2
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virConnectListAll* APIs appeared in 0.10.2
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    virDomainQemuAgentCommand appeared in 0.10.0
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainPinEmulator and virDomainGetEmulatorPinInfo APIs appeared in 0.10.0
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    VIR_DOMAIN_EVENT_ID_BALLOON_CHANGED appeared in 0.10.0
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virConnect{Unr,R}egisterCloseCallback API appeared in 0.10.0
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainSnapshotListAllChildren API appeared in 0.9.13
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virConnectListAllDomains API appeared in 0.9.13
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    virDomainListAllSnapshots API appeared in 0.9.13
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    Don't build LXC module when building less than 1.0.2
    The functions that the LXC module wraps did not appear until 1.0.2 so we
    can't build the module unless we're building against 1.0.2 or newer.
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    Create array of modules to be built
    Create an array of modules to be built to allow for flexibility to
    enable or disable some modules in the future and allow for additional
    modules to be added easily
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    Break generator.py to be called per module
    Since we don't always want to build all the modules, and there might be
    more modules added in the future but we want to retain backwards
    compatibility with older libvirts, change generator.py to be called once
    per module instead of with all modules at once.
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Setup distutils build system
    Create a setup.py for building libvirt python code and add
    supporting files
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Add execute permission for sanitytest.py
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Add build/ to python module path for sanitytest.py
    The generated libvirt.py modules will be in the build/
    directory, so santitytest.py must use that directory.
    
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    Import some virTypedParams* APIs from libvirt
    virTypedParamsClear() and virTypedParamsFree() were introduced in
    libvirt 1.0.2. In an effort to keep the code clean bring these two
    functions to libvirt-python if we're building against a version of
    libvirt that's older than 1.0.2
    
    
 2013- 11- 22 Doug Goldstein <cardoe@cardoe.com>
    
    Import LIBVIR_CHECK_VERSION macro from libvirt
    Add LIBVIR_CHECK_VERSION from libvirt upstream so that we can check the
    version of the library we are compiling against and support a range of
    libvirt versions. The macro was added to libvirt in 1.2.0 so we must
    provide it if its not defined.
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Import VIR_FORCE_CLOSE macro from libvirt
    Import the macro for safely closing file descriptors
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Remove use of virStrcpyStatic
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Import VIR_ALLOC / VIR_ALLOC_N / VIR_REALLOC_N functions
    Import the libvirt memory allocation functions, stripping the OOM
    testing and error reporting pieces.
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Import code annotation macros from libvirt
    Import ATTRIBUTE_RETURN_CHECK, ATTRIBUTE_UNUSED &
    ATTRIBUTE_NONNULL macros
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Import gnulib's ignore_value macro
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Import gnulib's xalloc_oversized macro
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Add decl of MIN macro
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Import STREQ macro from libvirt
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Update header file includes
    We're no longer using automake, so <config.h> files are not
    required. Also remove of all libvirt internal util header
    files. Reference generated header files in build/ subdir.
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Update generator for new code layout
    Change the generator.py to
    
    - Take XML API file names on command line
    - Generate data in build/ directory instead of cwd
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Remove obsolete Makefile.am
    We are no longer using automake, so Makefile.am is obsolete
    
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Move python example programs into python/examples/ subdirectory
    
    
 2013- 11- 22 Daniel P. Berrange <berrange@redhat.com>
    
    Mostly revert "python: remove virConnectGetCPUModelNames from globals"
    This reverts commit 6b90d7428d72e92db292a9228c44701bfd5003c9.
    
    The original problem was that libvirt_virConnectGetCPUModelNames
    was listed twice in the exports table, once automatically from
    the generator and once from the manual override. We merely needed
    to list it in the skip_impl list, and not delete the manually
    written code entirely.
    
    
 2013- 11- 21 Doug Goldstein <cardoe@cardoe.com>
    
    python: remove virConnectGetCPUModelNames from globals
    Commit de51dc9c9aed0e615c8b301cccb89f4859324eb0 primarily added
    virConnectGetCPUModelNames as libvirt.getCPUModelNames(conn, arch)
    instead of libvirt.virConnect.getCPUModelNames(arch) so revert the code
    that does the former while leaving the code that does the later.
    
    This is the rest of the patch that was ACK'd by Dan but I committed only
    the partial patch in 6a8b8ae.
    
    
 2013- 11- 21 Doug Goldstein <cardoe@cardoe.com>
    
    python: remove virConnectGetCPUModelNames from globals
    Commit de51dc9c9aed0e615c8b301cccb89f4859324eb0 primarily added
    virConnectGetCPUModelNames as libvirt.getCPUModelNames(conn, arch)
    instead of libvirt.virConnect.getCPUModelNames(arch) so revert the code
    that does the former while leaving the code that does the later.
    
    
 2013- 11- 20 Eric Blake <eblake@redhat.com>
    
    maint: fix comma style issues: python
    Most of our code base uses space after comma but not before;
    fix the remaining uses before adding a syntax check.
    
    * python/libvirt-override.c: Consistently use commas.
    
    
    
 2013- 11- 19 Doug Goldstein <cardoe@cardoe.com>
    
    Add missing break to switch-case block
    The case label for VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED did not have its
    own break statement but relied on falling through which we probably
    don't want.
    
    
 2013- 10- 22 Marian Neagul <marian@info.uvt.ro>
    
    python: Fix Create*WithFiles filefd passing
    Commit d76227be added functions virDomainCreateWithFiles and
    virDomainCreateXMLWithFiles, but there was a little piece missing in
    python bindings.  This patch fixes proper passing of file descriptors
    in the overwrites of these functions.
    
    
 2013- 10- 21 Daniel P. Berrange <berrange@redhat.com>
    
    Don't link virt-login-shell against libvirt.so (CVE-2013-4400)
    The libvirt.so library has far too many library deps to allow
    linking against it from setuid programs. Those libraries can
    do stuff in __attribute__((constructor) functions which is
    not setuid safe.
    
    The virt-login-shell needs to link directly against individual
    files that it uses, with all library deps turned off except
    for libxml2 and libselinux.
    
    Create a libvirt-setuid-rpc-client.la library which is linked
    to by virt-login-shell. A config-post.h file allows this library
    to disable all external deps except libselinux and libxml2.
    
    
    
 2013- 10- 14 Eric Blake <eblake@redhat.com>
    
    maint: avoid 'const fooPtr' in python bindings
    'const fooPtr' is the same as 'foo * const' (the pointer won't
    change, but it's contents can).  But in general, if an interface
    is trying to be const-correct, it should be using 'const foo *'
    (the pointer is to data that can't be changed).
    
    Fix up offenders in the python bindings.
    
    * python/generator.py (py_types): Drop useless conversions.
    * python/libvirt-override.c (getPyVirTypedParameter)
    (setPyVirTypedParameter): Use intended type.
    
    
    
 2013- 9- 30 Michal Privoznik <mprivozn@redhat.com>
    
    python: Document virNodeGetInfo bug
    The memory size in virNodeGetInfo python API binding is reported in MiB
    instead of KiB (like we have in C struct). However, there already might
    be applications out there relying on this inconsistence so we can't
    simply fix it. Document this sad fact as known bug.
    
    
 2013- 9- 23 Giuseppe Scrivano <gscrivan@redhat.com>
    
    python: add bindings for virConnectGetCPUModelNames
    
    
 2013- 9- 23 Giuseppe Scrivano <gscrivan@redhat.com>
    
    libvirt: add new public API virConnectGetCPUModelNames
    The new function virConnectGetCPUModelNames allows to retrieve the list
    of CPU models known by the hypervisor for a specific architecture.
    
    
    
 2013- 9- 20 Daniel P. Berrange <berrange@redhat.com>
    
    Fix potential use of uninitialized value in virDomainGetVcpuPinInfo
    The virDomainGetVcpuPinInfo python wrapper had a potential use of
    uninitialized values
    
    
    
 2013- 9- 10 Oskari Saarenmaa <os@ohmu.fi>
    
    docs, comments: minor typo fixes
    
    
 2013- 9- 4 Eric Blake <eblake@redhat.com>
    
    build: enforce makefile conditional style
    Automake has builtin support to prevent botched conditional nesting,
    but only if you use:
    if FOO
    else !FOO
    endif !FOO
    
    An example error message when using the wrong name:
    
    daemon/Makefile.am:378: error: else reminder (LIBVIRT_INIT_SCRIPT_SYSTEMD_TRUE) incompatible with current conditional: LIBVIRT_INIT_SCRIPT_SYSTEMD_FALSE
    daemon/Makefile.am:381: error: endif reminder (LIBVIRT_INIT_SCRIPT_SYSTEMD_TRUE) incompatible with current conditional: LIBVIRT_INIT_SCRIPT_SYSTEMD_FALSE
    
    As our makefiles tend to have quite a bit of nested conditionals,
    it's better to take advantage of the benefits of the build system
    double-checking that our conditionals are well-nested, but that
    requires a syntax check to enforce our usage style.
    
    Alas, unlike C preprocessor and spec files, we can't use indentation
    to make it easier to see how deeply nesting goes.
    
    * cfg.mk (sc_makefile_conditionals): New rule.
    * daemon/Makefile.am: Enforce the style.
    * gnulib/tests/Makefile.am: Likewise.
    * python/Makefile.am: Likewise.
    * src/Makefile.am: Likewise.
    * tests/Makefile.am: Likewise.
    * tools/Makefile.am: Likewise.
    
    
    
 2013- 9- 3 Ján Tomko <jtomko@redhat.com>
    
    Fix leaks in python bindings
    https://bugzilla.redhat.com/show_bug.cgi?id=1003828
    
    
 2013- 8- 29 Guan Qiang <hzguanqiang@corp.netease.com>
    
    python: Fix a PyList usage mistake
    Fix PyList usage mistake in Function libvirt_lxc_virDomainLxcOpenNamespace.
    
    https://bugzilla.redhat.com/show_bug.cgi?id=1002383
    
    
    
 2013- 8- 23 Claudio Bley <cbley@av-test.de>
    
    python: simplify complicated conditional assignment
    
    
 2013- 8- 23 Claudio Bley <cbley@av-test.de>
    
    Test for object identity when checking for None in Python
    Consistently use "is" or "is not" to compare variables to None,
    because doing so is preferrable, as per PEP 8
    (http://www.python.org/dev/peps/pep-0008/#programming-recommendations):
    
    > Comparisons to singletons like None should always be done with is or
    > is not, never the equality operators.
    
    
 2013- 8- 22 Guido Günther <agx@sigxcpu.org>
    
    python: Use RELRO_LDFLAGS and NO_INDIRECT_LDFLAGS
    A readonly GOT and detecting indirect linkage is useful here too.
    
    
 2013- 7- 30 Daniel P. Berrange <berrange@redhat.com>
    
    Delete obsolete / unused python test files
    The python/tests directory contains a number of so called
    "tests" for the python API. These are all hardcoded to
    look for Xen and cannot be run in any automated fashion,
    and no one is ever manually running them. Given that they
    don't meaningully contribute to the test coverage, delete
    them.
    
    For some reason these tests were also copied into the
    filesystem as part of 'make install'. The change to the
    RPM in commit 3347a4203278ec93d7b0ceb88b5ed10e4f14765c
    caused a build failure, since it removed the code which
    deleted these installed tests.
    
    
    
 2013- 7- 29 Cole Robinson <crobinso@redhat.com>
    
    python: Drop TODO
    File hasn't been really touched for 7 years. And with recent rawhide
    changes it contributed to an RPM build failure. Let's drop it.
    
    This also removes installation of a libvirt-python doc dir, so drop
    handling of it from the RPM spec.
    
    
 2013- 7- 19 Eric Blake <eblake@redhat.com>
    
    maint: split long lines in Makefiles
    Makefiles are another easy file to enforce line limits.
    
    Mostly straightforward; interesting tricks worth noting:
    src/Makefile.am: $(confdir) was already defined, use it in more places
    tests/Makefile.am: path_add and VG required some interesting compression
    
    * cfg.mk (sc_prohibit_long_lines): Add another test.
    * Makefile.am: Fix offenders.
    * daemon/Makefile.am: Likewise.
    * docs/Makefile.am: Likewise.
    * python/Makefile.am: Likewise.
    * src/Makefile.am: Likewise.
    * tests/Makefile.am: Likewise.
    
    
    
 2013- 7- 18 Jiri Denemark <jdenemar@redhat.com>
    
    Add VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED event
    
    
 2013- 7- 18 Daniel P. Berrange <berrange@redhat.com>
    
    Introduce new domain create APIs to pass pre-opened FDs to LXC
    With container based virt, it is useful to be able to pass
    pre-opened file descriptors to the container init process.
    This allows for containers to be auto-activated from incoming
    socket connections, passing the active socket into the container.
    
    To do this, introduce a pair of new APIs, virDomainCreateXMLWithFiles
    and virDomainCreateWithFiles, which accept an array of file
    descriptors. For the LXC driver, UNIX file descriptor passing
    will be used to send them to libvirtd, which will them pass
    them down to libvirt_lxc, which will then pass them to the container
    init process.
    
    This will only be implemented for LXC right now, but the design
    is generic enough it could work with other hypervisors, hence
    I suggest adding this to libvirt.so, rather than libvirt-lxc.so
    
    
    
 2013- 7- 15 Guannan Ren <gren@redhat.com>
    
    python: return dictionary without value in case of no blockjob
    Currently, when there is no blockjob, dom.blockJobInfo('vda')
    still reports error because it doesn't distinguish return value 0 from -1.
    libvirt.libvirtError: virDomainGetBlockJobInfo() failed
    
    virDomainGetBlockJobInfo() API return value:
    -1 in case of failure, 0 when nothing found, 1 found.
    
    And use PyDict_SetItemString instead of PyDict_SetItem when key is
    of string type. PyDict_SetItemString increments key/value reference
    count, so call Py_DECREF() for value. For key, we don't need to
    do this, because PyDict_SetItemString will handle it internally.
    
    
 2013- 7- 10 Daniel P. Berrange <berrange@redhat.com>
    
    Convert 'int i' to 'size_t i' in python/ files
    Convert the type of loop iterators named 'i', 'j', k',
    'ii', 'jj', 'kk', to be 'size_t' instead of 'int' or
    'unsigned int', also santizing 'ii', 'jj', 'kk' to use
    the normal 'i', 'j', 'k' naming
    
    
    
 2013- 7- 10 Michal Privoznik <mprivozn@redhat.com>
    
    viralloc: Report OOM error on failure
    Similarly to VIR_STRDUP, we want the OOM error to be reported in
    VIR_ALLOC and friends.
    
    
 2013- 6- 24 Jiri Denemark <jdenemar@redhat.com>
    
    python: Add bindings for extensible migration APIs
    The patch implements wrappers for virDomainMigrate3 and
    virDomainMigrateToURI3.
    
    
 2013- 6- 24 Jiri Denemark <jdenemar@redhat.com>
    
    Extensible migration APIs
    This patch introduces two new APIs virDomainMigrate3 and
    virDomainMigrateToURI3 that may be used in place of their older
    variants. These new APIs take optional migration parameters (such as
    bandwidth, domain XML, ...) in an array of virTypedParameters, which
    makes adding new parameters easier as there's no need to introduce new
    APIs whenever a new migration parameter needs to be added. Both APIs are
    backward compatible and will automatically use older migration calls in
    case the new calls are not supported as long as the typed parameters
    array does not contain any parameter which was not supported by the
    older calls.
    
    
 2013- 5- 28 Eric Blake <eblake@redhat.com>
    
    syntax: prefer space after semicolon in for loop
    I noticed several unusual spacings in for loops, and decided to
    fix them up.  See the next commit for the syntax check that found
    all of these.
    
    * examples/domsuspend/suspend.c (main): Fix spacing.
    * python/libvirt-override.c: Likewise.
    * src/conf/interface_conf.c: Likewise.
    * src/security/virt-aa-helper.c: Likewise.
    * src/util/virconf.c: Likewise.
    * src/util/virhook.c: Likewise.
    * src/util/virlog.c: Likewise.
    * src/util/virsocketaddr.c: Likewise.
    * src/util/virsysinfo.c: Likewise.
    * src/util/viruuid.c: Likewise.
    * src/vbox/vbox_tmpl.c: Likewise.
    * src/xen/xen_hypervisor.c: Likewise.
    * tools/virsh-domain-monitor.c (vshDomainStateToString): Drop
    default case, to let compiler check us.
    * tools/virsh-domain.c (vshDomainVcpuStateToString): Likewise.
    
    
    
 2013- 5- 21 Osier Yang <jyang@redhat.com>
    
    python: Remove the whitespace before ";"
    
    
 2013- 5- 20 Eric Blake <eblake@redhat.com>
    
    maint: use LGPL correctly
    Several files called out COPYING or COPYING.LIB instead of using
    the normal boilerplate.  It's especially important that we don't
    call out COPYING from an LGPL file, since COPYING is traditionally
    used for the GPL.  A few files were lacking copyright altogether.
    
    * src/rpc/gendispatch.pl: Add missing copyright.
    * Makefile.nonreentrant: Likewise.
    * src/check-symfile.pl: Likewise.
    * src/check-symsorting.pl: Likewise.
    * src/driver.h: Likewise.
    * src/internal.h: Likewise.
    * tools/libvirt-guests.sh.in: Likewise.
    * tools/virt-pki-validate.in: Mention copyright in comment, not just code.
    * tools/virt-sanlock-cleanup.in: Likewise.
    * src/rpc/genprotocol.pl: Spell out license terms.
    * src/xen/xend_internal.h: Likewise.
    * src/xen/xend_internal.c: Likewise.
    * Makefile.am: Likewise.
    * daemon/Makefile.am: Likewise.
    * docs/Makefile.am: Likewise.
    * docs/schemas/Makefile.am: Likewise.
    * examples/apparmor/Makefile.am: Likewise.
    * examples/domain-events/events-c/Makefile.am: Likewise.
    * examples/dominfo/Makefile.am: Likewise.
    * examples/domsuspend/Makefile.am: Likewise.
    * examples/hellolibvirt/Makefile.am: Likewise.
    * examples/openauth/Makefile.am: Likewise.
    * examples/python/Makefile.am: Likewise.
    * examples/systemtap/Makefile.am: Likewise.
    * examples/xml/nwfilter/Makefile.am: Likewise.
    * gnulib/lib/Makefile.am: Likewise.
    * gnulib/tests/Makefile.am: Likewise.
    * include/Makefile.am: Likewise.
    * include/libvirt/Makefile.am: Likewise.
    * python/Makefile.am: Likewise.
    * python/tests/Makefile.am: Likewise.
    * src/Makefile.am: Likewise.
    * tests/Makefile.am: Likewise.
    * tools/Makefile.am: Likewise.
    * configure.ac: Likewise.
    
    
    
 2013- 5- 9 Daniel P. Berrange <berrange@redhat.com>
    
    Fix build of python bindings on Python 2.4
    The PyDict_Next method on Python <= 2.4 used 'int' instead
    of "Py_ssize_t" for the 'pos' parameter
    
    
    
 2013- 5- 6 Eric Blake <eblake@redhat.com>
    
    build: clean up stray files found by 'make distcheck'
    'make distcheck' complained:
    
    ERROR: files left in build directory after distclean:
    ./python/libvirt.pyc
    ./tests/commandhelper.log
    
    Problems introduced in commits f015495 and 25ea8e4 (both v1.0.3).
    
    * tests/commandtest.c (test21): Check (and clean) log file.
    * tests/commanddata/test21.log: New file.
    * python/Makefile.am (CLEANFILES): Clean up compiled python files.
    
    
    
 2013- 5- 2 Eric Blake <eblake@redhat.com>
    
    build: always include sanitytest in tarball
    The libvirt 1.0.5 tarball is missing a file which renders 'make
    check' broken; first reported on list by Guido Günther.
    
    * python/Makefile.am (EXTRA_DIST): Hoist sanitytest.py out of
    HAVE_PYTHON conditional.
    
    
    
 2013- 5- 2 Michal Privoznik <mprivozn@redhat.com>
    
    virutil: Move string related functions to virstring.c
    The source code base needs to be adapted as well. Some files
    include virutil.h just for the string related functions (here,
    the include is substituted to match the new file), some include
    virutil.h without any need (here, the include is removed), and
    some require both.
    
    
 2013- 4- 19 Eric Blake <eblake@redhat.com>
    
    docs: fix usage of 'onto'
    http://www.uhv.edu/ac/newsletters/writing/grammartip2009.07.01.htm
    (and several other sites) give hints that 'onto' is best used if
    you can also add 'up' just before it and still make sense. In many
    cases in the code base, we really want the two-word form, or even
    a simplification to just 'on' or 'to'.
    
    * docs/hacking.html.in: Use correct 'on to'.
    * python/libvirt-override.c: Likewise.
    * src/lxc/lxc_controller.c: Likewise.
    * src/util/virpci.c: Likewise.
    * daemon/THREADS.txt: Use simpler 'on'.
    * docs/formatdomain.html.in: Better usage.
    * docs/internals/rpc.html.in: Likewise.
    * src/conf/domain_event.c: Likewise.
    * src/rpc/virnetclient.c: Likewise.
    * tests/qemumonitortestutils.c: Likewise.
    * HACKING: Regenerate.
    
    
    
 2013- 4- 18 Osier Yang <jyang@redhat.com>
    
    syntax-check: Only allows to include public headers in external tools
    With this patch, include public headers in "" form is only allowed
    for "internal.h". And only the external tools (examples|tools|python
    |include/libvirt) can include the public headers in <> form.
    
    
 2013- 3- 26 Guannan Ren <gren@redhat.com>
    
    python: set default value to optional arguments
    When prefixing with string (optional) or optional in the description
    of arguments to libvirt C APIs, in python, these arguments will be
    set as optional arugments, for example:
    
    * virDomainSaveFlags:
    * @domain: a domain object
    * @to: path for the output file
    * @dxml: (optional) XML config for adjusting guest xml used on restore
    * @flags: bitwise-OR of virDomainSaveRestoreFlags
    
    the corresponding python APIs is
    restoreFlags(self, frm, dxml=None, flags=0)
    
    The following python APIs are changed to:
    blockCommit(self, disk, base, top, bandwidth=0, flags=0)
    blockPull(self, disk, bandwidth=0, flags=0)
    blockRebase(self, disk, base, bandwidth=0, flags=0)
    migrate(self, dconn, flags=0, dname=None, uri=None, bandwidth=0)
    migrate2(self, dconn, dxml=None, flags=0, dname=None, uri=None, bandwidth=0)
    migrateToURI(self, duri, flags=0, dname=None, bandwidth=0)
    migrateToURI2(self, dconnuri=None, miguri=None, dxml=None, flags=0, \
    dname=None, bandwidth=0)
    saveFlags(self, to, dxml=None, flags=0)
    migrate(self, domain, flags=0, dname=None, uri=None, bandwidth=0)
    migrate2(self, domain, dxml=None, flags=0, dname=None, uri=None, bandwidth=0)
    restoreFlags(self, frm, dxml=None, flags=0)
    
    
 2013- 3- 22 Guannan Ren <gren@redhat.com>
    
    python:remove semicolon in python code
    This breaked "make syntax-check" testing
    
    Pushed under trivial rule
    
    
 2013- 3- 22 Guannan Ren <gren@redhat.com>
    
    make: regenerate bindings when <classname>.py changes
    
    
 2013- 3- 22 Guannan Ren <gren@redhat.com>
    
    python: treat flags as default argument with value 0
    The following four functions have not changed because default arguments
    have to come after positional arguments. Changing them will break the
    the binding APIs.
    
    migrate(self, dconn, flags, dname, uri, bandwidth):
    migrate2(self, dconn, dxml, flags, dname, uri, bandwidth):
    migrateToURI(self, duri, flags, dname, bandwidth):
    migrateToURI2(self, dconnuri, miguri, dxml, flags, dname, bandwidth):
    
    
 2013- 3- 21 Peter Krempa <pkrempa@redhat.com>
    
    python: Fix emulatorpin API bindings
    The addition of emulator pinning APIs didn't think of doing the right
    job with python APIs for them. The default generator produced unusable
    code for this.
    
    This patch switches to proper code as in the case of domain Vcpu pining.
    This change can be classified as a python API-breaker but in the state
    the code was before I doubt anyone was able to use it successfully.
    
    
 2013- 3- 21 Guannan Ren <gren@redhat.com>
    
    python: fix bindings that don't raise an exception
    For example:
    >>> dom.memoryStats()
    libvir: QEMU Driver error : Requested operation is not valid:\
    domain is not running
    
    There are six such python API functions like so.
    The root reason is that generator.py script checks the type of return
    value of a python stub function defined in libvirt-api.xml or
    libvirt-override-api.xml to see whether to add the raise clause or not
    in python wrapper code in libvirt.py.
    
    The type of return value is supposed to be C types.
    For those stub functions which return python non-integer data type like
    string, list, tuple, dictionary, the existing type in functions varies
    from each other which leads problem like this.
    
    Currently, in generator.py, it maintains a buggy whitelist for stub functions
    returning a list type. I think it is easy to forget adding new function name
    in the whitelist.
    
    This patch makes the value of type consistent with C type "char *"
    in libvirt-override-api.xml. For python, any of types could be printed
    as string, so I choose "char *" in this case. And the comment in xml
    could explain it when adding new function definition.
    
    <function name='virNodeGetCPUStats' file='python'>
    ...
    -      <return type='virNodeCPUStats' info='...'/>
    +      <return type='char *' info='...'/>
    ...
    </function>
    
    
 2013- 3- 13 Daniel P. Berrange <berrange@redhat.com>
    
    Apply security label when entering LXC namespaces
    Add a new virDomainLxcEnterSecurityLabel() function as a
    counterpart to virDomainLxcEnterNamespaces(), which can
    change the current calling process to have a new security
    context. This call runs client side, not in libvirtd
    so we can't use the security driver infrastructure.
    
    When entering a namespace, the process spawned from virsh
    will default to running with the security label of virsh.
    The actual desired behaviour is to run with the security
    label of the container most of the time. So this changes
    virsh lxc-enter-namespace command to invoke the
    virDomainLxcEnterSecurityLabel method.
    
    The current behaviour is:
    
    LABEL                             PID TTY          TIME CMD
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 1 pts/0 00:00:00 systemd
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 3 pts/1 00:00:00 sh
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 24 ? 00:00:00 systemd-journal
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 29 ? 00:00:00 dhclient
    staff_u:unconfined_r:unconfined_t:s0-s0:c0.c1023 47 ? 00:00:00 ps
    
    Note the ps command is running as unconfined_t,  After this patch,
    
    The new behaviour is this:
    
    virsh -c lxc:/// lxc-enter-namespace dan -- /bin/ps -eZ
    LABEL                             PID TTY          TIME CMD
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 1 pts/0 00:00:00 systemd
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 3 pts/1 00:00:00 sh
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 24 ? 00:00:00 systemd-journal
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 32 ? 00:00:00 dhclient
    system_u:system_r:svirt_lxc_net_t:s0:c0.c1023 38 ? 00:00:00 ps
    
    The '--noseclabel' flag can be used to skip security labelling.
    
    
    
 2013- 3- 1 Guannan Ren <gren@redhat.com>
    
    python: fix fd leak in generator.py
    
    
 2013- 3- 1 Guannan Ren <gren@redhat.com>
    
    python: fix typoes and repeated global vars references
    
    
 2013- 2- 22 Jiri Denemark <jdenemar@redhat.com>
    
    python: Implement virDomainMigrateGetCompressionCache wrapper
    
    
 2013- 2- 22 Jiri Denemark <jdenemar@redhat.com>
    
    Introduce virDomainMigrate*CompressionCache APIs
    Introduce virDomainMigrateGetCompressionCache and
    virDomainMigrateSetCompressionCache APIs.
    
    
 2013- 2- 22 Jiri Denemark <jdenemar@redhat.com>
    
    python: Implement virDomainGetJobStats wrapper
    
    
 2013- 2- 22 Jiri Denemark <jdenemar@redhat.com>
    
    Introduce virDomainGetJobStats API
    This is an extensible version of virDomainGetJobInfo.
    
    
 2013- 2- 11 Guido Günther <agx@sigxcpu.org>
    
    Check if classes are derived from object
    This makes sure we don't regress to old style classes
    
    
 2013- 2- 7 Guido Günther <agx@sigxcpu.org>
    
    Remove more trailing semicolons in Python files
    
    
 2013- 2- 7 Guido Günther <agx@sigxcpu.org>
    
    Cosmetics: Remove semicolons
    It's Python, not C
    
    
 2013- 2- 5 Jiri Denemark <jdenemar@redhat.com>
    
    sanitytest.py: Do not rely on system libvirt
    When running sanitytest.py we should not rely on libvirt library
    installed on the system. And since we generate a nice wrapper called
    "run" that sets both PYTHON_PATH and LD_LIBRARY_PATH, we should just use
    it rather than trying to duplicate it in the Makefile.
    
    
 2013- 2- 5 Daniel P. Berrange <berrange@redhat.com>
    
    Fix missing error constants in libvirt python module
    The previous change to the generator, changed too much - only
    the functions are in 'virerror.c', the constants remained in
    'virerror.h' which could not be renamed for API compat reasons.
    
    Add a test case to sanity check the generated python bindings
    
    
    
 2013- 1- 31 Serge Hallyn <serge.hallyn@canonical.com>
    
    complete virterror->virerror name change
    Without these two string changes in generator.py, the
    virGetLastError wrapper does not get created in
    /usr/share/pyshared/libvirt.py.  Noticed when running
    tests with virt-install.
    
    
    
 2013- 1- 24 Jiri Denemark <jdenemar@redhat.com>
    
    python: Fix bindings for virDomainSnapshotGet{Domain,Connect}
    https://bugzilla.redhat.com/show_bug.cgi?id=895882
    
    virDomainSnapshot.getDomain() and virDomainSnapshot.getConnect()
    wrappers around virDomainSnapshotGet{Domain,Connect} were not supposed
    to be ever implemented. The class should contain proper domain() and
    connect() accessors that fetch python objects stored internally within
    the class. While domain() was already provided, connect() was missing.
    
    This patch adds connect() method to virDomainSnapshot class and
    reimplements getDomain() and getConnect() methods as aliases to domain()
    and connect() for backward compatibility.
    
    
 2013- 1- 24 Daniel P. Berrange <berrange@redhat.com>
    
    Make python objects inherit from 'object' base class
    As of python >= 2.2, it is recommended that all objects inherit
    from the 'object' base class. We already require python >= 2.3
    for libvirt for thread macro support, so we should follow this
    best practice.
    
    See also
    
    http://stackoverflow.com/questions/4015417/python-class-inherits-object
    
    
    
 2013- 1- 18 Jiri Denemark <jdenemar@redhat.com>
    
    Introduce virTypedParamsClear public API
    The function is just a renamed public version of former
    virTypedParameterArrayClear.
    
    
 2013- 1- 18 Jiri Denemark <jdenemar@redhat.com>
    
    Add virTypedParams* APIs
    Working with virTypedParameters in clients written in C is ugly and
    requires all clients to duplicate the same code. This set of APIs makes
    this code for manipulating with virTypedParameters integral part of
    libvirt so that all clients may benefit from it.
    
    
 2013- 1- 17 Jiri Denemark <jdenemar@redhat.com>
    
    python: Avoid freeing uninitialized new_params pointer
    
    
 2013- 1- 14 Daniel P. Berrange <berrange@redhat.com>
    
    Fix build due to previous LXC patch
    Mark virDomainLxcEnterNamespace as skipped in python binding
    and remove reference to lxcDomainOpenNamespace which doesn't
    arrive until a later patch
    
    
 2013- 1- 14 Daniel P. Berrange <berrange@redhat.com>
    
    Introduce an LXC specific public API & library
    This patch introduces support for LXC specific public APIs. In
    common with what was done for QEMU, this creates a libvirt_lxc.so
    library and libvirt/libvirt-lxc.h header file.
    
    The actual APIs are
    
    int virDomainLxcOpenNamespace(virDomainPtr domain,
    int **fdlist,
    unsigned int flags);
    
    int virDomainLxcEnterNamespace(virDomainPtr domain,
    unsigned int nfdlist,
    int *fdlist,
    unsigned int *noldfdlist,
    int **oldfdlist,
    unsigned int flags);
    
    which provide a way to use the setns() system call to move the
    calling process into the container's namespace. It is not
    practical to write in a generically applicable manner. The
    nearest that we could get to such an API would be an API which
    allows to pass a command + argv to be executed inside a
    container. Even if we had such a generic API, this LXC specific
    API is still useful, because it allows the caller to maintain
    the current process context, in particular any I/O streams they
    have open.
    
    NB the virDomainLxcEnterNamespace() API is special in that it
    runs client side, so does not involve the internal driver API.
    
    
    
 2012- 12- 28 Michal Privoznik <mprivozn@redhat.com>
    
    python: Adapt to virevent rename
    With our recent renames under src/util/* we forgot to adapt
    python wrapper code generator. This results in some methods being
    not exposed:
    
    $ python examples/domain-events/events-python/event-test.py
    Using uri:qemu:///system
    Traceback (most recent call last):
    File "examples/domain-events/events-python/event-test.py", line 585, in <module>
    main()
    File "examples/domain-events/events-python/event-test.py", line 543, in main
    virEventLoopPureStart()
    File "examples/domain-events/events-python/event-test.py", line 416, in virEventLoopPureStart
    virEventLoopPureRegister()
    File "examples/domain-events/events-python/event-test.py", line 397, in virEventLoopPureRegister
    libvirt.virEventRegisterImpl(virEventAddHandleImpl,
    AttributeError: 'module' object has no attribute 'virEventRegisterImpl'
    
    
 2012- 12- 21 Daniel P. Berrange <berrange@redhat.com>
    
    Rename util.{c,h} to virutil.{c,h}
    
    
 2012- 12- 21 Daniel P. Berrange <berrange@redhat.com>
    
    Rename memory.{c,h} to viralloc.{c,h}
    
    
 2012- 12- 4 Osier Yang <jyang@redhat.com>
    
    Fix the indention
    Introduced by commit 1465876a, pushed under build-breaker &&
    trivial rule.
    
    
 2012- 12- 4 Daniel P. Berrange <berrange@redhat.com>
    
    Bind connection close callback APIs to python binding
    Add code in the python binding to cope with the new APIs
    virConnectRegisterCloseCallback and
    virConnectUnregisterCloseCallback. Also demonstrate their
    use in the python domain events demo
    
    
    
 2012- 11- 15 Viktor Mihajlovski <mihajlov@linux.vnet.ibm.com>
    
    python: Use virNodeGetCPUMap where possible
    Modified the places where virNodeGetInfo was used for the purpose
    of obtaining the maximum node CPU number. Transparently falling
    back to virNodeGetInfo in case of failure.
    Wrote a utility function getPyNodeCPUCount for that purpose.
    
    
    
 2012- 11- 2 Daniel P. Berrange <berrange@redhat.com>
    
    Remove spurious whitespace between function name & open brackets
    The libvirt coding standard is to use 'function(...args...)'
    instead of 'function (...args...)'. A non-trivial number of
    places did not follow this rule and are fixed in this patch.
    
    
    
 2012- 10- 25 Eric Blake <eblake@redhat.com>
    
    maint: consistent whitespace after 'if'
    Noticed during the review of the previous patch.
    
    * python/libvirt-override.c: Use space between 'if ('.
    
    
 2012- 10- 25 Viktor Mihajlovski <mihajlov@linux.vnet.ibm.com>
    
    virNodeGetCPUMap: Add python binding
    Added a method getCPUMap to virConnect.
    It can be used as follows:
    
    import libvirt
    import sys
    import os
    
    conn = libvirt.openReadOnly(None)
    if conn == None:
    print 'Failed to open connection to the hypervisor'
    sys.exit(1)
    
    try:
    (cpus, cpumap, online) = conn.getCPUMap(0)
    except:
    print 'Failed to extract the node cpu map information'
    sys.exit(1)
    
    print 'CPUs total %d, online %d' % (cpus, online)
    print 'CPU map %s' % str(cpumap)
    
    del conn
    print "OK"
    
    sys.exit(0)
    
    
    
 2012- 10- 24 Viktor Mihajlovski <mihajlov@linux.vnet.ibm.com>
    
    virNodeGetCPUMap: Define public API.
    Adding a new API to obtain information about the
    host node's present, online and offline CPUs.
    
    int virNodeGetCPUMap(virConnectPtr conn,
    unsigned char **cpumap,
    unsigned int *online,
    unsigned int flags);
    
    The function will return the number of CPUs present on the host
    or -1 on failure;
    If cpumap is non-NULL virNodeGetCPUMap will allocate an array
    containing a bit map representation of the online CPUs. It's
    the callers responsibility to deallocate cpumap using free().
    If online is non-NULL, the variable pointed to will contain
    the number of online host node CPUs.
    The variable flags has been added to support future extensions
    and must be set to 0.
    
    Extend the driver structure by nodeGetCPUMap entry in support of the
    new API virNodeGetCPUMap.
    Added implementation of virNodeGetCPUMap to libvirt.c
    
    
    
 2012- 10- 15 Martin Kletzander <mkletzan@redhat.com>
    
    Add support for SUSPEND_DISK event
    This patch adds support for SUSPEND_DISK event; both lifecycle and
    separated.  The support is added for QEMU, machines are changed to
    PMSUSPENDED, but as QEMU sends SHUTDOWN afterwards, the state changes
    to shut-off.  This and much more needs to be done in order for libvirt
    to work with transient devices, wake-ups etc.  This patch is not
    aiming for that functionality.
    
    
 2012- 10- 13 Guido Günther <agx@sigxcpu.org>
    
    Properly parse (unsigned) long long
    This fixes problems on platforms where sizeof(long) != sizeof(long long)
    like ia32.
    
    
 2012- 10- 8 Guannan Ren <gren@redhat.com>
    
    python: keep consistent handling of Python integer conversion
    libvirt_ulonglongUnwrap requires the integer type of python obj.
    But libvirt_longlongUnwrap still could handle python obj of
    Pyfloat_type which causes the float value to be rounded up
    to an integer.
    
    For example
    >>> dom.setSchedulerParameters({'vcpu_quota': 0.88})
    0
    libvirt_longlongUnwrap treats 0.88 as a valid value 0
    
    However
    >>> dom.setSchedulerParameters({'cpu_shares': 1000.22})
    libvirt_ulonglongUnwrap will throw out an error
    "TypeError: an integer is required"
    
    The patch make this consistent.
    
    
 2012- 10- 8 Guannan Ren <gren@redhat.com>
    
    python: cleanup vcpu related binding APIs
    libvirt_virDomainGetVcpus: add error handling, return -1 instead of None
    libvirt_virDomainPinVcpu and libvirt_virDomainPinVcpuFlags:
    check the type of argument
    make use of libvirt_boolUnwrap
    
    Set bitmap according to these values which are contained in given
    argument of vcpu tuple and turn off these bit corresponding to
    missing vcpus in argument tuple
    
    The original way ignored the error info from PyTuple_GetItem
    if index is out of range.
    "IndexError: tuple index out of range"
    The error message will only be raised on next command in interactive mode.
    
    
 2012- 9- 28 Guannan Ren <gren@redhat.com>
    
    python: return error if PyObject obj is NULL for unwrapper helper functions
    The result is indeterminate for NULL argument to python
    functions as follows. It's better to return negative value in
    these situations.
    
    PyObject_IsTrue will segfault if the argument is NULL
    PyFloat_AsDouble(NULL) is -1.000000
    PyLong_AsUnsignedLongLong(NULL) is 0.000000
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    node_memory: Expose the APIs to Python bindings
    * python/libvirt-override-api.xml: (Add document to describe
    the APIs).
    * python/libvirt-override.c: (Implement the API wrappers manually)
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    node_memory: Define the APIs to get/set memory parameters
    * include/libvirt/libvirt.h.in: (Add macros for the param fields,
    declare the APIs).
    * src/driver.h: (New methods for the driver struct)
    * src/libvirt.c: (Implement the public APIs)
    * src/libvirt_public.syms: (Export the public symbols)
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    list: Expose virConnectListAllSecrets to Python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    
    python/libvirt-override-virConnect.py: Implementation for listAllSecrets.
    
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    list: Define new API virConnectListAllSecrets
    This is to list the secret objects. Supports to filter the secrets
    by its storage location, and whether it's private or not.
    
    include/libvirt/libvirt.h.in: Declare enum virConnectListAllSecretFlags
    and virConnectListAllSecrets.
    python/generator.py: Skip auto-generating
    src/driver.h: (virDrvConnectListAllSecrets)
    src/libvirt.c: Implement the public API
    src/libvirt_public.syms: Export the symbol to public
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    list: Expose virConnectListAllNWFilters to Python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    
    python/libvirt-override-virConnect.py:
    * Implementation for listAllNWFilters.
    
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    list: Define new API virConnectListAllNWFilters
    This is to list the network filter objects. No flags are supported
    
    include/libvirt/libvirt.h.in: Declare enum virConnectListAllNWFilterFlags
    and virConnectListAllNWFilters.
    python/generator.py: Skip auto-generating
    src/driver.h: (virDrvConnectListAllNWFilters)
    src/libvirt.c: Implement the public API
    src/libvirt_public.syms: Export the symbol to public
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    list: Expose virConnectListAllNodeDevices to Python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    
    python/libvirt-override-virConnect.py:
    * Implementation for listAllNodeDevices.
    
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 17 Osier Yang <jyang@redhat.com>
    
    list: Define new API virConnectListAllNodeDevices
    This is to list the node device objects, supports to filter the results
    by capability types.
    
    include/libvirt/libvirt.h.in: Declare enum virConnectListAllNodeDeviceFlags
    and virConnectListAllNodeDevices.
    python/generator.py: Skip auto-generating
    src/driver.h: (virDrvConnectListAllNodeDevices)
    src/libvirt.c: Implement the public API
    src/libvirt_public.syms: Export the symbol to public
    
    
 2012- 9- 12 Osier Yang <jyang@redhat.com>
    
    list: Expose virConnectListAllInterfaces to Python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    
    python/libvirt-override-virConnect.py:
    * New file, includes implementation of listAllInterfaces.
    
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 12 Osier Yang <jyang@redhat.com>
    
    list: Define new API virConnectListAllInterfaces
    This is to list the interface objects, supported filtering flags
    are: active|inactive.
    
    include/libvirt/libvirt.h.in: Declare enum virConnectListAllInterfaceFlags
    and virConnectListAllInterfaces.
    python/generator.py: Skip auto-generating
    src/driver.h: (virDrvConnectListAllInterfaces)
    src/libvirt.c: Implement the public API
    src/libvirt_public.syms: Export the symbol to public
    
    
 2012- 9- 11 Federico Simoncelli <fsimonce@redhat.com>
    
    python: Initialize new_params in virDomainSetSchedulerParameters
    The new_params variable must be initialized in case the
    virDomainGetSchedulerParameters call fails and we hit the cleanup
    section before actually allocating the new parameters.
    
    
    
 2012- 9- 11 Daniel P. Berrange <berrange@redhat.com>
    
    Check against python None type when filling in auth parameters
    When deciding whether to provide an auth function callback
    in openAuth(), credcb was checked against NULL, when it
    really needs to be checked against Py_None
    
    
    
 2012- 9- 11 Daniel P. Berrange <berrange@redhat.com>
    
    Print any exception that occurs in authentication callback
    If an exception occurs in the python callback for openAuth()
    the stack trace isn't seen by the apps, since this code is
    called from libvirt context. To aid diagnostics, print the
    error to stderr at least
    
    
    
 2012- 9- 11 Daniel P. Berrange <berrange@redhat.com>
    
    Fix crash passing an empty list to python openAuth() API
    If passing a 'credtype' parameter which was an empty list
    to the python openAuth() API, the 'credtype' field in
    the virConnectAuth struct would not be initialized. This
    lead to a crash when later trying to free that field.
    
    
    
 2012- 9- 11 Osier Yang <jyang@redhat.com>
    
    list: Expose virConnectListAllNetworks to Python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    
    python/libvirt-override-virConnect.py: Implement listAllNetworks.
    
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 11 Osier Yang <jyang@redhat.com>
    
    list: Define new API virConnectListAllNetworks
    This is to list the network objects, supported filtering flags
    are: active|inactive, persistent|transient, autostart|no-autostart.
    
    include/libvirt/libvirt.h.in: Declare enum virConnectListAllNetworkFlags
    and virConnectListAllNetworks.
    python/generator.py: Skip auto-generating
    src/driver.h: (virDrvConnectListAllNetworks)
    src/libvirt.c: Implement the public API
    src/libvirt_public.syms: Export the symbol to public
    
    
 2012- 9- 10 Osier Yang <jyang@redhat.com>
    
    list: Expose virStoragePoolListAllVolumes to Python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    
    python/libvirt-override-virStoragePool.py:
    * New file, includes implementation of listAllVolumes.
    
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 10 Osier Yang <jyang@redhat.com>
    
    list: Define new API virStoragePoolListAllVolumes
    Simply returns the storage volume objects. No supported filter
    flags.
    
    include/libvirt/libvirt.h.in: Declare the API
    python/generator.py: Skip the function for generating. virStoragePool.py
    will be added in later patch.
    src/driver.h: virDrvStoragePoolListVolumesFlags
    src/libvirt.c: Implementation for the API.
    src/libvirt_public.syms: Export the symbol to public
    
    
 2012- 9- 7 Jiri Denemark <jdenemar@redhat.com>
    
    Fix PMSuspend and PMWakeup events
    The unused reason parameter of PM{Suspend,Wakeup} event callbacks was
    completely ignored in lot of places and those events were not actually
    working at all.
    
    
 2012- 9- 6 Osier Yang <jyang@redhat.com>
    
    python: Expose virStorageListAllStoragePools to python binding
    The implementation is done manually as the generator does not support
    wrapping lists of C pointers into Python objects.
    
    python/libvirt-override-api.xml: Document
    python/libvirt-override-virConnect.py: Add listAllStoragePools
    python/libvirt-override.c: Implementation for the wrapper.
    
    
 2012- 9- 6 Osier Yang <jyang@redhat.com>
    
    list: Define new API virStorageListAllStoragePools
    This introduces a new API to list the storage pool objects,
    4 groups of flags are provided to filter the returned pools:
    
    * Active or not
    
    * Autostarting or not
    
    * Persistent or not
    
    * And the pool type.
    
    include/libvirt/libvirt.h.in: New enum virConnectListAllStoragePoolFlags;
    Declare the API.
    python/generator.py: Skip the generating
    src/driver.h: (virDrvConnectListAllStoragePools)
    src/libvirt.c: Implementation for the API.
    src/libvirt_public.syms: Export the symbol.
    
    
 2012- 8- 31 Eric Blake <eblake@redhat.com>
    
    python: don't mask libvirt errors
    A user reported this crash when using python bindings:
    
    File "/home/nox/workspace/NOX/src/NOX/hooks.py", line 134, in trigger
    hook.trigger(event)
    File "/home/nox/workspace/NOX/src/NOX/hooks.py", line 33, in trigger
    self.handlers[event]()
    File "/home/nox/workspace/NOX/hooks/volatility.py", line 81, in memory_dump
    for block in Memory(self.ctx):
    File "/home/see/workspace/NOX/src/NOX/lib/libtools.py", line 179, in next
    libvirt.VIR_MEMORY_PHYSICAL)
    File "/usr/lib/python2.7/dist-packages/libvirt.py", line 1759, in memoryPeek
    ret = libvirtmod.virDomainMemoryPeek(self._o, start, size, flags)
    SystemError: error return without exception set
    
    In the python bindings, returning NULL makes python think an
    exception was thrown, while returning the None object lets the
    wrappers know that a libvirt error exists.
    
    Reported by Nox DaFox, fix suggested by Dan Berrange.
    
    * python/libvirt-override.c (libvirt_virDomainBlockPeek)
    (libvirt_virDomainMemoryPeek): Return python's None object, so
    wrapper knows to check libvirt error.
    
    
 2012- 8- 23 MATSUDA Daiki <matsudadik@intellilink.co.jp>
    
    agent: add python module support
    Add virDomainQemuAgentCommand() support function to python module.
    
    
    
 2012- 8- 23 MATSUDA Daiki <matsudadik@intellilink.co.jp>
    
    agent: add virDrvDomainQemuAgentCommand prototype for drivers.
    Add virDrvDomainQemuAgentCommand prototype for drivers.
    Add virDomainQemuAgentCommand() for virDrvDomainQemuAgentCommand.
    
    
    
 2012- 8- 20 Marcelo Cerri <mhcerri@linux.vnet.ibm.com>
    
    Update the remote API
    This patch updates libvirt's API to allow applications to inspect the
    full list of security labels of a domain.
    
    
    
 2012- 7- 30 Peter Krempa <pkrempa@redhat.com>
    
    python: Don't generate bodies for close callback functions
    Commit 6ed5a1b9bd6240b8f2736790e48dd1c284c2e0e1 adds close callback
    functions to the public API but doesn't add python implementation. This
    patch sets the function to be written manually (to fix the build), but
    doesn't implement them yet.
    
    
 2012- 7- 14 Daniel P. Berrange <berrange@redhat.com>
    
    Define public API for receiving guest memory balloon events
    When the guest changes its memory balloon applications may want
    to know what the new value is, without having to periodically
    poll on XML / domain info. Introduce a "balloon change" event
    to let apps see this
    
    * include/libvirt/libvirt.h.in: Define the
    virConnectDomainEventBalloonChangeCallback callback
    and VIR_DOMAIN_EVENT_ID_BALLOON_CHANGE constant
    * python/libvirt-override-virConnect.py,
    python/libvirt-override.c: Wire up helpers for new event
    * daemon/remote.c: Helper for serializing balloon event
    * examples/domain-events/events-c/event-test.c,
    examples/domain-events/events-python/event-test.py: Add
    example of balloon event usage
    * src/conf/domain_event.c, src/conf/domain_event.h: Handling
    of balloon events
    * src/remote/remote_driver.c: Add handler of balloon events
    * src/remote/remote_protocol.x: Define wire protocol for
    balloon events
    * src/remote_protocol-structs: Likewise.
    
    
 2012- 6- 19 Eric Blake <eblake@redhat.com>
    
    list: provide python bindings for snapshots
    This adds support for the new virDomainListAllSnapshots (a domain
    function) and virDomainSnapshotListAllChildren (a snapshot function)
    to the libvirt-python bindings.  The implementation is done manually
    as the generator does not support wrapping lists of C pointers into
    python objects.
    
    * python/libvirt-override.c (libvirt_virDomainListAllSnapshots)
    (libvirt_virDomainSnapshotListAllChildren): New functions.
    * python/libvirt-override-api.xml: Document them.
    * python/libvirt-override-virDomain.py (listAllSnapshots): New
    file.
    * python/libvirt-override-virDomainSnapshot.py (listAllChildren):
    Likewise.
    * python/Makefile.am (CLASSES_EXTRA): Ship them.
    
    
 2012- 6- 19 Eric Blake <eblake@redhat.com>
    
    list: add virDomainListAllSnapshots API
    There was an inherent race between virDomainSnapshotNum() and
    virDomainSnapshotListNames(), where an additional snapshot could
    be created in the meantime, or where a snapshot could be deleted
    before converting the name back to a virDomainSnapshotPtr.  It
    was also an awkward name: the function operates on domains, not
    domain snapshots.  virDomainSnapshotListChildrenNames() suffered
    from the same inherent race, although its naming was nicer.
    
    This patch makes things nicer by grabbing a snapshot list
    atomically, in the format most useful to the user.
    
    * include/libvirt/libvirt.h.in (virDomainListAllSnapshots)
    (virDomainSnapshotListAllChildren): New declarations.
    * src/libvirt.c (virDomainSnapshotListNames)
    (virDomainSnapshotListChildrenNames): Add cross-references.
    (virDomainListAllSnapshots, virDomainSnapshotListAllChildren):
    New functions.
    * src/libvirt_public.syms (LIBVIRT_0.9.13): Export them.
    * src/driver.h (virDrvDomainListAllSnapshots)
    (virDrvDomainSnapshotListAllChildren): New callbacks.
    * python/generator.py (skip_function): Prepare for later
    hand-written versions.
    
    
 2012- 6- 18 Peter Krempa <pkrempa@redhat.com>
    
    python: add API exports for virConnectListAllDomains()
    This patch adds export of the new API function
    virConnectListAllDomains() to the libvirt-python bindings. The
    virConnect object now has method "listAllDomains" that takes only the
    flags parameter and returns a python list of virDomain object
    corresponding to virDomainPtrs returned by the underlying api.
    
    The implementation is done manually as the generator does not support
    wrapping list of virDomainPtrs into virDomain objects.
    
    
 2012- 6- 18 Peter Krempa <pkrempa@redhat.com>
    
    lib: Add public api to enable atomic listing of guest
    This patch adds a new public api that lists domains. The new approach is
    different from those used before. There are key points to this:
    
